#! perl -w
#
# !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
#
# This file is generated automatically from 'src/ops/core.ops'.
# Any changes made here will be lost!
#

=head1 NAME

Parrot::OpLib::core - Parrot Op Info

=head1 DESCRIPTION

This is an autogenerated file, created by F<tools/build/ops2pm.pl>.

It contains Parrot version info, a preamble for inclusion in C code,
and an array of C<Parrot::Op> instances representing the Parrot ops.

=cut


use strict;

package Parrot::OpLib::core;

use vars qw($VERSION $ops $preamble);

$VERSION = "2.1.1";

$preamble = '

#include "parrot/dynext.h"
#include "parrot/embed.h"
#include "parrot/runcore_api.h"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_parrotlibrary.h"



 /* Signed shift operator that is compatible with PMC shifts.  This is
  * guaranteed to produce the same result as bitwise_left_shift_internal modulo
  * word size, ignoring the fact that Parrot integers are always signed.  This
  * usually gives the same answer regardless whether you shift PMC operands and
  * then assign to an I-reg, or move the operands to I-regs and do the shift
  * there -- except when the true result is between 2^{w-1} and 2^w (where w is
  * the word size), in which case the high order bit is taken as the sign,
  * giving a truncated result that is 2^w lower.
  */
#define bit_shift_left(number, bits) \\
    ((bits) >= 8*INTVAL_SIZE     ? 0                    \\
     : (bits) >= 0               ? (number) << (bits)   \\
     : (bits) > -8*INTVAL_SIZE   ? (number) >> -(bits)   \\
     : 0)






#include "../io/io_private.h"







';
$ops = [
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'end',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'check_event' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 0,
                  'ARGS' => [],
                  'BODY' => '#line 55 "src/ops/core.ops"
    {{=0}};
',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'noop',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 1,
                  'ARGS' => [],
                  'BODY' => '#line 109 "src/ops/core.ops"

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'cpu_ret',
                  'FLAGS' => {},
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 2,
                  'ARGS' => [],
                  'BODY' => '#line 112 "src/ops/core.ops"
    /* We only want to call __asm__("ret") if we\'re in the JIT core. Otherwise
       we want to throw an error. Seriously people: Do not use this opcode
       directly in PIR. Ever. It absolutely makes no sense and it doesn\'t do
       anything productive. You\'ve been warned. */
   if (PARROT_RUNCORE_JIT_OPS_TEST(interp->run_core)) {
#ifdef __GNUC__
#  ifdef I386
        __asm__("ret");
#  endif
#endif
    }
    else {
        opcode_t * const handler= Parrot_ex_throw_from_op_args(interp,
            NULL, EXCEPTION_INVALID_OPERATION,
            "cpu_ret: May not use this opcode from PIR source");
        {{=handler}};
    }

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'check_events',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 3,
                  'ARGS' => [],
                  'BODY' => '#line 132 "src/ops/core.ops"
    opcode_t *next = {{^+1}};
    Parrot_cx_check_tasks(interp, interp->scheduler);
    {{=next}};   /* force this being a branch op */
',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'check_events__',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'internal' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 4,
                  'ARGS' => [],
                  'BODY' => '#line 138 "src/ops/core.ops"
    opcode_t *_this = CUR_OPCODE;
    /* Restore op_func_table. */
    disable_event_checking(interp);
    Parrot_cx_handle_tasks(interp, interp->scheduler);
    {{=_this}};   /* force this being a branch op */
',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'wrapper__',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'internal' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 5,
                  'ARGS' => [],
                  'BODY' => '#line 146 "src/ops/core.ops"
    opcode_t *pc = CUR_OPCODE;
    DO_OP(pc, interp);
    {{=pc}};
',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'prederef__',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'internal' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 6,
                  'ARGS' => [],
                  'BODY' => '#line 152 "src/ops/core.ops"
    opcode_t * const _this = CUR_OPCODE;
    if (PARROT_RUNCORE_CGOTO_OPS_TEST(interp->run_core)) {
        /* must be CGP then - check for events in not yet prederefed code */
        Parrot_cx_runloop_wake(interp, interp->scheduler);
    /*    _this = CHECK_EVENTS(interp, _this); */
    }
    do_prederef((void**)cur_opcode, interp, interp->run_core);
    {{=_this}}; /* force this being a branch op */
',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'reserved',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 7,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 163 "src/ops/core.ops"
    /* reserve 1 entries */

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'load_bytecode',
                  'FLAGS' => {
                               'load_file' => undef,
                               '' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 8,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 167 "src/ops/core.ops"
    Parrot_load_bytecode(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'load_bytecode',
                  'FLAGS' => $ops->[8]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 9,
                  'ARGS' => [
                              'sc'
                            ],
                  'BODY' => '#line 167 "src/ops/core.ops"
    Parrot_load_bytecode(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'load_language',
                  'FLAGS' => {
                               'load_file' => undef,
                               '' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 10,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 178 "src/ops/core.ops"
    Parrot_load_language(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'load_language',
                  'FLAGS' => $ops->[10]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 11,
                  'ARGS' => [
                              'sc'
                            ],
                  'BODY' => '#line 178 "src/ops/core.ops"
    Parrot_load_language(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE|PARROT_JUMP_GNEXT',
                  'NAME' => 'branch',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'base_loop' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 12,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 204 "src/ops/core.ops"
    {{+={{@1}}}};
',
                  'LABELS' => [
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'branch',
                  'FLAGS' => $ops->[12]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 13,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 204 "src/ops/core.ops"
    {{+={{@1}}}};
',
                  'LABELS' => [
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_RELATIVE|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'local_branch',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'check_event' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 14,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 218 "src/ops/core.ops"
    INTVAL return_addr;
    opcode_t *dest = {{^+3}};

    if (PMC_IS_NULL({{@1}}) || {{@1}}->vtable->base_type != enum_class_ResizableIntegerArray) {
        opcode_t * handler = Parrot_ex_throw_from_op_args(interp, dest,
            EXCEPTION_INVALID_OPERATION,
            "Must pass a valid integer array to \'local_branch\'");
        {{=handler}};
    }

    return_addr = PTR2INTVAL(dest);
    VTABLE_push_integer(interp, {{@1}}, return_addr);

    {{+={{@2}}}};
',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_RELATIVE|PARROT_JUMP_ENEXT',
                  'NAME' => 'local_branch',
                  'FLAGS' => $ops->[14]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 15,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 218 "src/ops/core.ops"
    INTVAL return_addr;
    opcode_t *dest = {{^+3}};

    if (PMC_IS_NULL({{@1}}) || {{@1}}->vtable->base_type != enum_class_ResizableIntegerArray) {
        opcode_t * handler = Parrot_ex_throw_from_op_args(interp, dest,
            EXCEPTION_INVALID_OPERATION,
            "Must pass a valid integer array to \'local_branch\'");
        {{=handler}};
    }

    return_addr = PTR2INTVAL(dest);
    VTABLE_push_integer(interp, {{@1}}, return_addr);

    {{+={{@2}}}};
',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'local_return',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 16,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 241 "src/ops/core.ops"
    INTVAL return_addr;
    opcode_t *next;
    opcode_t *dest = {{^+2}};

    if (PMC_IS_NULL({{@1}}) || {{@1}}->vtable->base_type != enum_class_ResizableIntegerArray) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, dest,
            EXCEPTION_INVALID_OPERATION,
            "Must pass a valid integer array to \'local_return\'");
        {{=handler}};
    }

    return_addr = VTABLE_pop_integer(interp, {{@1}});
    next = INTVAL2PTR(opcode_t *, return_addr);

    /* The return address must be within the current code segment. */
    if (! (next >= interp->code->base.data
           && next < (interp->code->base.data + interp->code->base.size))) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, dest,
            EXCEPTION_INVALID_OPERATION,
            "Address for \'local_return\' must be within the current code segment");
        {{=handler}};
    }

    {{=next}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_GNEXT',
                  'NAME' => 'jump',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'base_loop' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 17,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 276 "src/ops/core.ops"
    opcode_t * const loc = INTVAL2PTR(opcode_t *, {{@1}});
    {{=loc}};
',
                  'LABELS' => [
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'jump',
                  'FLAGS' => $ops->[17]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 18,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 276 "src/ops/core.ops"
    opcode_t * const loc = INTVAL2PTR(opcode_t *, {{@1}});
    {{=loc}};
',
                  'LABELS' => [
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'enternative',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 19,
                  'ARGS' => [],
                  'BODY' => '#line 289 "src/ops/core.ops"
    opcode_t * const addr = run_native(interp, CUR_OPCODE,
            interp->code->base.data);
    {{=addr}};
',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'if',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 20,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 324 "src/ops/core.ops"
    if ({{@1}} != 0)
        {{+={{@2}}}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'if',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 21,
                  'ARGS' => [
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 329 "src/ops/core.ops"
    if (!FLOAT_IS_ZERO({{@1}}))
        {{+={{@2}}}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'if',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 22,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 334 "src/ops/core.ops"
    if (Parrot_str_boolean(interp, {{@1}}))
        {{+={{@2}}}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'if',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 23,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 339 "src/ops/core.ops"
    if (VTABLE_get_bool(interp, {{@1}}))
        {{+={{@2}}}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'unless',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 24,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 358 "src/ops/core.ops"
    if ({{@1}} == 0)
        {{+={{@2}}}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'unless',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 25,
                  'ARGS' => [
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 363 "src/ops/core.ops"
    if (FLOAT_IS_ZERO({{@1}}))
        {{+={{@2}}}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'unless',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 26,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 368 "src/ops/core.ops"
    if (!Parrot_str_boolean(interp, {{@1}}))
        {{+={{@2}}}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'unless',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 27,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 373 "src/ops/core.ops"
    if (!VTABLE_get_bool(interp, {{@1}}))
        {{+={{@2}}}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'invokecc',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 28,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 428 "src/ops/core.ops"
    PMC      * const p     = {{@1}};
    opcode_t *dest         = {{^+2}};

    interp->current_object = NULL;
    interp->current_cont   = NEED_CONTINUATION;
    dest                   = VTABLE_invoke(interp, p, dest);

    {{=dest}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'invoke',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 29,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 439 "src/ops/core.ops"
    opcode_t   *dest       = {{^+3}};
    PMC * const p          = {{@1}};

    interp->current_object = NULL;
    interp->current_cont   = {{@2}};

    dest = VTABLE_invoke(interp, p, dest);
    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'yield',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 30,
                  'ARGS' => [],
                  'BODY' => '#line 450 "src/ops/core.ops"
    opcode_t   *dest = {{^+1}};
    PMC * const p    = Parrot_pcc_get_sub(interp, CURRENT_CONTEXT(interp));

    VTABLE_increment(interp, p);
    dest = VTABLE_invoke(interp, p, dest);

    {{=dest}};
',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'tailcall',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 31,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 460 "src/ops/core.ops"
    PMC * const p               = {{@1}};
    opcode_t   *dest            = {{^+2}};
    PMC * const ctx             = CURRENT_CONTEXT(interp);
    PMC * const parent_ctx      = Parrot_pcc_get_caller_ctx(interp, ctx);
    PMC * const this_call_sig   = Parrot_pcc_get_signature(interp, ctx);
    PMC * const parent_call_sig = Parrot_pcc_get_signature(interp, parent_ctx);
    interp->current_cont        = Parrot_pcc_get_continuation(interp, ctx);

    Parrot_pcc_merge_signature_for_tailcall(interp, parent_call_sig, this_call_sig);

    SUB_FLAG_TAILCALL_SET(interp->current_cont);
    dest = VTABLE_invoke(interp, p, dest);
    {{=dest}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'returncc',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 32,
                  'ARGS' => [],
                  'BODY' => '#line 476 "src/ops/core.ops"
    PMC * const p = Parrot_pcc_get_continuation(interp, CURRENT_CONTEXT(interp));
    opcode_t * const dest = VTABLE_invoke(interp, p, {{^+1}});
    {{=dest}};
',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'capture_lex',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 33,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 482 "src/ops/core.ops"
    Parrot_capture_lex(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'newclosure',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 34,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 486 "src/ops/core.ops"
    {{@1}} = parrot_new_closure(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'set_args',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 35,
                  'ARGS' => [
                              'pc'
                            ],
                  'BODY' => '#line 524 "src/ops/core.ops"
    opcode_t * const raw_args = CUR_OPCODE;
    PMC * const signature = {{@1}};
    PMC * call_sig;
    INTVAL argc;

    call_sig = Parrot_pcc_build_sig_object_from_op(interp,
            PMCNULL, signature, raw_args);
    Parrot_pcc_set_signature(interp, CURRENT_CONTEXT(interp), call_sig);

    argc = VTABLE_elements(interp, signature);
    {{+=argc + 2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'get_results',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 36,
                  'ARGS' => [
                              'pc'
                            ],
                  'BODY' => '#line 538 "src/ops/core.ops"
    opcode_t * const raw_returns = CUR_OPCODE;
    PMC * const signature = {{@1}};
    PMC * call_sig;
    INTVAL argc;

    call_sig = Parrot_pcc_build_sig_object_returns_from_op(interp,
            Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp)),
            signature, raw_returns);
    Parrot_pcc_set_signature(interp, CURRENT_CONTEXT(interp), call_sig);

    argc = VTABLE_elements(interp, signature);
    {{+=argc + 2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'get_params',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 37,
                  'ARGS' => [
                              'pc'
                            ],
                  'BODY' => '#line 553 "src/ops/core.ops"
    opcode_t * const raw_params = CUR_OPCODE;
    PMC *caller_ctx, *ctx;
    PMC *ccont, *call_object;
    PMC * const signature = {{@1}};
    INTVAL argc;

    ctx     = CURRENT_CONTEXT(interp);
    ccont   = Parrot_pcc_get_continuation(interp, ctx);

    caller_ctx  = Parrot_pcc_get_caller_ctx(interp, ctx);
    call_object = Parrot_pcc_get_signature(interp, caller_ctx);

    Parrot_pcc_fill_params_from_op(interp, call_object, signature, raw_params);

    /* TODO Factor out with Sub.invoke */
    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, ctx);
        Parrot_pcc_set_caller_ctx(interp, ctx, Parrot_pcc_get_caller_ctx(interp, caller_ctx));
    }
    argc = VTABLE_elements(interp, signature);
    {{+=argc + 2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'set_returns',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 38,
                  'ARGS' => [
                              'pc'
                            ],
                  'BODY' => '#line 578 "src/ops/core.ops"
    opcode_t * const raw_returns = CUR_OPCODE;
    PMC      *signature          = {{@1}};
    PMC      *ctx                = CURRENT_CONTEXT(interp);
    PMC      *caller_ctx         = Parrot_pcc_get_caller_ctx(interp, ctx);
    PMC      *call_object        = Parrot_pcc_get_signature(interp, caller_ctx);
    INTVAL    argc               = VTABLE_elements(interp, signature);

    Parrot_pcc_fill_returns_from_op(interp, call_object, signature, raw_returns);

    Parrot_pcc_set_signature(interp, ctx, NULL);

    {{+=argc + 2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'result_info',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 39,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 602 "src/ops/core.ops"
    PMC *caller_ctx  = Parrot_pcc_get_caller_ctx(interp, CURRENT_CONTEXT(interp));
    PMC *call_object = Parrot_pcc_get_signature(interp, caller_ctx);
    PMC *sig = VTABLE_get_attr_str(interp, call_object,
            Parrot_str_new_constant(interp, "return_flags"));

    /* If no elements, hand back empty array; otherwise PMC. */
    if (!sig)
        {{@1}} = pmc_new(interp, enum_class_FixedIntegerArray);
    else
        {{@1}} = sig;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_addr',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 40,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 643 "src/ops/core.ops"
    {{@1}} = PTR2INTVAL(CUR_OPCODE + {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_addr',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 41,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 647 "src/ops/core.ops"
    VTABLE_set_pointer(interp, {{@1}}, (CUR_OPCODE + {{@2}}));

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_addr',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 42,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 651 "src/ops/core.ops"
    VTABLE_set_pointer(interp, {{@1}}, (void*){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_addr',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 43,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 655 "src/ops/core.ops"
    void *ptr = VTABLE_get_pointer(interp, {{@2}});
    {{@1}}        = (INTVAL)ptr;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'schedule',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 44,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 675 "src/ops/core.ops"
    Parrot_cx_schedule_task(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'addhandler',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 45,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 684 "src/ops/core.ops"
    Parrot_cx_add_handler(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'push_eh',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 46,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 761 "src/ops/core.ops"
    PMC * const eh = pmc_new(interp, enum_class_ExceptionHandler);
    VTABLE_set_pointer(interp, eh, CUR_OPCODE + {{@1}});
    Parrot_cx_add_handler_local(interp, eh);

{{+=2}};',
                  'LABELS' => [
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'push_eh',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 47,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 767 "src/ops/core.ops"
    Parrot_cx_add_handler_local(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pop_eh',
                  'FLAGS' => {},
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 48,
                  'ARGS' => [],
                  'BODY' => '#line 771 "src/ops/core.ops"
    Parrot_cx_delete_handler_local(interp,
            Parrot_str_new(interp, "exception", 9));

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'throw',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 49,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 776 "src/ops/core.ops"
    PMC * except = {{@1}};
    opcode_t *dest;
    opcode_t *const ret    = {{^+2}};
    PMC            *resume = new_ret_continuation_pmc(interp, ret);
    if (PMC_IS_NULL(except) || except->vtable->base_type != enum_class_Exception)
        except = Parrot_ex_build_exception(interp, EXCEPT_fatal,
                EXCEPTION_UNIMPLEMENTED,
                Parrot_str_new_constant(interp, "Not a throwable object"));

    VTABLE_set_attr_str(interp, except, Parrot_str_new_constant(interp, "resume"), resume);
    dest = Parrot_ex_throw_from_op(interp, except, ret);
    {{=dest}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'throw',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 50,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 791 "src/ops/core.ops"
    opcode_t * dest;
    PMC * except = {{@1}};
    if (PMC_IS_NULL(except) || except->vtable->base_type != enum_class_Exception)
        except = Parrot_ex_build_exception(interp, EXCEPT_fatal,
                EXCEPTION_UNIMPLEMENTED,
                Parrot_str_new_constant(interp, "Not a throwable object"));
    dest = Parrot_ex_throw_from_op(interp, {{@1}},
                                VTABLE_get_pointer(interp, {{@2}}));
    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'rethrow',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 51,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 803 "src/ops/core.ops"
    opcode_t * dest;
    if (PMC_IS_NULL({{@1}}) || {{@1}}->vtable->base_type != enum_class_Exception) {
        opcode_t * const ret = {{^+2}};
        PMC * except = Parrot_ex_build_exception(interp, EXCEPT_fatal,
                EXCEPTION_UNIMPLEMENTED,
                Parrot_str_new_constant(interp, "Not a throwable object"));
        dest = Parrot_ex_throw_from_op(interp, except, ret);
        {{=dest}};
    }
    dest = Parrot_ex_rethrow_from_op(interp, {{@1}});
    {{=dest}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'count_eh',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 52,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 817 "src/ops/core.ops"
    {{@1}} = Parrot_cx_count_handlers_local(interp,
            Parrot_str_new(interp, "exception", 9));

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'die',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 53,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 822 "src/ops/core.ops"
    opcode_t        *dest;
    opcode_t * const ret       = {{^+2}};
    PMC             *resume    = new_ret_continuation_pmc(interp, ret);
    PMC             *exception = Parrot_ex_build_exception(interp, EXCEPT_error,
                                    CONTROL_ERROR, {{@1}});

    VTABLE_set_attr_str(interp, exception,
                        Parrot_str_new_constant(interp, "resume"), resume);
    dest = Parrot_ex_throw_from_op(interp, exception, ret);
    {{=dest}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'die',
                  'FLAGS' => $ops->[53]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 54,
                  'ARGS' => [
                              'sc'
                            ],
                  'BODY' => '#line 822 "src/ops/core.ops"
    opcode_t        *dest;
    opcode_t * const ret       = {{^+2}};
    PMC             *resume    = new_ret_continuation_pmc(interp, ret);
    PMC             *exception = Parrot_ex_build_exception(interp, EXCEPT_error,
                                    CONTROL_ERROR, {{@1}});

    VTABLE_set_attr_str(interp, exception,
                        Parrot_str_new_constant(interp, "resume"), resume);
    dest = Parrot_ex_throw_from_op(interp, exception, ret);
    {{=dest}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'die',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 55,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 835 "src/ops/core.ops"
    opcode_t        *dest;
    opcode_t * const ret       = {{^+2}};
    PMC             *resume    = new_ret_continuation_pmc(interp, ret);
    STRING          *msg       = PMC_IS_NULL({{@1}})
                               ? NULL : VTABLE_get_string(interp, {{@1}});
    PMC             *exception =
        Parrot_ex_build_exception(interp, EXCEPT_error, CONTROL_ERROR, msg);

    VTABLE_set_attr_str(interp, exception,
                        Parrot_str_new_constant(interp, "resume"), resume);
    dest = Parrot_ex_throw_from_op(interp, exception, ret);
    {{=dest}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'die',
                  'FLAGS' => $ops->[55]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 56,
                  'ARGS' => [
                              'pc'
                            ],
                  'BODY' => '#line 835 "src/ops/core.ops"
    opcode_t        *dest;
    opcode_t * const ret       = {{^+2}};
    PMC             *resume    = new_ret_continuation_pmc(interp, ret);
    STRING          *msg       = PMC_IS_NULL({{@1}})
                               ? NULL : VTABLE_get_string(interp, {{@1}});
    PMC             *exception =
        Parrot_ex_build_exception(interp, EXCEPT_error, CONTROL_ERROR, msg);

    VTABLE_set_attr_str(interp, exception,
                        Parrot_str_new_constant(interp, "resume"), resume);
    dest = Parrot_ex_throw_from_op(interp, exception, ret);
    {{=dest}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'die',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 57,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 850 "src/ops/core.ops"
    if ({{@1}} == EXCEPT_doomed)
        _exit({{@2}});
    else {
        opcode_t * const ret       = {{^+3}};
        PMC             *exception = Parrot_ex_build_exception(interp, {{@1}},
                                                               {{@2}}, NULL);
        opcode_t * const dest      = Parrot_ex_throw_from_op(interp,
                                                             exception, ret);
        {{=dest}};
    }
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'die',
                  'FLAGS' => $ops->[57]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 58,
                  'ARGS' => [
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 850 "src/ops/core.ops"
    if ({{@1}} == EXCEPT_doomed)
        _exit({{@2}});
    else {
        opcode_t * const ret       = {{^+3}};
        PMC             *exception = Parrot_ex_build_exception(interp, {{@1}},
                                                               {{@2}}, NULL);
        opcode_t * const dest      = Parrot_ex_throw_from_op(interp,
                                                             exception, ret);
        {{=dest}};
    }
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'die',
                  'FLAGS' => $ops->[57]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 59,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 850 "src/ops/core.ops"
    if ({{@1}} == EXCEPT_doomed)
        _exit({{@2}});
    else {
        opcode_t * const ret       = {{^+3}};
        PMC             *exception = Parrot_ex_build_exception(interp, {{@1}},
                                                               {{@2}}, NULL);
        opcode_t * const dest      = Parrot_ex_throw_from_op(interp,
                                                             exception, ret);
        {{=dest}};
    }
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'die',
                  'FLAGS' => $ops->[57]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 60,
                  'ARGS' => [
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 850 "src/ops/core.ops"
    if ({{@1}} == EXCEPT_doomed)
        _exit({{@2}});
    else {
        opcode_t * const ret       = {{^+3}};
        PMC             *exception = Parrot_ex_build_exception(interp, {{@1}},
                                                               {{@2}}, NULL);
        opcode_t * const dest      = Parrot_ex_throw_from_op(interp,
                                                             exception, ret);
        {{=dest}};
    }
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'exit',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 61,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 863 "src/ops/core.ops"
    opcode_t        *dest;
    opcode_t * const ret       = {{^+2}};
    PMC             *resume    = new_ret_continuation_pmc(interp, ret);
    PMC             *exception = Parrot_ex_build_exception(interp, EXCEPT_exit,
                                                      {{@1}}, NULL);
    VTABLE_set_attr_str(interp, exception,
                        Parrot_str_new_constant(interp, "resume"), resume);
    VTABLE_set_integer_keyed_str(interp, exception,
        Parrot_str_new_constant(interp, "exit_code"), {{@1}});
    dest = Parrot_ex_throw_from_op(interp, exception, ret);
    {{=dest}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'exit',
                  'FLAGS' => $ops->[61]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 62,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 863 "src/ops/core.ops"
    opcode_t        *dest;
    opcode_t * const ret       = {{^+2}};
    PMC             *resume    = new_ret_continuation_pmc(interp, ret);
    PMC             *exception = Parrot_ex_build_exception(interp, EXCEPT_exit,
                                                      {{@1}}, NULL);
    VTABLE_set_attr_str(interp, exception,
                        Parrot_str_new_constant(interp, "resume"), resume);
    VTABLE_set_integer_keyed_str(interp, exception,
        Parrot_str_new_constant(interp, "exit_code"), {{@1}});
    dest = Parrot_ex_throw_from_op(interp, exception, ret);
    {{=dest}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pushmark',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 63,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 877 "src/ops/core.ops"
    PMC * const newint = pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, newint, {{@1}});
    VTABLE_push_pmc(interp, interp->dynamic_env, newint);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pushmark',
                  'FLAGS' => $ops->[63]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 64,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 877 "src/ops/core.ops"
    PMC * const newint = pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, newint, {{@1}});
    VTABLE_push_pmc(interp, interp->dynamic_env, newint);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'popmark',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 65,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 883 "src/ops/core.ops"
    opcode_t * dest;
    opcode_t * const ret = {{^+2}};
    int found = 0;
    while (VTABLE_elements(interp, interp->dynamic_env)) {
        PMC * const item = VTABLE_pop_pmc(interp, interp->dynamic_env);
        if (item->vtable->base_type == enum_class_Integer
         && VTABLE_get_integer(interp, item) == {{@1}}) {
            found = 1;
            break;
        }

        else if (item->vtable->base_type == enum_class_Sub
              || item->vtable->base_type == enum_class_NCI)
            Parrot_pcc_invoke_sub_from_c_args(interp, item, "I->", 0);
    }
    if (!found)
        dest = Parrot_ex_throw_from_op_args(interp, ret, 1, "Mark %d not found", {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'popmark',
                  'FLAGS' => $ops->[65]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 66,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 883 "src/ops/core.ops"
    opcode_t * dest;
    opcode_t * const ret = {{^+2}};
    int found = 0;
    while (VTABLE_elements(interp, interp->dynamic_env)) {
        PMC * const item = VTABLE_pop_pmc(interp, interp->dynamic_env);
        if (item->vtable->base_type == enum_class_Integer
         && VTABLE_get_integer(interp, item) == {{@1}}) {
            found = 1;
            break;
        }

        else if (item->vtable->base_type == enum_class_Sub
              || item->vtable->base_type == enum_class_NCI)
            Parrot_pcc_invoke_sub_from_c_args(interp, item, "I->", 0);
    }
    if (!found)
        dest = Parrot_ex_throw_from_op_args(interp, ret, 1, "Mark %d not found", {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pushaction',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 67,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 903 "src/ops/core.ops"
    VTABLE_push_pmc(interp, interp->dynamic_env, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT|PARROT_JUMP_RESTART|PARROT_JUMP_GNEXT',
                  'NAME' => 'debug',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 68,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 930 "src/ops/core.ops"
    if ({{@1}} != 0) { Interp_debug_SET(interp,   {{@1}}); }
    else         { Interp_debug_CLEAR(interp, PARROT_ALL_DEBUG_FLAGS); }
    {{=0,+=2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT|PARROT_JUMP_RESTART',
                  'NAME' => 'debug',
                  'FLAGS' => $ops->[68]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 69,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 930 "src/ops/core.ops"
    if ({{@1}} != 0) { Interp_debug_SET(interp,   {{@1}}); }
    else         { Interp_debug_CLEAR(interp, PARROT_ALL_DEBUG_FLAGS); }
    {{=0,+=2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT|PARROT_JUMP_RESTART|PARROT_JUMP_GNEXT',
                  'NAME' => 'bounds',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 70,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 945 "src/ops/core.ops"
    if ({{@1}} != 0) { Parrot_set_flag(interp,   PARROT_BOUNDS_FLAG); }
    else         { Interp_flags_CLEAR(interp, PARROT_BOUNDS_FLAG); }
    {{=0,+=2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT|PARROT_JUMP_RESTART',
                  'NAME' => 'bounds',
                  'FLAGS' => $ops->[70]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 71,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 945 "src/ops/core.ops"
    if ({{@1}} != 0) { Parrot_set_flag(interp,   PARROT_BOUNDS_FLAG); }
    else         { Interp_flags_CLEAR(interp, PARROT_BOUNDS_FLAG); }
    {{=0,+=2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT|PARROT_JUMP_RESTART|PARROT_JUMP_GNEXT',
                  'NAME' => 'profile',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 72,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 960 "src/ops/core.ops"
    if ({{@1}} != 0) { Parrot_set_flag(interp,   PARROT_PROFILE_FLAG); }
    else         { Interp_flags_CLEAR(interp, PARROT_PROFILE_FLAG); }
    {{=0,+=2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT|PARROT_JUMP_RESTART',
                  'NAME' => 'profile',
                  'FLAGS' => $ops->[72]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 73,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 960 "src/ops/core.ops"
    if ({{@1}} != 0) { Parrot_set_flag(interp,   PARROT_PROFILE_FLAG); }
    else         { Interp_flags_CLEAR(interp, PARROT_PROFILE_FLAG); }
    {{=0,+=2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT|PARROT_JUMP_RESTART|PARROT_JUMP_GNEXT',
                  'NAME' => 'trace',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 74,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 975 "src/ops/core.ops"
    if ({{@1}} != 0) { Parrot_set_trace(interp,   {{@1}}); }
    else         { Parrot_clear_trace(interp, PARROT_ALL_TRACE_FLAGS); }
    {{=0,+=2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT|PARROT_JUMP_RESTART',
                  'NAME' => 'trace',
                  'FLAGS' => $ops->[74]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 75,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 975 "src/ops/core.ops"
    if ({{@1}} != 0) { Parrot_set_trace(interp,   {{@1}}); }
    else         { Parrot_clear_trace(interp, PARROT_ALL_TRACE_FLAGS); }
    {{=0,+=2}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'gc_debug',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 76,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 989 "src/ops/core.ops"
    if ({{@1}} != 0) { Interp_flags_SET(interp,   PARROT_GC_DEBUG_FLAG); }
    else         { Interp_flags_CLEAR(interp, PARROT_GC_DEBUG_FLAG); }

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'gc_debug',
                  'FLAGS' => $ops->[76]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 77,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 989 "src/ops/core.ops"
    if ({{@1}} != 0) { Interp_flags_SET(interp,   PARROT_GC_DEBUG_FLAG); }
    else         { Interp_flags_CLEAR(interp, PARROT_GC_DEBUG_FLAG); }

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'interpinfo',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 78,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 1023 "src/ops/core.ops"
    {{@1}} = interpinfo(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'interpinfo',
                  'FLAGS' => $ops->[78]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 79,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 1023 "src/ops/core.ops"
    {{@1}} = interpinfo(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'interpinfo',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 80,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 1027 "src/ops/core.ops"
    {{@1}} = interpinfo_p(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'interpinfo',
                  'FLAGS' => $ops->[80]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 81,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 1027 "src/ops/core.ops"
    {{@1}} = interpinfo_p(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'interpinfo',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 82,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 1031 "src/ops/core.ops"
    STRING * s = interpinfo_s(interp, {{@2}});
    {{@1}} = s;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'interpinfo',
                  'FLAGS' => $ops->[82]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 83,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 1031 "src/ops/core.ops"
    STRING * s = interpinfo_s(interp, {{@2}});
    {{@1}} = s;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'warningson',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 84,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 1051 "src/ops/core.ops"
    PARROT_WARNINGS_on(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'warningson',
                  'FLAGS' => $ops->[84]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 85,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 1051 "src/ops/core.ops"
    PARROT_WARNINGS_on(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'warningsoff',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 86,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 1063 "src/ops/core.ops"
    PARROT_WARNINGS_off(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'warningsoff',
                  'FLAGS' => $ops->[86]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 87,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 1063 "src/ops/core.ops"
    PARROT_WARNINGS_off(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'errorson',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 88,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 1098 "src/ops/core.ops"
    PARROT_ERRORS_on(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'errorson',
                  'FLAGS' => $ops->[88]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 89,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 1098 "src/ops/core.ops"
    PARROT_ERRORS_on(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'errorsoff',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 90,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 1110 "src/ops/core.ops"
    PARROT_ERRORS_off(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'errorsoff',
                  'FLAGS' => $ops->[90]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 91,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 1110 "src/ops/core.ops"
    PARROT_ERRORS_off(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'runinterp',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 92,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 1126 "src/ops/core.ops"
    Interp * const new_interp = (Interp *)VTABLE_get_pointer(interp, {{@1}});
    Interp_flags_SET(new_interp, PARROT_EXTERN_CODE_FLAG);
    Parrot_switch_to_cs(new_interp, interp->code, 1);
    runops(new_interp, REL_PC + {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE|PARROT_JUMP_ENEXT',
                  'NAME' => 'runinterp',
                  'FLAGS' => $ops->[92]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 93,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 1126 "src/ops/core.ops"
    Interp * const new_interp = (Interp *)VTABLE_get_pointer(interp, {{@1}});
    Interp_flags_SET(new_interp, PARROT_EXTERN_CODE_FLAG);
    Parrot_switch_to_cs(new_interp, interp->code, 1);
    runops(new_interp, REL_PC + {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getinterp',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 94,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 1133 "src/ops/core.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, interp->iglobals,
           IGLOBALS_INTERPRETER);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sweep',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 95,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 1177 "src/ops/core.ops"
    if ({{@1}})
        Parrot_gc_mark_and_sweep(interp, 0);
    else
        if (Parrot_gc_impatient_pmcs(interp))
            Parrot_gc_mark_and_sweep(interp, GC_lazy_FLAG);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'collect',
                  'FLAGS' => {},
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 96,
                  'ARGS' => [],
                  'BODY' => '#line 1191 "src/ops/core.ops"
    Parrot_gc_compact_memory_pool(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sweepoff',
                  'FLAGS' => {},
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 97,
                  'ARGS' => [],
                  'BODY' => '#line 1201 "src/ops/core.ops"
    Parrot_block_GC_mark(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sweepon',
                  'FLAGS' => {},
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 98,
                  'ARGS' => [],
                  'BODY' => '#line 1211 "src/ops/core.ops"
    Parrot_unblock_GC_mark(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'collectoff',
                  'FLAGS' => {},
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 99,
                  'ARGS' => [],
                  'BODY' => '#line 1221 "src/ops/core.ops"
    Parrot_block_GC_sweep(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'collecton',
                  'FLAGS' => {},
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 100,
                  'ARGS' => [],
                  'BODY' => '#line 1231 "src/ops/core.ops"
    Parrot_unblock_GC_sweep(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'needs_destroy',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 101,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 1242 "src/ops/core.ops"
    Parrot_gc_pmc_needs_early_collection(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'loadlib',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 102,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 1297 "src/ops/core.ops"
    {{@1}} = Parrot_load_lib(interp, {{@2}}, NULL);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'loadlib',
                  'FLAGS' => $ops->[102]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 103,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 1297 "src/ops/core.ops"
    {{@1}} = Parrot_load_lib(interp, {{@2}}, NULL);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'dlfunc',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 104,
                  'ARGS' => [
                              'p',
                              'p',
                              's',
                              's'
                            ],
                  'BODY' => '#line 1301 "src/ops/core.ops"
    char * const  name      = Parrot_str_to_cstring(interp, ({{@3}}));
    void         *dl_handle = NULL;
    void         *ptr       = NULL;
    funcptr_t     p;

    if (!PMC_IS_NULL({{@2}}) && {{@2}}->vtable->base_type == enum_class_ParrotLibrary) {
        dl_handle = ((Parrot_ParrotLibrary_attributes*)PMC_data({{@2}}))->dl_handle;
    }

    ptr = Parrot_dlsym(
            PMC_IS_NULL({{@2}}) ? NULL :
            VTABLE_defined(interp, {{@2}}) ? dl_handle :
            NULL,
            name);

    p = D2FPTR(ptr);

    if (p == NULLfunc) {
        const char * err = Parrot_dlerror();
        Parrot_warn(interp, PARROT_WARNINGS_UNDEF_FLAG,
                "Symbol \'%s\' not found: %s\\n", name, err ? err : "unknown reason");
        {{@1}} = pmc_new(interp, enum_class_Undef);
    }
    else {
        {{@1}} = pmc_new(interp, enum_class_NCI);
        VTABLE_set_pointer_keyed_str(interp, {{@1}}, {{@4}}, F2DPTR(p));
        PObj_get_FLAGS({{@1}}) |= PObj_private1_FLAG;
    }
    Parrot_str_free_cstring(name);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'dlfunc',
                  'FLAGS' => $ops->[104]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 105,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 1301 "src/ops/core.ops"
    char * const  name      = Parrot_str_to_cstring(interp, ({{@3}}));
    void         *dl_handle = NULL;
    void         *ptr       = NULL;
    funcptr_t     p;

    if (!PMC_IS_NULL({{@2}}) && {{@2}}->vtable->base_type == enum_class_ParrotLibrary) {
        dl_handle = ((Parrot_ParrotLibrary_attributes*)PMC_data({{@2}}))->dl_handle;
    }

    ptr = Parrot_dlsym(
            PMC_IS_NULL({{@2}}) ? NULL :
            VTABLE_defined(interp, {{@2}}) ? dl_handle :
            NULL,
            name);

    p = D2FPTR(ptr);

    if (p == NULLfunc) {
        const char * err = Parrot_dlerror();
        Parrot_warn(interp, PARROT_WARNINGS_UNDEF_FLAG,
                "Symbol \'%s\' not found: %s\\n", name, err ? err : "unknown reason");
        {{@1}} = pmc_new(interp, enum_class_Undef);
    }
    else {
        {{@1}} = pmc_new(interp, enum_class_NCI);
        VTABLE_set_pointer_keyed_str(interp, {{@1}}, {{@4}}, F2DPTR(p));
        PObj_get_FLAGS({{@1}}) |= PObj_private1_FLAG;
    }
    Parrot_str_free_cstring(name);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'dlfunc',
                  'FLAGS' => $ops->[104]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 106,
                  'ARGS' => [
                              'p',
                              'p',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 1301 "src/ops/core.ops"
    char * const  name      = Parrot_str_to_cstring(interp, ({{@3}}));
    void         *dl_handle = NULL;
    void         *ptr       = NULL;
    funcptr_t     p;

    if (!PMC_IS_NULL({{@2}}) && {{@2}}->vtable->base_type == enum_class_ParrotLibrary) {
        dl_handle = ((Parrot_ParrotLibrary_attributes*)PMC_data({{@2}}))->dl_handle;
    }

    ptr = Parrot_dlsym(
            PMC_IS_NULL({{@2}}) ? NULL :
            VTABLE_defined(interp, {{@2}}) ? dl_handle :
            NULL,
            name);

    p = D2FPTR(ptr);

    if (p == NULLfunc) {
        const char * err = Parrot_dlerror();
        Parrot_warn(interp, PARROT_WARNINGS_UNDEF_FLAG,
                "Symbol \'%s\' not found: %s\\n", name, err ? err : "unknown reason");
        {{@1}} = pmc_new(interp, enum_class_Undef);
    }
    else {
        {{@1}} = pmc_new(interp, enum_class_NCI);
        VTABLE_set_pointer_keyed_str(interp, {{@1}}, {{@4}}, F2DPTR(p));
        PObj_get_FLAGS({{@1}}) |= PObj_private1_FLAG;
    }
    Parrot_str_free_cstring(name);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'dlfunc',
                  'FLAGS' => $ops->[104]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 107,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc',
                              'sc'
                            ],
                  'BODY' => '#line 1301 "src/ops/core.ops"
    char * const  name      = Parrot_str_to_cstring(interp, ({{@3}}));
    void         *dl_handle = NULL;
    void         *ptr       = NULL;
    funcptr_t     p;

    if (!PMC_IS_NULL({{@2}}) && {{@2}}->vtable->base_type == enum_class_ParrotLibrary) {
        dl_handle = ((Parrot_ParrotLibrary_attributes*)PMC_data({{@2}}))->dl_handle;
    }

    ptr = Parrot_dlsym(
            PMC_IS_NULL({{@2}}) ? NULL :
            VTABLE_defined(interp, {{@2}}) ? dl_handle :
            NULL,
            name);

    p = D2FPTR(ptr);

    if (p == NULLfunc) {
        const char * err = Parrot_dlerror();
        Parrot_warn(interp, PARROT_WARNINGS_UNDEF_FLAG,
                "Symbol \'%s\' not found: %s\\n", name, err ? err : "unknown reason");
        {{@1}} = pmc_new(interp, enum_class_Undef);
    }
    else {
        {{@1}} = pmc_new(interp, enum_class_NCI);
        VTABLE_set_pointer_keyed_str(interp, {{@1}}, {{@4}}, F2DPTR(p));
        PObj_get_FLAGS({{@1}}) |= PObj_private1_FLAG;
    }
    Parrot_str_free_cstring(name);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'dlvar',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 108,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 1333 "src/ops/core.ops"
    char * const  name      = Parrot_str_to_cstring(interp, ({{@3}}));
    void *        p         = NULL;
    void         *dl_handle = NULL;

    if (!PMC_IS_NULL({{@2}}) && {{@2}}->vtable->base_type == enum_class_ParrotLibrary) {
        dl_handle = ((Parrot_ParrotLibrary_attributes*)PMC_data({{@2}}))->dl_handle;
        p         = Parrot_dlsym(PMC_IS_NULL({{@2}}) ? NULL : dl_handle, name);
    }
    if (p == NULL) {
        const char * const err = Parrot_dlerror();
        Parrot_warn(interp, PARROT_WARNINGS_UNDEF_FLAG,
                "Symbol \'%s\' not found: %s\\n", name, err ? err : "unknown reason");
        {{@1}} = pmc_new(interp, enum_class_Undef);
    }
    else {
        /* At this point we have the symbol\'s address. We just need to build
           a PMC with it so we can get and set the value */
        {{@1}} = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, {{@1}}, p);
    }
    Parrot_str_free_cstring(name);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'dlvar',
                  'FLAGS' => $ops->[108]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 109,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 1333 "src/ops/core.ops"
    char * const  name      = Parrot_str_to_cstring(interp, ({{@3}}));
    void *        p         = NULL;
    void         *dl_handle = NULL;

    if (!PMC_IS_NULL({{@2}}) && {{@2}}->vtable->base_type == enum_class_ParrotLibrary) {
        dl_handle = ((Parrot_ParrotLibrary_attributes*)PMC_data({{@2}}))->dl_handle;
        p         = Parrot_dlsym(PMC_IS_NULL({{@2}}) ? NULL : dl_handle, name);
    }
    if (p == NULL) {
        const char * const err = Parrot_dlerror();
        Parrot_warn(interp, PARROT_WARNINGS_UNDEF_FLAG,
                "Symbol \'%s\' not found: %s\\n", name, err ? err : "unknown reason");
        {{@1}} = pmc_new(interp, enum_class_Undef);
    }
    else {
        /* At this point we have the symbol\'s address. We just need to build
           a PMC with it so we can get and set the value */
        {{@1}} = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, {{@1}}, p);
    }
    Parrot_str_free_cstring(name);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'compreg',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 110,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 1357 "src/ops/core.ops"
    PMC * const compreg_hash = VTABLE_get_pmc_keyed_int(interp,
            interp->iglobals, IGLOBALS_COMPREG_HASH);
    VTABLE_set_pmc_keyed_str(interp, compreg_hash, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'compreg',
                  'FLAGS' => $ops->[110]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 111,
                  'ARGS' => [
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 1357 "src/ops/core.ops"
    PMC * const compreg_hash = VTABLE_get_pmc_keyed_int(interp,
            interp->iglobals, IGLOBALS_COMPREG_HASH);
    VTABLE_set_pmc_keyed_str(interp, compreg_hash, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'compreg',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 112,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 1363 "src/ops/core.ops"
    PMC * const compreg_hash = VTABLE_get_pmc_keyed_int(interp,
            interp->iglobals, IGLOBALS_COMPREG_HASH);
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, compreg_hash, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'compreg',
                  'FLAGS' => $ops->[112]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 113,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 1363 "src/ops/core.ops"
    PMC * const compreg_hash = VTABLE_get_pmc_keyed_int(interp,
            interp->iglobals, IGLOBALS_COMPREG_HASH);
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, compreg_hash, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'new_callback',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 114,
                  'ARGS' => [
                              'p',
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 1369 "src/ops/core.ops"
    {{@1}} = Parrot_make_cb(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'new_callback',
                  'FLAGS' => $ops->[114]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 115,
                  'ARGS' => [
                              'p',
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 1369 "src/ops/core.ops"
    {{@1}} = Parrot_make_cb(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'annotations',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 116,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 1396 "src/ops/core.ops"
    if (interp->code->annotations) {
        opcode_t const cur_pos = ({{^+2}}) - interp->code->base.data;
        {{@1}} = PackFile_Annotations_lookup(interp, interp->code->annotations,
                cur_pos, NULL);
    }
    else {
        {{@1}} = pmc_new(interp, enum_class_Hash);
    }
    {{+=2}};

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'annotations',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 117,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 1415 "src/ops/core.ops"
    if (interp->code->annotations) {
        opcode_t const cur_pos = ({{^+3}}) - interp->code->base.data;
        {{@1}} = PackFile_Annotations_lookup(interp, interp->code->annotations,
                cur_pos, {{@2}});
    }
    else {
        {{@1}} = PMCNULL;
    }
    {{+=3}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'annotations',
                  'FLAGS' => $ops->[117]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 118,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 1415 "src/ops/core.ops"
    if (interp->code->annotations) {
        opcode_t const cur_pos = ({{^+3}}) - interp->code->base.data;
        {{@1}} = PackFile_Annotations_lookup(interp, interp->code->annotations,
                cur_pos, {{@2}});
    }
    else {
        {{@1}} = PMCNULL;
    }
    {{+=3}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 119,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 62 "src/ops/bit.ops"
    {{@1}} &= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => $ops->[119]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 120,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 62 "src/ops/bit.ops"
    {{@1}} &= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 121,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 66 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    const INTVAL b = a & {{@2}};
    VTABLE_set_integer_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => $ops->[121]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 122,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 66 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    const INTVAL b = a & {{@2}};
    VTABLE_set_integer_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 123,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 72 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    const INTVAL b = VTABLE_get_integer(interp, {{@2}});
    VTABLE_set_integer_native(interp, {{@1}}, a & b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 124,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 78 "src/ops/bit.ops"
    {{@1}} = {{@2}} & {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => $ops->[124]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 125,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 78 "src/ops/bit.ops"
    {{@1}} = {{@2}} & {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => $ops->[124]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 126,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 78 "src/ops/bit.ops"
    {{@1}} = {{@2}} & {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 127,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 82 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    VTABLE_set_integer_native(interp, {{@1}}, a & {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => $ops->[127]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 128,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 82 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    VTABLE_set_integer_native(interp, {{@1}}, a & {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'band',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 129,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 87 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    const INTVAL b = VTABLE_get_integer(interp, {{@3}});
    VTABLE_set_integer_native(interp, {{@1}}, a & b);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 130,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 113 "src/ops/bit.ops"
    Parrot_str_bitwise_and(interp, {{@1}}, {{@2}}, &{{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => $ops->[130]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 131,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 113 "src/ops/bit.ops"
    Parrot_str_bitwise_and(interp, {{@1}}, {{@2}}, &{{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 132,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 117 "src/ops/bit.ops"
    STRING * const a = VTABLE_get_string(interp, {{@1}});
    STRING * const b = Parrot_str_bitwise_and(interp, a, {{@2}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => $ops->[132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 133,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 117 "src/ops/bit.ops"
    STRING * const a = VTABLE_get_string(interp, {{@1}});
    STRING * const b = Parrot_str_bitwise_and(interp, a, {{@2}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 134,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 123 "src/ops/bit.ops"
    STRING * a = VTABLE_get_string(interp, {{@1}});
    STRING * b = VTABLE_get_string(interp, {{@2}});
    a = Parrot_str_bitwise_and(interp, a, b, NULL);
    VTABLE_set_string_native(interp, {{@1}}, a);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 135,
                  'ARGS' => [
                              's',
                              's',
                              's'
                            ],
                  'BODY' => '#line 130 "src/ops/bit.ops"
    {{@1}} = Parrot_str_bitwise_and(interp, {{@2}}, {{@3}}, NULL);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => $ops->[135]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 136,
                  'ARGS' => [
                              's',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 130 "src/ops/bit.ops"
    {{@1}} = Parrot_str_bitwise_and(interp, {{@2}}, {{@3}}, NULL);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => $ops->[135]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 137,
                  'ARGS' => [
                              's',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 130 "src/ops/bit.ops"
    {{@1}} = Parrot_str_bitwise_and(interp, {{@2}}, {{@3}}, NULL);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 138,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 134 "src/ops/bit.ops"
    STRING * const a = VTABLE_get_string(interp, {{@2}});
    STRING * const b = Parrot_str_bitwise_and(interp, a, {{@3}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => $ops->[138]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 139,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 134 "src/ops/bit.ops"
    STRING * const a = VTABLE_get_string(interp, {{@2}});
    STRING * const b = Parrot_str_bitwise_and(interp, a, {{@3}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bands',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 140,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 140 "src/ops/bit.ops"
    STRING * const a = VTABLE_get_string(interp, {{@2}});
    STRING * const b = VTABLE_get_string(interp, {{@3}});
    STRING * const c = Parrot_str_bitwise_and(interp, a, b, NULL);
    VTABLE_set_string_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bnot',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 141,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 161 "src/ops/bit.ops"
    {{@1}} = ~ {{@1}};

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bnot',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 142,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 165 "src/ops/bit.ops"
    {{@1}} = ~ {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bnot',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 143,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 169 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    VTABLE_set_integer_native(interp, {{@1}}, ~a);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bnot',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 144,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 174 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    PMC * const b = pmc_new(interp, VTABLE_type(interp, {{@2}}));
    VTABLE_set_integer_native(interp, b, ~a);
    {{@1}} = b;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bnots',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 145,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 191 "src/ops/bit.ops"
    Parrot_str_bitwise_not(interp, {{@1}}, &{{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bnots',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 146,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 195 "src/ops/bit.ops"
    Parrot_str_bitwise_not(interp, {{@2}}, &{{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bnots',
                  'FLAGS' => $ops->[146]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 147,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 195 "src/ops/bit.ops"
    Parrot_str_bitwise_not(interp, {{@2}}, &{{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bnots',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 148,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 199 "src/ops/bit.ops"
    STRING * a = VTABLE_get_string(interp, {{@1}});
    STRING * b = Parrot_str_bitwise_not(interp, a, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bnots',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 149,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 205 "src/ops/bit.ops"
    STRING * a = VTABLE_get_string(interp, {{@2}});
    STRING * b = Parrot_str_bitwise_not(interp, a, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 150,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 233 "src/ops/bit.ops"
    {{@1}} |= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => $ops->[150]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 151,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 233 "src/ops/bit.ops"
    {{@1}} |= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 152,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 237 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    VTABLE_set_integer_native(interp, {{@1}}, a | {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => $ops->[152]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 153,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 237 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    VTABLE_set_integer_native(interp, {{@1}}, a | {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 154,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 242 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    const INTVAL b = VTABLE_get_integer(interp, {{@2}});
    VTABLE_set_integer_native(interp, {{@1}}, a | b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 155,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 248 "src/ops/bit.ops"
    {{@1}} = {{@2}} | {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => $ops->[155]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 156,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 248 "src/ops/bit.ops"
    {{@1}} = {{@2}} | {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => $ops->[155]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 157,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 248 "src/ops/bit.ops"
    {{@1}} = {{@2}} | {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 158,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 252 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    VTABLE_set_integer_native(interp, {{@1}}, a | {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => $ops->[158]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 159,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 252 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    VTABLE_set_integer_native(interp, {{@1}}, a | {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 160,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 257 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    const INTVAL b = VTABLE_get_integer(interp, {{@3}});
    VTABLE_set_integer_native(interp, {{@1}}, a | b);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 161,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 283 "src/ops/bit.ops"
    Parrot_str_bitwise_or(interp, {{@1}}, {{@2}}, &{{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => $ops->[161]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 162,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 283 "src/ops/bit.ops"
    Parrot_str_bitwise_or(interp, {{@1}}, {{@2}}, &{{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 163,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 287 "src/ops/bit.ops"
    STRING * const a = VTABLE_get_string(interp, {{@1}});
    STRING * const b = Parrot_str_bitwise_or(interp, a, {{@2}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => $ops->[163]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 164,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 287 "src/ops/bit.ops"
    STRING * const a = VTABLE_get_string(interp, {{@1}});
    STRING * const b = Parrot_str_bitwise_or(interp, a, {{@2}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 165,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 293 "src/ops/bit.ops"
    STRING * const a = VTABLE_get_string(interp, {{@1}});
    STRING * const b = VTABLE_get_string(interp, {{@2}});
    STRING * const c = Parrot_str_bitwise_or(interp, a, b, NULL);
    VTABLE_set_string_native(interp, {{@1}}, c);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 166,
                  'ARGS' => [
                              's',
                              's',
                              's'
                            ],
                  'BODY' => '#line 300 "src/ops/bit.ops"
    {{@1}} = Parrot_str_bitwise_or(interp, {{@2}}, {{@3}}, NULL);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => $ops->[166]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 167,
                  'ARGS' => [
                              's',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 300 "src/ops/bit.ops"
    {{@1}} = Parrot_str_bitwise_or(interp, {{@2}}, {{@3}}, NULL);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => $ops->[166]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 168,
                  'ARGS' => [
                              's',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 300 "src/ops/bit.ops"
    {{@1}} = Parrot_str_bitwise_or(interp, {{@2}}, {{@3}}, NULL);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 169,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 304 "src/ops/bit.ops"
    STRING * const b = VTABLE_get_string(interp, {{@2}});
    STRING * const c = Parrot_str_bitwise_or(interp, b, {{@3}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => $ops->[169]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 170,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 304 "src/ops/bit.ops"
    STRING * const b = VTABLE_get_string(interp, {{@2}});
    STRING * const c = Parrot_str_bitwise_or(interp, b, {{@3}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 171,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 310 "src/ops/bit.ops"
    STRING * const a = VTABLE_get_string(interp, {{@2}});
    STRING * const b = VTABLE_get_string(interp, {{@3}});
    STRING * const c = Parrot_str_bitwise_or(interp, a, b, NULL);
    VTABLE_set_string_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 172,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 337 "src/ops/bit.ops"
    {{@1}} = bit_shift_left({{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => $ops->[172]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 173,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 337 "src/ops/bit.ops"
    {{@1}} = bit_shift_left({{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 174,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 341 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    const INTVAL b = bit_shift_left(a, {{@2}});
    VTABLE_set_integer_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => $ops->[174]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 175,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 341 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    const INTVAL b = bit_shift_left(a, {{@2}});
    VTABLE_set_integer_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 176,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 347 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    const INTVAL b = VTABLE_get_integer(interp, {{@2}});
    const INTVAL c = bit_shift_left(a, b);
    VTABLE_set_integer_native(interp, {{@1}}, c);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 177,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 354 "src/ops/bit.ops"
    {{@1}} = bit_shift_left({{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => $ops->[177]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 178,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 354 "src/ops/bit.ops"
    {{@1}} = bit_shift_left({{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => $ops->[177]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 179,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 354 "src/ops/bit.ops"
    {{@1}} = bit_shift_left({{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 180,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 358 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    const INTVAL b = bit_shift_left(a, {{@3}});
    VTABLE_set_integer_native(interp, {{@1}}, b);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => $ops->[180]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 181,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 358 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    const INTVAL b = bit_shift_left(a, {{@3}});
    VTABLE_set_integer_native(interp, {{@1}}, b);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shl',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 182,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 364 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    const INTVAL b = VTABLE_get_integer(interp, {{@3}});
    const INTVAL c = bit_shift_left(a, b);
    VTABLE_set_integer_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 183,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 391 "src/ops/bit.ops"
    const INTVAL signed_shift = -{{@2}};
    {{@1}} = bit_shift_left({{@1}}, signed_shift);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => $ops->[183]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 184,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 391 "src/ops/bit.ops"
    const INTVAL signed_shift = -{{@2}};
    {{@1}} = bit_shift_left({{@1}}, signed_shift);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 185,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 396 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    const INTVAL b = bit_shift_left(a, -{{@2}});
    VTABLE_set_integer_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => $ops->[185]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 186,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 396 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    const INTVAL b = bit_shift_left(a, -{{@2}});
    VTABLE_set_integer_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 187,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 402 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@1}});
    const INTVAL b = VTABLE_get_integer(interp, {{@2}});
    const INTVAL c = bit_shift_left(a, -b);
    VTABLE_set_integer_native(interp, {{@1}}, c);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 188,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 409 "src/ops/bit.ops"
    const INTVAL signed_shift = -{{@3}};
    {{@1}} = bit_shift_left({{@2}}, signed_shift);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => $ops->[188]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 189,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 409 "src/ops/bit.ops"
    const INTVAL signed_shift = -{{@3}};
    {{@1}} = bit_shift_left({{@2}}, signed_shift);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => $ops->[188]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 190,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 409 "src/ops/bit.ops"
    const INTVAL signed_shift = -{{@3}};
    {{@1}} = bit_shift_left({{@2}}, signed_shift);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 191,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 414 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    const INTVAL c = bit_shift_left(a, -{{@3}});
    VTABLE_set_integer_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => $ops->[191]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 192,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 414 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    const INTVAL c = bit_shift_left(a, -{{@3}});
    VTABLE_set_integer_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 193,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 420 "src/ops/bit.ops"
    const INTVAL a = VTABLE_get_integer(interp, {{@2}});
    const INTVAL b = VTABLE_get_integer(interp, {{@3}});
    const INTVAL c = bit_shift_left(a, -b);
    VTABLE_set_integer_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 194,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 447 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL){{@1}};
    const UINTVAL b = a >> {{@2}};
    {{@1}} = (INTVAL)b;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => $ops->[194]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 195,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 447 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL){{@1}};
    const UINTVAL b = a >> {{@2}};
    {{@1}} = (INTVAL)b;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 196,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 453 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@1}});
    const UINTVAL b = a >> {{@2}};
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => $ops->[196]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 197,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 453 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@1}});
    const UINTVAL b = a >> {{@2}};
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 198,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 459 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@1}});
    const UINTVAL b = (UINTVAL)VTABLE_get_integer(interp, {{@2}});
    const UINTVAL c = a >> b;
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)c);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 199,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 466 "src/ops/bit.ops"
    {{@1}} = (INTVAL)((UINTVAL){{@2}} >> {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => $ops->[199]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 200,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 466 "src/ops/bit.ops"
    {{@1}} = (INTVAL)((UINTVAL){{@2}} >> {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => $ops->[199]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 201,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 466 "src/ops/bit.ops"
    {{@1}} = (INTVAL)((UINTVAL){{@2}} >> {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 202,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 470 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@2}});
    const UINTVAL b = (UINTVAL){{@3}};
    const UINTVAL c = a >> b;
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => $ops->[202]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 203,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 470 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@2}});
    const UINTVAL b = (UINTVAL){{@3}};
    const UINTVAL c = a >> b;
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lsr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 204,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 477 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@2}});
    const UINTVAL b = (UINTVAL)VTABLE_get_integer(interp, {{@3}});
    const UINTVAL c = a >> b;
    VTABLE_set_integer_native(interp, {{@3}}, (INTVAL)c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'rot',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 205,
                  'ARGS' => [
                              'i',
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 493 "src/ops/bit.ops"
    const INTVAL r = {{@2}};
    INTVAL s = {{@3}};
    const INTVAL w = {{@4}};
    INTVAL d, t;
    if (s < 0)
        s += w;
    d = r << s;
    t = w - s;
    t = (INTVAL)((UINTVAL)r >> t);
    d |= t;
    {{@1}} = d;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'rot',
                  'FLAGS' => $ops->[205]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 206,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 493 "src/ops/bit.ops"
    const INTVAL r = {{@2}};
    INTVAL s = {{@3}};
    const INTVAL w = {{@4}};
    INTVAL d, t;
    if (s < 0)
        s += w;
    d = r << s;
    t = w - s;
    t = (INTVAL)((UINTVAL)r >> t);
    d |= t;
    {{@1}} = d;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'rot',
                  'FLAGS' => $ops->[205]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 207,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 493 "src/ops/bit.ops"
    const INTVAL r = {{@2}};
    INTVAL s = {{@3}};
    const INTVAL w = {{@4}};
    INTVAL d, t;
    if (s < 0)
        s += w;
    d = r << s;
    t = w - s;
    t = (INTVAL)((UINTVAL)r >> t);
    d |= t;
    {{@1}} = d;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 208,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 529 "src/ops/bit.ops"
    {{@1}} ^= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => $ops->[208]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 209,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 529 "src/ops/bit.ops"
    {{@1}} ^= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 210,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 533 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@1}});
    const UINTVAL b = a ^ {{@2}};
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => $ops->[210]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 211,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 533 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@1}});
    const UINTVAL b = a ^ {{@2}};
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 212,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 539 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@1}});
    const UINTVAL b = (UINTVAL)VTABLE_get_integer(interp, {{@2}});
    const UINTVAL c = a ^ b;
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)c);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 213,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 546 "src/ops/bit.ops"
    {{@1}} = {{@2}} ^ {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => $ops->[213]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 214,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 546 "src/ops/bit.ops"
    {{@1}} = {{@2}} ^ {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => $ops->[213]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 215,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 546 "src/ops/bit.ops"
    {{@1}} = {{@2}} ^ {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 216,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 550 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@2}});
    const UINTVAL b = a ^ {{@3}};
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)b);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => $ops->[216]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 217,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 550 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@2}});
    const UINTVAL b = a ^ {{@3}};
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)b);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 218,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 556 "src/ops/bit.ops"
    const UINTVAL a = (UINTVAL)VTABLE_get_integer(interp, {{@2}});
    const UINTVAL b = (UINTVAL)VTABLE_get_integer(interp, {{@3}});
    const UINTVAL c = a ^ b;
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL)c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 219,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 583 "src/ops/bit.ops"
    Parrot_str_bitwise_xor(interp, {{@1}}, {{@2}}, &{{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => $ops->[219]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 220,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 583 "src/ops/bit.ops"
    Parrot_str_bitwise_xor(interp, {{@1}}, {{@2}}, &{{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 221,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 587 "src/ops/bit.ops"
    STRING *a = VTABLE_get_string(interp, {{@1}});
    STRING *b = Parrot_str_bitwise_xor(interp, a, {{@2}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => $ops->[221]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 222,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 587 "src/ops/bit.ops"
    STRING *a = VTABLE_get_string(interp, {{@1}});
    STRING *b = Parrot_str_bitwise_xor(interp, a, {{@2}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 223,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 593 "src/ops/bit.ops"
    STRING *a = VTABLE_get_string(interp, {{@1}});
    STRING *b = VTABLE_get_string(interp, {{@2}});
    STRING *c = Parrot_str_bitwise_xor(interp, a, b, NULL);
    VTABLE_set_string_native(interp, {{@1}}, c);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 224,
                  'ARGS' => [
                              's',
                              's',
                              's'
                            ],
                  'BODY' => '#line 600 "src/ops/bit.ops"
    {{@1}} = Parrot_str_bitwise_xor(interp, {{@2}}, {{@3}}, NULL);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => $ops->[224]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 225,
                  'ARGS' => [
                              's',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 600 "src/ops/bit.ops"
    {{@1}} = Parrot_str_bitwise_xor(interp, {{@2}}, {{@3}}, NULL);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => $ops->[224]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 226,
                  'ARGS' => [
                              's',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 600 "src/ops/bit.ops"
    {{@1}} = Parrot_str_bitwise_xor(interp, {{@2}}, {{@3}}, NULL);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 227,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 604 "src/ops/bit.ops"
    STRING *a = VTABLE_get_string(interp, {{@2}});
    STRING *b = Parrot_str_bitwise_xor(interp, a, {{@3}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => $ops->[227]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 228,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 604 "src/ops/bit.ops"
    STRING *a = VTABLE_get_string(interp, {{@2}});
    STRING *b = Parrot_str_bitwise_xor(interp, a, {{@3}}, NULL);
    VTABLE_set_string_native(interp, {{@1}}, b);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bxors',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 229,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 610 "src/ops/bit.ops"
    STRING *a = VTABLE_get_string(interp, {{@2}});
    STRING *b = VTABLE_get_string(interp, {{@3}});
    STRING *c = Parrot_str_bitwise_xor(interp, a, b, NULL);
    VTABLE_set_string_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 230,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 66 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => $ops->[230]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 231,
                  'ARGS' => [
                              'ic',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 66 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => $ops->[230]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 232,
                  'ARGS' => [
                              'i',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 66 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 233,
                  'ARGS' => [
                              'n',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 72 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => $ops->[233]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 234,
                  'ARGS' => [
                              'nc',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 72 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => $ops->[233]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 235,
                  'ARGS' => [
                              'n',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 72 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 236,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 78 "src/ops/cmp.ops"
    if (Parrot_str_equal(interp, {{@1}}, {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => $ops->[236]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 237,
                  'ARGS' => [
                              'sc',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 78 "src/ops/cmp.ops"
    if (Parrot_str_equal(interp, {{@1}}, {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => $ops->[236]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 238,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 78 "src/ops/cmp.ops"
    if (Parrot_str_equal(interp, {{@1}}, {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 239,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 84 "src/ops/cmp.ops"
    if (VTABLE_is_equal(interp, {{@1}}, {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 240,
                  'ARGS' => [
                              'p',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 90 "src/ops/cmp.ops"
    PMC * temp = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (VTABLE_is_equal(interp, {{@1}}, temp)) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => $ops->[240]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 241,
                  'ARGS' => [
                              'p',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 90 "src/ops/cmp.ops"
    PMC * temp = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (VTABLE_is_equal(interp, {{@1}}, temp)) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 242,
                  'ARGS' => [
                              'p',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 102 "src/ops/cmp.ops"
    /*
     * the get_number and get_string should probably
     * be also replaced with code like above, as
     * overriding the compare multi subs wouldn\'t
     * have any effect with the current code
     */
    if (VTABLE_get_number(interp, {{@1}}) == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => $ops->[242]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 243,
                  'ARGS' => [
                              'p',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 102 "src/ops/cmp.ops"
    /*
     * the get_number and get_string should probably
     * be also replaced with code like above, as
     * overriding the compare multi subs wouldn\'t
     * have any effect with the current code
     */
    if (VTABLE_get_number(interp, {{@1}}) == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 244,
                  'ARGS' => [
                              'p',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 114 "src/ops/cmp.ops"
    if (Parrot_str_equal(interp, VTABLE_get_string(interp, {{@1}}), {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq',
                  'FLAGS' => $ops->[244]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 245,
                  'ARGS' => [
                              'p',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 114 "src/ops/cmp.ops"
    if (Parrot_str_equal(interp, VTABLE_get_string(interp, {{@1}}), {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq_str',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 246,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 120 "src/ops/cmp.ops"
    if (VTABLE_is_equal_string(interp, {{@1}}, {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq_num',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 247,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 126 "src/ops/cmp.ops"
    if (VTABLE_is_equal_num(interp, {{@1}}, {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq_addr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 248,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 132 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq_addr',
                  'FLAGS' => $ops->[248]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 249,
                  'ARGS' => [
                              'sc',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 132 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq_addr',
                  'FLAGS' => $ops->[248]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 250,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 132 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq_addr',
                  'FLAGS' => $ops->[248]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 251,
                  'ARGS' => [
                              'sc',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 132 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'eq_addr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 252,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 138 "src/ops/cmp.ops"
    if ({{@1}} == {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 253,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 172 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => $ops->[253]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 254,
                  'ARGS' => [
                              'ic',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 172 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => $ops->[253]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 255,
                  'ARGS' => [
                              'i',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 172 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 256,
                  'ARGS' => [
                              'n',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 178 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => $ops->[256]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 257,
                  'ARGS' => [
                              'nc',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 178 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => $ops->[256]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 258,
                  'ARGS' => [
                              'n',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 178 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 259,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 184 "src/ops/cmp.ops"
    if (Parrot_str_not_equal(interp, {{@1}}, {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => $ops->[259]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 260,
                  'ARGS' => [
                              'sc',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 184 "src/ops/cmp.ops"
    if (Parrot_str_not_equal(interp, {{@1}}, {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => $ops->[259]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 261,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 184 "src/ops/cmp.ops"
    if (Parrot_str_not_equal(interp, {{@1}}, {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 262,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 190 "src/ops/cmp.ops"
    if (!VTABLE_is_equal(interp, {{@1}}, {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 263,
                  'ARGS' => [
                              'p',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 196 "src/ops/cmp.ops"
    PMC * temp = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (!VTABLE_is_equal(interp, {{@1}}, temp)) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => $ops->[263]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 264,
                  'ARGS' => [
                              'p',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 196 "src/ops/cmp.ops"
    PMC * temp = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (!VTABLE_is_equal(interp, {{@1}}, temp)) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 265,
                  'ARGS' => [
                              'p',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 208 "src/ops/cmp.ops"
    if (VTABLE_get_number(interp, {{@1}}) != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => $ops->[265]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 266,
                  'ARGS' => [
                              'p',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 208 "src/ops/cmp.ops"
    if (VTABLE_get_number(interp, {{@1}}) != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 267,
                  'ARGS' => [
                              'p',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 214 "src/ops/cmp.ops"
    if (Parrot_str_not_equal(interp, VTABLE_get_string(interp, {{@1}}), {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne',
                  'FLAGS' => $ops->[267]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 268,
                  'ARGS' => [
                              'p',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 214 "src/ops/cmp.ops"
    if (Parrot_str_not_equal(interp, VTABLE_get_string(interp, {{@1}}), {{@2}})) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne_str',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 269,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 220 "src/ops/cmp.ops"
    if (VTABLE_cmp_string(interp, {{@1}}, {{@2}}) != 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne_num',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 270,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 226 "src/ops/cmp.ops"
    if (VTABLE_cmp_num(interp, {{@1}}, {{@2}}) != 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne_addr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 271,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 232 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne_addr',
                  'FLAGS' => $ops->[271]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 272,
                  'ARGS' => [
                              'sc',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 232 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne_addr',
                  'FLAGS' => $ops->[271]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 273,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 232 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne_addr',
                  'FLAGS' => $ops->[271]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 274,
                  'ARGS' => [
                              'sc',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 232 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ne_addr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 275,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 238 "src/ops/cmp.ops"
    if ({{@1}} != {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 276,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 268 "src/ops/cmp.ops"
    if ({{@1}} < {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => $ops->[276]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 277,
                  'ARGS' => [
                              'ic',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 268 "src/ops/cmp.ops"
    if ({{@1}} < {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => $ops->[276]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 278,
                  'ARGS' => [
                              'i',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 268 "src/ops/cmp.ops"
    if ({{@1}} < {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 279,
                  'ARGS' => [
                              'n',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 274 "src/ops/cmp.ops"
    if ({{@1}} < {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => $ops->[279]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 280,
                  'ARGS' => [
                              'nc',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 274 "src/ops/cmp.ops"
    if ({{@1}} < {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => $ops->[279]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 281,
                  'ARGS' => [
                              'n',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 274 "src/ops/cmp.ops"
    if ({{@1}} < {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 282,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 280 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, {{@1}}, {{@2}}) < 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => $ops->[282]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 283,
                  'ARGS' => [
                              'sc',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 280 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, {{@1}}, {{@2}}) < 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => $ops->[282]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 284,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 280 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, {{@1}}, {{@2}}) < 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 285,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 286 "src/ops/cmp.ops"
    if (VTABLE_cmp(interp, {{@1}}, {{@2}}) < 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 286,
                  'ARGS' => [
                              'p',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 292 "src/ops/cmp.ops"
    PMC * temp  = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (VTABLE_cmp(interp, {{@1}}, temp) < 0) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => $ops->[286]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 287,
                  'ARGS' => [
                              'p',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 292 "src/ops/cmp.ops"
    PMC * temp  = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (VTABLE_cmp(interp, {{@1}}, temp) < 0) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 288,
                  'ARGS' => [
                              'p',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 304 "src/ops/cmp.ops"
    if (VTABLE_get_number(interp, {{@1}}) < {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => $ops->[288]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 289,
                  'ARGS' => [
                              'p',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 304 "src/ops/cmp.ops"
    if (VTABLE_get_number(interp, {{@1}}) < {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 290,
                  'ARGS' => [
                              'p',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 310 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, VTABLE_get_string(interp, {{@1}}), {{@2}}) < 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt',
                  'FLAGS' => $ops->[290]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 291,
                  'ARGS' => [
                              'p',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 310 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, VTABLE_get_string(interp, {{@1}}), {{@2}}) < 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt_str',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 292,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 316 "src/ops/cmp.ops"
    if (VTABLE_cmp_string(interp, {{@1}}, {{@2}}) < 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'lt_num',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 293,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 322 "src/ops/cmp.ops"
    if (VTABLE_cmp_num(interp, {{@1}}, {{@2}}) < 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 294,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 352 "src/ops/cmp.ops"
    if ({{@1}} <= {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => $ops->[294]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 295,
                  'ARGS' => [
                              'ic',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 352 "src/ops/cmp.ops"
    if ({{@1}} <= {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => $ops->[294]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 296,
                  'ARGS' => [
                              'i',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 352 "src/ops/cmp.ops"
    if ({{@1}} <= {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 297,
                  'ARGS' => [
                              'n',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 358 "src/ops/cmp.ops"
    if ({{@1}} <= {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => $ops->[297]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 298,
                  'ARGS' => [
                              'nc',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 358 "src/ops/cmp.ops"
    if ({{@1}} <= {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => $ops->[297]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 299,
                  'ARGS' => [
                              'n',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 358 "src/ops/cmp.ops"
    if ({{@1}} <= {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 300,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 364 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, {{@1}}, {{@2}}) <= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => $ops->[300]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 301,
                  'ARGS' => [
                              'sc',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 364 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, {{@1}}, {{@2}}) <= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => $ops->[300]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 302,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 364 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, {{@1}}, {{@2}}) <= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 303,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 370 "src/ops/cmp.ops"
    if (VTABLE_cmp(interp, {{@1}}, {{@2}}) <= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 304,
                  'ARGS' => [
                              'p',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 376 "src/ops/cmp.ops"
    PMC * temp  = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (VTABLE_cmp(interp, {{@1}}, temp) <= 0) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => $ops->[304]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 305,
                  'ARGS' => [
                              'p',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 376 "src/ops/cmp.ops"
    PMC * temp  = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (VTABLE_cmp(interp, {{@1}}, temp) <= 0) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 306,
                  'ARGS' => [
                              'p',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 388 "src/ops/cmp.ops"
    if (VTABLE_get_number(interp, {{@1}}) <= {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => $ops->[306]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 307,
                  'ARGS' => [
                              'p',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 388 "src/ops/cmp.ops"
    if (VTABLE_get_number(interp, {{@1}}) <= {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 308,
                  'ARGS' => [
                              'p',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 394 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, VTABLE_get_string(interp, {{@1}}), {{@2}}) <= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le',
                  'FLAGS' => $ops->[308]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 309,
                  'ARGS' => [
                              'p',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 394 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, VTABLE_get_string(interp, {{@1}}), {{@2}}) <= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le_str',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 310,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 400 "src/ops/cmp.ops"
    if (VTABLE_cmp_string(interp, {{@1}}, {{@2}}) <= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'le_num',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 311,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 406 "src/ops/cmp.ops"
    if (VTABLE_cmp_num(interp, {{@1}}, {{@2}}) <= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'gt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 312,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 430 "src/ops/cmp.ops"
    if (VTABLE_cmp(interp, {{@1}}, {{@2}}) > 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'gt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 313,
                  'ARGS' => [
                              'p',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 436 "src/ops/cmp.ops"
    PMC * temp  = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (VTABLE_cmp(interp, {{@1}}, temp) > 0) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'gt',
                  'FLAGS' => $ops->[313]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 314,
                  'ARGS' => [
                              'p',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 436 "src/ops/cmp.ops"
    PMC * temp  = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (VTABLE_cmp(interp, {{@1}}, temp) > 0) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'gt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 315,
                  'ARGS' => [
                              'p',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 448 "src/ops/cmp.ops"
    if (VTABLE_get_number(interp, {{@1}}) > {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'gt',
                  'FLAGS' => $ops->[315]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 316,
                  'ARGS' => [
                              'p',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 448 "src/ops/cmp.ops"
    if (VTABLE_get_number(interp, {{@1}}) > {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'gt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 317,
                  'ARGS' => [
                              'p',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 454 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, VTABLE_get_string(interp, {{@1}}), {{@2}}) > 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'gt',
                  'FLAGS' => $ops->[317]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 318,
                  'ARGS' => [
                              'p',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 454 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, VTABLE_get_string(interp, {{@1}}), {{@2}}) > 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'gt_str',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 319,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 460 "src/ops/cmp.ops"
    if (VTABLE_cmp_string(interp, {{@1}}, {{@2}}) > 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'gt_num',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 320,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 466 "src/ops/cmp.ops"
    if (VTABLE_cmp_num(interp, {{@1}}, {{@2}}) > 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ge',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 321,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 490 "src/ops/cmp.ops"
    if (VTABLE_cmp(interp, {{@1}}, {{@2}}) >= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ge',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 322,
                  'ARGS' => [
                              'p',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 496 "src/ops/cmp.ops"
    PMC * temp  = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (VTABLE_cmp(interp, {{@1}}, temp) >= 0) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ge',
                  'FLAGS' => $ops->[322]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 323,
                  'ARGS' => [
                              'p',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 496 "src/ops/cmp.ops"
    PMC * temp  = temporary_pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, temp, {{@2}});

    if (VTABLE_cmp(interp, {{@1}}, temp) >= 0) {
        temporary_pmc_free(interp, temp);
        {{+={{@3}}}};
    }

    temporary_pmc_free(interp, temp);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ge',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 324,
                  'ARGS' => [
                              'p',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 508 "src/ops/cmp.ops"
    if (VTABLE_get_number(interp, {{@1}}) >= {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ge',
                  'FLAGS' => $ops->[324]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 325,
                  'ARGS' => [
                              'p',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 508 "src/ops/cmp.ops"
    if (VTABLE_get_number(interp, {{@1}}) >= {{@2}}) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ge',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 326,
                  'ARGS' => [
                              'p',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 514 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, VTABLE_get_string(interp, {{@1}}), {{@2}}) >= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ge',
                  'FLAGS' => $ops->[326]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 327,
                  'ARGS' => [
                              'p',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 514 "src/ops/cmp.ops"
    if (Parrot_str_compare(interp, VTABLE_get_string(interp, {{@1}}), {{@2}}) >= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ge_str',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 328,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 520 "src/ops/cmp.ops"
    if (VTABLE_cmp_string(interp, {{@1}}, {{@2}}) >= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'ge_num',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 329,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 526 "src/ops/cmp.ops"
    if (VTABLE_cmp_num(interp, {{@1}}, {{@2}}) >= 0) {
        {{+={{@3}}}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'if_null',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 330,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 544 "src/ops/cmp.ops"
    if (PMC_IS_NULL({{@1}})) {
        {{+={{@2}}}};
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'if_null',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 331,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 550 "src/ops/cmp.ops"
    if (STRING_IS_NULL({{@1}})) {
        {{+={{@2}}}};
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'unless_null',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 332,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 568 "src/ops/cmp.ops"
    if (!PMC_IS_NULL({{@1}})) {
        {{+={{@2}}}};
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_RELATIVE',
                  'NAME' => 'unless_null',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 333,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 574 "src/ops/cmp.ops"
    if (!STRING_IS_NULL({{@1}})) {
        {{+={{@2}}}};
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 334,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 615 "src/ops/cmp.ops"
    {{@1}} = {{@2}} < {{@3}} ? -1 :
         {{@2}} > {{@3}} ? +1 :
         0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => $ops->[334]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 335,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 615 "src/ops/cmp.ops"
    {{@1}} = {{@2}} < {{@3}} ? -1 :
         {{@2}} > {{@3}} ? +1 :
         0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => $ops->[334]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 336,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 615 "src/ops/cmp.ops"
    {{@1}} = {{@2}} < {{@3}} ? -1 :
         {{@2}} > {{@3}} ? +1 :
         0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 337,
                  'ARGS' => [
                              'i',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 621 "src/ops/cmp.ops"
    {{@1}} = {{@2}} < {{@3}} ? -1 :
         {{@2}} > {{@3}} ? +1 :
         0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => $ops->[337]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 338,
                  'ARGS' => [
                              'i',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 621 "src/ops/cmp.ops"
    {{@1}} = {{@2}} < {{@3}} ? -1 :
         {{@2}} > {{@3}} ? +1 :
         0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => $ops->[337]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 339,
                  'ARGS' => [
                              'i',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 621 "src/ops/cmp.ops"
    {{@1}} = {{@2}} < {{@3}} ? -1 :
         {{@2}} > {{@3}} ? +1 :
         0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 340,
                  'ARGS' => [
                              'i',
                              's',
                              's'
                            ],
                  'BODY' => '#line 627 "src/ops/cmp.ops"
    {{@1}} = Parrot_str_compare(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => $ops->[340]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 341,
                  'ARGS' => [
                              'i',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 627 "src/ops/cmp.ops"
    {{@1}} = Parrot_str_compare(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => $ops->[340]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 342,
                  'ARGS' => [
                              'i',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 627 "src/ops/cmp.ops"
    {{@1}} = Parrot_str_compare(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 343,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 631 "src/ops/cmp.ops"
    {{@1}} = VTABLE_cmp(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 344,
                  'ARGS' => [
                              'i',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 635 "src/ops/cmp.ops"
    const INTVAL l = VTABLE_get_integer(interp, {{@2}});
    {{@1}} = l < {{@3}} ? -1 :
         l > {{@3}} ? +1 :
         0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => $ops->[344]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 345,
                  'ARGS' => [
                              'i',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 635 "src/ops/cmp.ops"
    const INTVAL l = VTABLE_get_integer(interp, {{@2}});
    {{@1}} = l < {{@3}} ? -1 :
         l > {{@3}} ? +1 :
         0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 346,
                  'ARGS' => [
                              'i',
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 642 "src/ops/cmp.ops"
    const FLOATVAL l = VTABLE_get_number(interp, {{@2}});
    {{@1}} = l < {{@3}} ? -1 :
         l > {{@3}} ? +1 :
         0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => $ops->[346]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 347,
                  'ARGS' => [
                              'i',
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 642 "src/ops/cmp.ops"
    const FLOATVAL l = VTABLE_get_number(interp, {{@2}});
    {{@1}} = l < {{@3}} ? -1 :
         l > {{@3}} ? +1 :
         0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 348,
                  'ARGS' => [
                              'i',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 649 "src/ops/cmp.ops"
    STRING* const l = VTABLE_get_string(interp, {{@2}});
    {{@1}} = Parrot_str_compare(interp, l, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp',
                  'FLAGS' => $ops->[348]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 349,
                  'ARGS' => [
                              'i',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 649 "src/ops/cmp.ops"
    STRING* const l = VTABLE_get_string(interp, {{@2}});
    {{@1}} = Parrot_str_compare(interp, l, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp_str',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 350,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 654 "src/ops/cmp.ops"
    {{@1}} = VTABLE_cmp_string(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp_num',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 351,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 658 "src/ops/cmp.ops"
    {{@1}} = VTABLE_cmp_num(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cmp_pmc',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 352,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 670 "src/ops/cmp.ops"
    {{@1}} = VTABLE_cmp_pmc(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'issame',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 353,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 707 "src/ops/cmp.ops"
    if ({{@2}} == {{@3}})
        {{@1}} = 1;
    else
        {{@1}} = VTABLE_is_same(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'issame',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 354,
                  'ARGS' => [
                              'i',
                              's',
                              's'
                            ],
                  'BODY' => '#line 714 "src/ops/cmp.ops"
    {{@1}} = {{@2}} == {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'issame',
                  'FLAGS' => $ops->[354]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 355,
                  'ARGS' => [
                              'i',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 714 "src/ops/cmp.ops"
    {{@1}} = {{@2}} == {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'issame',
                  'FLAGS' => $ops->[354]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 356,
                  'ARGS' => [
                              'i',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 714 "src/ops/cmp.ops"
    {{@1}} = {{@2}} == {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'issame',
                  'FLAGS' => $ops->[354]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 357,
                  'ARGS' => [
                              'i',
                              'sc',
                              'sc'
                            ],
                  'BODY' => '#line 714 "src/ops/cmp.ops"
    {{@1}} = {{@2}} == {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isntsame',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 358,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 718 "src/ops/cmp.ops"
    if ({{@2}} == {{@3}})
        {{@1}} = 0;
    else
        {{@1}} = !VTABLE_is_same(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isntsame',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 359,
                  'ARGS' => [
                              'i',
                              's',
                              's'
                            ],
                  'BODY' => '#line 725 "src/ops/cmp.ops"
    {{@1}} = {{@2}} != {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isntsame',
                  'FLAGS' => $ops->[359]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 360,
                  'ARGS' => [
                              'i',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 725 "src/ops/cmp.ops"
    {{@1}} = {{@2}} != {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isntsame',
                  'FLAGS' => $ops->[359]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 361,
                  'ARGS' => [
                              'i',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 725 "src/ops/cmp.ops"
    {{@1}} = {{@2}} != {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isntsame',
                  'FLAGS' => $ops->[359]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 362,
                  'ARGS' => [
                              'i',
                              'sc',
                              'sc'
                            ],
                  'BODY' => '#line 725 "src/ops/cmp.ops"
    {{@1}} = {{@2}} != {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'istrue',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 363,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 729 "src/ops/cmp.ops"
    {{@1}} = VTABLE_get_bool(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isfalse',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 364,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 733 "src/ops/cmp.ops"
    {{@1}} = !VTABLE_get_bool(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isnull',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 365,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 737 "src/ops/cmp.ops"
    {{@1}} = PMC_IS_NULL({{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isnull',
                  'FLAGS' => $ops->[365]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 366,
                  'ARGS' => [
                              'i',
                              'pc'
                            ],
                  'BODY' => '#line 737 "src/ops/cmp.ops"
    {{@1}} = PMC_IS_NULL({{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isnull',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 367,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 741 "src/ops/cmp.ops"
    {{@1}} = STRING_IS_NULL({{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isnull',
                  'FLAGS' => $ops->[367]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 368,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 741 "src/ops/cmp.ops"
    {{@1}} = STRING_IS_NULL({{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isgt',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 369,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 759 "src/ops/cmp.ops"
    {{@1}} = (VTABLE_cmp(interp, {{@2}}, {{@3}}) > 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isge',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 370,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 777 "src/ops/cmp.ops"
    {{@1}} = (VTABLE_cmp(interp, {{@2}}, {{@3}}) >= 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isle',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 371,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 793 "src/ops/cmp.ops"
    {{@1}} = {{@2}} <= {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isle',
                  'FLAGS' => $ops->[371]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 372,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 793 "src/ops/cmp.ops"
    {{@1}} = {{@2}} <= {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isle',
                  'FLAGS' => $ops->[371]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 373,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 793 "src/ops/cmp.ops"
    {{@1}} = {{@2}} <= {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isle',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 374,
                  'ARGS' => [
                              'i',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 797 "src/ops/cmp.ops"
    {{@1}} = {{@2}} <= {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isle',
                  'FLAGS' => $ops->[374]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 375,
                  'ARGS' => [
                              'i',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 797 "src/ops/cmp.ops"
    {{@1}} = {{@2}} <= {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isle',
                  'FLAGS' => $ops->[374]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 376,
                  'ARGS' => [
                              'i',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 797 "src/ops/cmp.ops"
    {{@1}} = {{@2}} <= {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isle',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 377,
                  'ARGS' => [
                              'i',
                              's',
                              's'
                            ],
                  'BODY' => '#line 801 "src/ops/cmp.ops"
    {{@1}} = Parrot_str_compare(interp, {{@2}}, {{@3}}) <= 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isle',
                  'FLAGS' => $ops->[377]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 378,
                  'ARGS' => [
                              'i',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 801 "src/ops/cmp.ops"
    {{@1}} = Parrot_str_compare(interp, {{@2}}, {{@3}}) <= 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isle',
                  'FLAGS' => $ops->[377]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 379,
                  'ARGS' => [
                              'i',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 801 "src/ops/cmp.ops"
    {{@1}} = Parrot_str_compare(interp, {{@2}}, {{@3}}) <= 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isle',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 380,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 805 "src/ops/cmp.ops"
    {{@1}} = (VTABLE_cmp(interp, {{@2}}, {{@3}}) <= 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'islt',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 381,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 821 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} < {{@3}}) ? 1 : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'islt',
                  'FLAGS' => $ops->[381]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 382,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 821 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} < {{@3}}) ? 1 : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'islt',
                  'FLAGS' => $ops->[381]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 383,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 821 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} < {{@3}}) ? 1 : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'islt',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 384,
                  'ARGS' => [
                              'i',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 825 "src/ops/cmp.ops"
    {{@1}} = {{@2}} < {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'islt',
                  'FLAGS' => $ops->[384]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 385,
                  'ARGS' => [
                              'i',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 825 "src/ops/cmp.ops"
    {{@1}} = {{@2}} < {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'islt',
                  'FLAGS' => $ops->[384]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 386,
                  'ARGS' => [
                              'i',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 825 "src/ops/cmp.ops"
    {{@1}} = {{@2}} < {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'islt',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 387,
                  'ARGS' => [
                              'i',
                              's',
                              's'
                            ],
                  'BODY' => '#line 829 "src/ops/cmp.ops"
    {{@1}} = Parrot_str_compare(interp, {{@2}}, {{@3}}) < 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'islt',
                  'FLAGS' => $ops->[387]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 388,
                  'ARGS' => [
                              'i',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 829 "src/ops/cmp.ops"
    {{@1}} = Parrot_str_compare(interp, {{@2}}, {{@3}}) < 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'islt',
                  'FLAGS' => $ops->[387]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 389,
                  'ARGS' => [
                              'i',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 829 "src/ops/cmp.ops"
    {{@1}} = Parrot_str_compare(interp, {{@2}}, {{@3}}) < 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'islt',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 390,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 833 "src/ops/cmp.ops"
    {{@1}} = (VTABLE_cmp(interp, {{@2}}, {{@3}}) < 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iseq',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 391,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 849 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} == {{@3}}) ? 1 : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iseq',
                  'FLAGS' => $ops->[391]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 392,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 849 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} == {{@3}}) ? 1 : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iseq',
                  'FLAGS' => $ops->[391]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 393,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 849 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} == {{@3}}) ? 1 : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iseq',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 394,
                  'ARGS' => [
                              'i',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 853 "src/ops/cmp.ops"
    {{@1}} = {{@2}} == {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iseq',
                  'FLAGS' => $ops->[394]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 395,
                  'ARGS' => [
                              'i',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 853 "src/ops/cmp.ops"
    {{@1}} = {{@2}} == {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iseq',
                  'FLAGS' => $ops->[394]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 396,
                  'ARGS' => [
                              'i',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 853 "src/ops/cmp.ops"
    {{@1}} = {{@2}} == {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iseq',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 397,
                  'ARGS' => [
                              'i',
                              's',
                              's'
                            ],
                  'BODY' => '#line 857 "src/ops/cmp.ops"
    {{@1}} = (Parrot_str_equal(interp, {{@2}}, {{@3}}) ? 1 : 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iseq',
                  'FLAGS' => $ops->[397]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 398,
                  'ARGS' => [
                              'i',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 857 "src/ops/cmp.ops"
    {{@1}} = (Parrot_str_equal(interp, {{@2}}, {{@3}}) ? 1 : 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iseq',
                  'FLAGS' => $ops->[397]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 399,
                  'ARGS' => [
                              'i',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 857 "src/ops/cmp.ops"
    {{@1}} = (Parrot_str_equal(interp, {{@2}}, {{@3}}) ? 1 : 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iseq',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 400,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 861 "src/ops/cmp.ops"
    if (&{{@2}} == &{{@3}})
        {{@1}} = 1;
    else
        {{@1}} = VTABLE_is_equal(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isne',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 401,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 880 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} == {{@3}}) ? 0 : 1;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isne',
                  'FLAGS' => $ops->[401]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 402,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 880 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} == {{@3}}) ? 0 : 1;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isne',
                  'FLAGS' => $ops->[401]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 403,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 880 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} == {{@3}}) ? 0 : 1;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isne',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 404,
                  'ARGS' => [
                              'i',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 884 "src/ops/cmp.ops"
    {{@1}} = {{@2}} != {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isne',
                  'FLAGS' => $ops->[404]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 405,
                  'ARGS' => [
                              'i',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 884 "src/ops/cmp.ops"
    {{@1}} = {{@2}} != {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isne',
                  'FLAGS' => $ops->[404]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 406,
                  'ARGS' => [
                              'i',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 884 "src/ops/cmp.ops"
    {{@1}} = {{@2}} != {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isne',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 407,
                  'ARGS' => [
                              'i',
                              's',
                              's'
                            ],
                  'BODY' => '#line 888 "src/ops/cmp.ops"
    {{@1}} = (Parrot_str_not_equal(interp, {{@2}}, {{@3}}) ? 1 : 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isne',
                  'FLAGS' => $ops->[407]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 408,
                  'ARGS' => [
                              'i',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 888 "src/ops/cmp.ops"
    {{@1}} = (Parrot_str_not_equal(interp, {{@2}}, {{@3}}) ? 1 : 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isne',
                  'FLAGS' => $ops->[407]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 409,
                  'ARGS' => [
                              'i',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 888 "src/ops/cmp.ops"
    {{@1}} = (Parrot_str_not_equal(interp, {{@2}}, {{@3}}) ? 1 : 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isne',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 410,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 892 "src/ops/cmp.ops"
    if (&{{@2}} == &{{@3}})
        {{@1}} = 0;
    else
        {{@1}} = !VTABLE_is_equal(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'and',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 411,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 924 "src/ops/cmp.ops"
    {{@1}} = {{@2}} ? {{@3}} : {{@2}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'and',
                  'FLAGS' => $ops->[411]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 412,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 924 "src/ops/cmp.ops"
    {{@1}} = {{@2}} ? {{@3}} : {{@2}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'and',
                  'FLAGS' => $ops->[411]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 413,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 924 "src/ops/cmp.ops"
    {{@1}} = {{@2}} ? {{@3}} : {{@2}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'and',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 414,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 928 "src/ops/cmp.ops"
    {{@1}} = VTABLE_logical_and(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'not',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 415,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 946 "src/ops/cmp.ops"
    {{@1}} = ! {{@1}};

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'not',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 416,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 950 "src/ops/cmp.ops"
    {{@1}} = ! {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'not',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 417,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 954 "src/ops/cmp.ops"
    VTABLE_i_logical_not(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'not',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 418,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 958 "src/ops/cmp.ops"
    {{@1}} = VTABLE_logical_not(interp, {{@2}}, {{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'or',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 419,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 972 "src/ops/cmp.ops"
    {{@1}} = {{@2}} ? {{@2}} : {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'or',
                  'FLAGS' => $ops->[419]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 420,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 972 "src/ops/cmp.ops"
    {{@1}} = {{@2}} ? {{@2}} : {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'or',
                  'FLAGS' => $ops->[419]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 421,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 972 "src/ops/cmp.ops"
    {{@1}} = {{@2}} ? {{@2}} : {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'or',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 422,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 976 "src/ops/cmp.ops"
    {{@1}} = VTABLE_logical_or(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'xor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 423,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 991 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} && ! {{@3}}) ? {{@2}} : ({{@3}} && ! {{@2}}) ? {{@3}} : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'xor',
                  'FLAGS' => $ops->[423]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 424,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 991 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} && ! {{@3}}) ? {{@2}} : ({{@3}} && ! {{@2}}) ? {{@3}} : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'xor',
                  'FLAGS' => $ops->[423]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 425,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 991 "src/ops/cmp.ops"
    {{@1}} = ({{@2}} && ! {{@3}}) ? {{@2}} : ({{@3}} && ! {{@2}}) ? {{@3}} : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'xor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 426,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 995 "src/ops/cmp.ops"
    {{@1}} = VTABLE_logical_xor(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'debug_init',
                  'FLAGS' => {
                               '' => undef,
                               'base_debug' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 427,
                  'ARGS' => [],
                  'BODY' => '#line 45 "src/ops/debug.ops"
    Parrot_debugger_init(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'debug_load',
                  'FLAGS' => {
                               '' => undef,
                               'base_debug' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 428,
                  'ARGS' => [
                              'sc'
                            ],
                  'BODY' => '#line 57 "src/ops/debug.ops"
    Parrot_debugger_load(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'debug_break',
                  'FLAGS' => {
                               '' => undef,
                               'base_debug' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 429,
                  'ARGS' => [],
                  'BODY' => '#line 74 "src/ops/debug.ops"
    Parrot_debugger_break(interp, cur_opcode);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'debug_print',
                  'FLAGS' => {
                               '' => undef,
                               'base_debug' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 430,
                  'ARGS' => [],
                  'BODY' => '#line 86 "src/ops/debug.ops"
    if (!interp->pdb) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+1}},
            EXCEPTION_INVALID_OPERATION,
            "Initialize debugger with debug_init before using debug_print");
        {{=handler}};
    }

    if (!(interp->pdb->state & PDB_BREAK)) {
        PDB_print(interp, "I");
        PDB_print(interp, "N");
        PDB_print(interp, "S");
        PDB_print(interp, "P");
    }

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'backtrace',
                  'FLAGS' => {
                               '' => undef,
                               'base_debug' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 431,
                  'ARGS' => [],
                  'BODY' => '#line 108 "src/ops/debug.ops"
    PDB_backtrace(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getline',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 432,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 120 "src/ops/debug.ops"
    Parrot_Context_info info;
    Parrot_Context_get_info(interp, CURRENT_CONTEXT(interp), &info);
    {{@1}} = info.line;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getfile',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 433,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 132 "src/ops/debug.ops"
    Parrot_Context_info info;
    Parrot_Context_get_info(interp, CURRENT_CONTEXT(interp), &info);
    {{@1}} = info.file;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_label',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 434,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 71 "src/ops/experimental.ops"
    VTABLE_set_pointer(interp, {{@1}}, (CUR_OPCODE + {{@2}}));

{{+=3}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                1
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_label',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 435,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 75 "src/ops/experimental.ops"
    void * const ptr = VTABLE_get_pointer(interp, {{@2}});
    {{@1}} =  PTR2INTVAL(ptr);

{{+=3}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'close',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 436,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 43 "src/ops/io.ops"
    Parrot_io_close(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdopen',
                  'FLAGS' => {
                               '' => undef,
                               'filesys_open' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 437,
                  'ARGS' => [
                              'p',
                              'i',
                              's'
                            ],
                  'BODY' => '#line 55 "src/ops/io.ops"
    {{@1}} = Parrot_io_fdopen(interp, PMCNULL, (PIOHANDLE){{@2}}, {{@3}});
    if (!{{@1}})
        {{@1}} = pmc_new(interp, enum_class_Undef);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdopen',
                  'FLAGS' => $ops->[437]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 438,
                  'ARGS' => [
                              'p',
                              'ic',
                              's'
                            ],
                  'BODY' => '#line 55 "src/ops/io.ops"
    {{@1}} = Parrot_io_fdopen(interp, PMCNULL, (PIOHANDLE){{@2}}, {{@3}});
    if (!{{@1}})
        {{@1}} = pmc_new(interp, enum_class_Undef);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdopen',
                  'FLAGS' => $ops->[437]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 439,
                  'ARGS' => [
                              'p',
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 55 "src/ops/io.ops"
    {{@1}} = Parrot_io_fdopen(interp, PMCNULL, (PIOHANDLE){{@2}}, {{@3}});
    if (!{{@1}})
        {{@1}} = pmc_new(interp, enum_class_Undef);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdopen',
                  'FLAGS' => $ops->[437]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 440,
                  'ARGS' => [
                              'p',
                              'ic',
                              'sc'
                            ],
                  'BODY' => '#line 55 "src/ops/io.ops"
    {{@1}} = Parrot_io_fdopen(interp, PMCNULL, (PIOHANDLE){{@2}}, {{@3}});
    if (!{{@1}})
        {{@1}} = pmc_new(interp, enum_class_Undef);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getstdin',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 441,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 78 "src/ops/io.ops"
    {{@1}} = _PIO_STDIN(interp);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getstdout',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 442,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 82 "src/ops/io.ops"
    {{@1}} = _PIO_STDOUT(interp);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getstderr',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 443,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 86 "src/ops/io.ops"
    {{@1}} = _PIO_STDERR(interp);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setstdin',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 444,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 109 "src/ops/io.ops"
    _PIO_STDIN(interp) = {{@1}};

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setstdout',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 445,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 113 "src/ops/io.ops"
    _PIO_STDOUT(interp) = {{@1}};

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setstderr',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 446,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 117 "src/ops/io.ops"
    _PIO_STDERR(interp) = {{@1}};

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'open',
                  'FLAGS' => {
                               '' => undef,
                               'filesys_open' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 447,
                  'ARGS' => [
                              'p',
                              's',
                              's'
                            ],
                  'BODY' => '#line 142 "src/ops/io.ops"
    if (STRING_IS_NULL({{@2}}) || STRING_IS_NULL({{@3}})) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_UNEXPECTED_NULL, "Invalid open");
        {{=handler}};
    }
    else {
        {{@1}} = Parrot_io_open(interp, PMCNULL, {{@2}}, {{@3}});
        PARROT_ASSERT(! PMC_IS_NULL({{@1}}));
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'open',
                  'FLAGS' => $ops->[447]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 448,
                  'ARGS' => [
                              'p',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 142 "src/ops/io.ops"
    if (STRING_IS_NULL({{@2}}) || STRING_IS_NULL({{@3}})) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_UNEXPECTED_NULL, "Invalid open");
        {{=handler}};
    }
    else {
        {{@1}} = Parrot_io_open(interp, PMCNULL, {{@2}}, {{@3}});
        PARROT_ASSERT(! PMC_IS_NULL({{@1}}));
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'open',
                  'FLAGS' => $ops->[447]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 449,
                  'ARGS' => [
                              'p',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 142 "src/ops/io.ops"
    if (STRING_IS_NULL({{@2}}) || STRING_IS_NULL({{@3}})) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_UNEXPECTED_NULL, "Invalid open");
        {{=handler}};
    }
    else {
        {{@1}} = Parrot_io_open(interp, PMCNULL, {{@2}}, {{@3}});
        PARROT_ASSERT(! PMC_IS_NULL({{@1}}));
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'open',
                  'FLAGS' => $ops->[447]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 450,
                  'ARGS' => [
                              'p',
                              'sc',
                              'sc'
                            ],
                  'BODY' => '#line 142 "src/ops/io.ops"
    if (STRING_IS_NULL({{@2}}) || STRING_IS_NULL({{@3}})) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_UNEXPECTED_NULL, "Invalid open");
        {{=handler}};
    }
    else {
        {{@1}} = Parrot_io_open(interp, PMCNULL, {{@2}}, {{@3}});
        PARROT_ASSERT(! PMC_IS_NULL({{@1}}));
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'open',
                  'FLAGS' => {
                               '' => undef,
                               'filesys_open' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 451,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 154 "src/ops/io.ops"
    if (STRING_IS_NULL({{@2}})) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_UNEXPECTED_NULL, "Invalid open");
        {{=handler}};
    }
    else {
        {{@1}} = Parrot_io_open(interp, PMCNULL, {{@2}}, NULL);
        PARROT_ASSERT(! PMC_IS_NULL({{@1}}));
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'open',
                  'FLAGS' => $ops->[451]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 452,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 154 "src/ops/io.ops"
    if (STRING_IS_NULL({{@2}})) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_UNEXPECTED_NULL, "Invalid open");
        {{=handler}};
    }
    else {
        {{@1}} = Parrot_io_open(interp, PMCNULL, {{@2}}, NULL);
        PARROT_ASSERT(! PMC_IS_NULL({{@1}}));
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 453,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 180 "src/ops/io.ops"
    Parrot_io_printf(interp, INTVAL_FMT, (INTVAL){{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => $ops->[453]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 454,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 180 "src/ops/io.ops"
    Parrot_io_printf(interp, INTVAL_FMT, (INTVAL){{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 455,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 184 "src/ops/io.ops"
#ifdef PARROT_HAS_NEGATIVE_ZERO
    Parrot_io_printf(interp, FLOATVAL_FMT, {{@1}});
#else
    /* Workaround for older msvcrt and openbsd. TT #313 */
    if (Parrot_is_nzero({{@1}})) {
        Parrot_io_printf(interp, "-0");
    }
    else {
        Parrot_io_printf(interp, FLOATVAL_FMT, {{@1}});
    }
#endif

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => $ops->[455]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 456,
                  'ARGS' => [
                              'nc'
                            ],
                  'BODY' => '#line 184 "src/ops/io.ops"
#ifdef PARROT_HAS_NEGATIVE_ZERO
    Parrot_io_printf(interp, FLOATVAL_FMT, {{@1}});
#else
    /* Workaround for older msvcrt and openbsd. TT #313 */
    if (Parrot_is_nzero({{@1}})) {
        Parrot_io_printf(interp, "-0");
    }
    else {
        Parrot_io_printf(interp, FLOATVAL_FMT, {{@1}});
    }
#endif

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 457,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 198 "src/ops/io.ops"
    STRING * const s = {{@1}};
    if (s && Parrot_str_byte_length(interp, s))
        Parrot_io_putps(interp, _PIO_STDOUT(interp), s);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => $ops->[457]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 458,
                  'ARGS' => [
                              'sc'
                            ],
                  'BODY' => '#line 198 "src/ops/io.ops"
    STRING * const s = {{@1}};
    if (s && Parrot_str_byte_length(interp, s))
        Parrot_io_putps(interp, _PIO_STDOUT(interp), s);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 459,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 204 "src/ops/io.ops"
    PMC * const p = {{@1}};
    STRING * const s = (VTABLE_get_string(interp, p));
    if (s)
        Parrot_io_putps(interp, _PIO_STDOUT(interp), s);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'say',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 460,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 223 "src/ops/io.ops"
    Parrot_io_printf(interp, INTVAL_FMT "\\n", (INTVAL){{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'say',
                  'FLAGS' => $ops->[460]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 461,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 223 "src/ops/io.ops"
    Parrot_io_printf(interp, INTVAL_FMT "\\n", (INTVAL){{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'say',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 462,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 227 "src/ops/io.ops"
#ifdef PARROT_HAS_NEGATIVE_ZERO
    Parrot_io_printf(interp, FLOATVAL_FMT "\\n", {{@1}});
#else
    /* Workaround for older msvcrt and openbsd. TT #313 */
    if (Parrot_is_nzero({{@1}})) {
        Parrot_io_printf(interp, "-0\\n");
    }
    else {
        Parrot_io_printf(interp, FLOATVAL_FMT "\\n", {{@1}});
    }
#endif

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'say',
                  'FLAGS' => $ops->[462]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 463,
                  'ARGS' => [
                              'nc'
                            ],
                  'BODY' => '#line 227 "src/ops/io.ops"
#ifdef PARROT_HAS_NEGATIVE_ZERO
    Parrot_io_printf(interp, FLOATVAL_FMT "\\n", {{@1}});
#else
    /* Workaround for older msvcrt and openbsd. TT #313 */
    if (Parrot_is_nzero({{@1}})) {
        Parrot_io_printf(interp, "-0\\n");
    }
    else {
        Parrot_io_printf(interp, FLOATVAL_FMT "\\n", {{@1}});
    }
#endif

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'say',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 464,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 241 "src/ops/io.ops"
    STRING * const s = {{@1}};
    if (s && Parrot_str_byte_length(interp, s))
        Parrot_io_putps(interp, _PIO_STDOUT(interp), s);
    Parrot_io_putps(interp, _PIO_STDOUT(interp), Parrot_str_new_constant(interp, "\\n"));

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'say',
                  'FLAGS' => $ops->[464]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 465,
                  'ARGS' => [
                              'sc'
                            ],
                  'BODY' => '#line 241 "src/ops/io.ops"
    STRING * const s = {{@1}};
    if (s && Parrot_str_byte_length(interp, s))
        Parrot_io_putps(interp, _PIO_STDOUT(interp), s);
    Parrot_io_putps(interp, _PIO_STDOUT(interp), Parrot_str_new_constant(interp, "\\n"));

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'say',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 466,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 248 "src/ops/io.ops"
    PMC * const p = {{@1}};

    if (PMC_IS_NULL(p)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+2}},
             EXCEPTION_UNEXPECTED_NULL,
            "Null PMC in say");
        {{=handler}};
    }
    else {
        STRING * const s = VTABLE_get_string(interp, p);
        if (s)
            Parrot_io_putps(interp, _PIO_STDOUT(interp), s);
        Parrot_io_putps(interp, _PIO_STDOUT(interp), Parrot_str_new_constant(interp, "\\n"));
    }

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'printerr',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 467,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 282 "src/ops/io.ops"
    Parrot_io_eprintf(interp, INTVAL_FMT, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'printerr',
                  'FLAGS' => $ops->[467]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 468,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 282 "src/ops/io.ops"
    Parrot_io_eprintf(interp, INTVAL_FMT, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'printerr',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 469,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 286 "src/ops/io.ops"
    Parrot_io_eprintf(interp, FLOATVAL_FMT, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'printerr',
                  'FLAGS' => $ops->[469]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 470,
                  'ARGS' => [
                              'nc'
                            ],
                  'BODY' => '#line 286 "src/ops/io.ops"
    Parrot_io_eprintf(interp, FLOATVAL_FMT, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'printerr',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 471,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 290 "src/ops/io.ops"
    STRING * const s = {{@1}};
    if (s && Parrot_str_byte_length(interp, s))
        Parrot_io_putps(interp, _PIO_STDERR(interp), s);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'printerr',
                  'FLAGS' => $ops->[471]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 472,
                  'ARGS' => [
                              'sc'
                            ],
                  'BODY' => '#line 290 "src/ops/io.ops"
    STRING * const s = {{@1}};
    if (s && Parrot_str_byte_length(interp, s))
        Parrot_io_putps(interp, _PIO_STDERR(interp), s);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'printerr',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 473,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 296 "src/ops/io.ops"
    PMC * const p = {{@1}};
    STRING * const s = (VTABLE_get_string(interp, p));
    if (s)
        Parrot_io_putps(interp, _PIO_STDERR(interp), s);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 474,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 317 "src/ops/io.ops"
    if ({{@1}}) {
        STRING * const s = Parrot_str_from_int(interp, {{@2}});
        Parrot_io_putps(interp, {{@1}}, s);
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => $ops->[474]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 475,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 317 "src/ops/io.ops"
    if ({{@1}}) {
        STRING * const s = Parrot_str_from_int(interp, {{@2}});
        Parrot_io_putps(interp, {{@1}}, s);
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 476,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 324 "src/ops/io.ops"
    if ({{@1}}) {
        STRING * const s = Parrot_sprintf_c(interp, FLOATVAL_FMT, {{@2}});
        Parrot_io_putps(interp, {{@1}}, s);
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => $ops->[476]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 477,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 324 "src/ops/io.ops"
    if ({{@1}}) {
        STRING * const s = Parrot_sprintf_c(interp, FLOATVAL_FMT, {{@2}});
        Parrot_io_putps(interp, {{@1}}, s);
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 478,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 331 "src/ops/io.ops"
    if ({{@2}} && {{@1}}) {
        Parrot_io_putps(interp, {{@1}}, {{@2}});
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => $ops->[478]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 479,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 331 "src/ops/io.ops"
    if ({{@2}} && {{@1}}) {
        Parrot_io_putps(interp, {{@1}}, {{@2}});
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'print',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 480,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 337 "src/ops/io.ops"
    if ({{@2}} && {{@1}}) {
        STRING * const s = VTABLE_get_string(interp, {{@2}});
        Parrot_io_putps(interp, {{@1}}, s);
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'read',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 481,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 356 "src/ops/io.ops"
    {{@1}} = Parrot_io_reads(interp, _PIO_STDIN(interp), (size_t){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'read',
                  'FLAGS' => $ops->[481]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 482,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 356 "src/ops/io.ops"
    {{@1}} = Parrot_io_reads(interp, _PIO_STDIN(interp), (size_t){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'read',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 483,
                  'ARGS' => [
                              's',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 360 "src/ops/io.ops"
    {{@1}} = Parrot_io_reads(interp, {{@2}}, (size_t){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'read',
                  'FLAGS' => $ops->[483]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 484,
                  'ARGS' => [
                              's',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 360 "src/ops/io.ops"
    {{@1}} = Parrot_io_reads(interp, {{@2}}, (size_t){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'readline',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 485,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 371 "src/ops/io.ops"
    {{@1}} = Parrot_io_readline(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'peek',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 486,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 389 "src/ops/io.ops"
    STRING ** const s = &{{@1}};

    *s = NULL;
    if (Parrot_io_peek(interp, _PIO_STDIN(interp), s) < 0) {
        {{@1}} = Parrot_str_new_noinit(interp, enum_stringrep_one, 0);
    }

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'peek',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 487,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 398 "src/ops/io.ops"
    STRING ** const s = &{{@1}};

    *s = NULL;
    if (Parrot_io_peek(interp, {{@2}}, s) < 0) {
        {{@1}} = Parrot_str_new_noinit(interp, enum_stringrep_one, 0);
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'stat',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 488,
                  'ARGS' => [
                              'i',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 431 "src/ops/io.ops"
    {{@1}} = Parrot_stat_info_intval(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'stat',
                  'FLAGS' => $ops->[488]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 489,
                  'ARGS' => [
                              'i',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 431 "src/ops/io.ops"
    {{@1}} = Parrot_stat_info_intval(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'stat',
                  'FLAGS' => $ops->[488]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 490,
                  'ARGS' => [
                              'i',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 431 "src/ops/io.ops"
    {{@1}} = Parrot_stat_info_intval(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'stat',
                  'FLAGS' => $ops->[488]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 491,
                  'ARGS' => [
                              'i',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 431 "src/ops/io.ops"
    {{@1}} = Parrot_stat_info_intval(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'stat',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 492,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 435 "src/ops/io.ops"
    {{@1}} = Parrot_fstat_info_intval(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'stat',
                  'FLAGS' => $ops->[492]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 493,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 435 "src/ops/io.ops"
    {{@1}} = Parrot_fstat_info_intval(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'stat',
                  'FLAGS' => $ops->[492]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 494,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 435 "src/ops/io.ops"
    {{@1}} = Parrot_fstat_info_intval(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'stat',
                  'FLAGS' => $ops->[492]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 495,
                  'ARGS' => [
                              'i',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 435 "src/ops/io.ops"
    {{@1}} = Parrot_fstat_info_intval(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'seek',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 496,
                  'ARGS' => [
                              'p',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 465 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset({{@2}}), {{@3}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_PIO_ERROR,
                "seek failed (32bit)");
            {{=handler}};
        }
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'seek',
                  'FLAGS' => $ops->[496]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 497,
                  'ARGS' => [
                              'p',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 465 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset({{@2}}), {{@3}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_PIO_ERROR,
                "seek failed (32bit)");
            {{=handler}};
        }
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'seek',
                  'FLAGS' => $ops->[496]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 498,
                  'ARGS' => [
                              'p',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 465 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset({{@2}}), {{@3}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_PIO_ERROR,
                "seek failed (32bit)");
            {{=handler}};
        }
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'seek',
                  'FLAGS' => $ops->[496]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 499,
                  'ARGS' => [
                              'p',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 465 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset({{@2}}), {{@3}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_PIO_ERROR,
                "seek failed (32bit)");
            {{=handler}};
        }
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'seek',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 500,
                  'ARGS' => [
                              'p',
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 476 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset32({{@2}}, {{@3}}), {{@4}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+5}},
                EXCEPTION_PIO_ERROR,
                "seek failed (64bit)");
            {{=handler}};
        }
    }

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'seek',
                  'FLAGS' => $ops->[500]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 501,
                  'ARGS' => [
                              'p',
                              'ic',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 476 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset32({{@2}}, {{@3}}), {{@4}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+5}},
                EXCEPTION_PIO_ERROR,
                "seek failed (64bit)");
            {{=handler}};
        }
    }

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'seek',
                  'FLAGS' => $ops->[500]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 502,
                  'ARGS' => [
                              'p',
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 476 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset32({{@2}}, {{@3}}), {{@4}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+5}},
                EXCEPTION_PIO_ERROR,
                "seek failed (64bit)");
            {{=handler}};
        }
    }

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'seek',
                  'FLAGS' => $ops->[500]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 503,
                  'ARGS' => [
                              'p',
                              'ic',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 476 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset32({{@2}}, {{@3}}), {{@4}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+5}},
                EXCEPTION_PIO_ERROR,
                "seek failed (64bit)");
            {{=handler}};
        }
    }

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'seek',
                  'FLAGS' => $ops->[500]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 504,
                  'ARGS' => [
                              'p',
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 476 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset32({{@2}}, {{@3}}), {{@4}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+5}},
                EXCEPTION_PIO_ERROR,
                "seek failed (64bit)");
            {{=handler}};
        }
    }

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'seek',
                  'FLAGS' => $ops->[500]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 505,
                  'ARGS' => [
                              'p',
                              'ic',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 476 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset32({{@2}}, {{@3}}), {{@4}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+5}},
                EXCEPTION_PIO_ERROR,
                "seek failed (64bit)");
            {{=handler}};
        }
    }

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'seek',
                  'FLAGS' => $ops->[500]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 506,
                  'ARGS' => [
                              'p',
                              'i',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 476 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset32({{@2}}, {{@3}}), {{@4}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+5}},
                EXCEPTION_PIO_ERROR,
                "seek failed (64bit)");
            {{=handler}};
        }
    }

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'seek',
                  'FLAGS' => $ops->[500]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 507,
                  'ARGS' => [
                              'p',
                              'ic',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 476 "src/ops/io.ops"
    if ({{@1}}) {
        if (Parrot_io_seek(interp, {{@1}}, Parrot_io_make_offset32({{@2}}, {{@3}}), {{@4}}) < 0) {
            opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+5}},
                EXCEPTION_PIO_ERROR,
                "seek failed (64bit)");
            {{=handler}};
        }
    }

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'tell',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 508,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 502 "src/ops/io.ops"
    if ({{@2}})
        {{@1}} = (INTVAL)Parrot_io_tell(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'tell',
                  'FLAGS' => {
                               '' => undef,
                               'base_io' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 509,
                  'ARGS' => [
                              'i',
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 507 "src/ops/io.ops"
    if ({{@3}}) {
        PIOOFF_T pos;
        pos = Parrot_io_tell(interp, {{@3}});
        {{@1}} = (INTVAL)(pos >> 31);
        {{@2}} = (INTVAL)(pos & 0xffffffff);
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'abs',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 510,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 47 "src/ops/math.ops"
    {{@1}} = abs({{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'abs',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 511,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 51 "src/ops/math.ops"
    {{@1}} = fabs({{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'abs',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 512,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 55 "src/ops/math.ops"
    if ({{@2}} < 0)
        {{@1}} = - (INTVAL){{@2}};
    else
        {{@1}} = (INTVAL){{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'abs',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 513,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 62 "src/ops/math.ops"
    if ({{@2}} < 0)
        {{@1}} = - (FLOATVAL){{@2}};
    else
        {{@1}} = (FLOATVAL){{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'abs',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 514,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 69 "src/ops/math.ops"
    VTABLE_i_absolute(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'abs',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 515,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 73 "src/ops/math.ops"
    {{@1}} = VTABLE_absolute(interp, {{@2}}, {{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 516,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 105 "src/ops/math.ops"
    {{@1}} += {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => $ops->[516]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 517,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 105 "src/ops/math.ops"
    {{@1}} += {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 518,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 109 "src/ops/math.ops"
    {{@1}} += {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => $ops->[518]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 519,
                  'ARGS' => [
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 109 "src/ops/math.ops"
    {{@1}} += {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 520,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 113 "src/ops/math.ops"
    VTABLE_i_add(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 521,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 117 "src/ops/math.ops"
    VTABLE_i_add_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => $ops->[521]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 522,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 117 "src/ops/math.ops"
    VTABLE_i_add_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 523,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 121 "src/ops/math.ops"
    VTABLE_i_add_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => $ops->[523]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 524,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 121 "src/ops/math.ops"
    VTABLE_i_add_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 525,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 125 "src/ops/math.ops"
    {{@1}} = {{@2}} + {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => $ops->[525]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 526,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 125 "src/ops/math.ops"
    {{@1}} = {{@2}} + {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => $ops->[525]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 527,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 125 "src/ops/math.ops"
    {{@1}} = {{@2}} + {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 528,
                  'ARGS' => [
                              'n',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 129 "src/ops/math.ops"
    {{@1}} = {{@2}} + {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => $ops->[528]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 529,
                  'ARGS' => [
                              'n',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 129 "src/ops/math.ops"
    {{@1}} = {{@2}} + {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => $ops->[528]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 530,
                  'ARGS' => [
                              'n',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 129 "src/ops/math.ops"
    {{@1}} = {{@2}} + {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 531,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 133 "src/ops/math.ops"
    {{@1}} = VTABLE_add(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 532,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 137 "src/ops/math.ops"
    {{@1}} = VTABLE_add_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => $ops->[532]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 533,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 137 "src/ops/math.ops"
    {{@1}} = VTABLE_add_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 534,
                  'ARGS' => [
                              'p',
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 141 "src/ops/math.ops"
    {{@1}} = VTABLE_add_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add',
                  'FLAGS' => $ops->[534]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 535,
                  'ARGS' => [
                              'p',
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 141 "src/ops/math.ops"
    {{@1}} = VTABLE_add_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 536,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 186 "src/ops/math.ops"
    INTVAL den = {{@3}};
    if ({{@3}} == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} % den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => $ops->[536]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 537,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 186 "src/ops/math.ops"
    INTVAL den = {{@3}};
    if ({{@3}} == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} % den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => $ops->[536]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 538,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 186 "src/ops/math.ops"
    INTVAL den = {{@3}};
    if ({{@3}} == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} % den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 539,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 197 "src/ops/math.ops"
    INTVAL result;

    if ({{@3}} == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }

    result = VTABLE_get_integer(interp, {{@2}}) % {{@3}};

    {{@1}} = pmc_new(interp, VTABLE_type(interp, {{@2}}));
    VTABLE_set_integer_native(interp, {{@1}}, result);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => $ops->[539]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 540,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 197 "src/ops/math.ops"
    INTVAL result;

    if ({{@3}} == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }

    result = VTABLE_get_integer(interp, {{@2}}) % {{@3}};

    {{@1}} = pmc_new(interp, VTABLE_type(interp, {{@2}}));
    VTABLE_set_integer_native(interp, {{@1}}, result);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 541,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 213 "src/ops/math.ops"
    INTVAL result;
    INTVAL value = VTABLE_get_integer(interp, {{@3}});

    if (value == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }

    result = VTABLE_get_integer(interp, {{@2}}) % value;

    {{@1}} = pmc_new(interp, VTABLE_type(interp, {{@2}}));
    VTABLE_set_integer_native(interp, {{@1}}, result);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 542,
                  'ARGS' => [
                              'n',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 263 "src/ops/math.ops"
    FLOATVAL den = {{@3}};
    if (FLOAT_IS_ZERO({{@3}})) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = fmod({{@2}}, den);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => $ops->[542]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 543,
                  'ARGS' => [
                              'n',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 263 "src/ops/math.ops"
    FLOATVAL den = {{@3}};
    if (FLOAT_IS_ZERO({{@3}})) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = fmod({{@2}}, den);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => $ops->[542]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 544,
                  'ARGS' => [
                              'n',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 263 "src/ops/math.ops"
    FLOATVAL den = {{@3}};
    if (FLOAT_IS_ZERO({{@3}})) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = fmod({{@2}}, den);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 545,
                  'ARGS' => [
                              'p',
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 274 "src/ops/math.ops"
    FLOATVAL result;
    FLOATVAL value = {{@3}};

    if (FLOAT_IS_ZERO(value)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }

    result = fmod(VTABLE_get_integer(interp, {{@2}}), value);

    {{@1}} = pmc_new(interp, VTABLE_type(interp, {{@2}}));
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL) result);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'cmod',
                  'FLAGS' => $ops->[545]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 546,
                  'ARGS' => [
                              'p',
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 274 "src/ops/math.ops"
    FLOATVAL result;
    FLOATVAL value = {{@3}};

    if (FLOAT_IS_ZERO(value)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }

    result = fmod(VTABLE_get_integer(interp, {{@2}}), value);

    {{@1}} = pmc_new(interp, VTABLE_type(interp, {{@2}}));
    VTABLE_set_integer_native(interp, {{@1}}, (INTVAL) result);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'dec',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 547,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 303 "src/ops/math.ops"
    {{@1}}--;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'dec',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 548,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 307 "src/ops/math.ops"
    {{@1}}--;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'dec',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 549,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 311 "src/ops/math.ops"
    VTABLE_decrement(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'div',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 550,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 345 "src/ops/math.ops"
    INTVAL den = {{@2}};
    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} /= den;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[550]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 551,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 345 "src/ops/math.ops"
    INTVAL den = {{@2}};
    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} /= den;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'div',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 552,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 356 "src/ops/math.ops"
    FLOATVAL den = {{@2}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} /= den;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[552]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 553,
                  'ARGS' => [
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 356 "src/ops/math.ops"
    FLOATVAL den = {{@2}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} /= den;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'div',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 554,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 367 "src/ops/math.ops"
    VTABLE_i_divide(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'div',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 555,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 371 "src/ops/math.ops"
    VTABLE_i_divide_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[555]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 556,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 371 "src/ops/math.ops"
    VTABLE_i_divide_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'div',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 557,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 375 "src/ops/math.ops"
    VTABLE_i_divide_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[557]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 558,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 375 "src/ops/math.ops"
    VTABLE_i_divide_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'div',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 559,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 378 "src/ops/math.ops"
    INTVAL den = {{@3}};
    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} / den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[559]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 560,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 378 "src/ops/math.ops"
    INTVAL den = {{@3}};
    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} / den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[559]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 561,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 378 "src/ops/math.ops"
    INTVAL den = {{@3}};
    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} / den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[559]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 562,
                  'ARGS' => [
                              'i',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 378 "src/ops/math.ops"
    INTVAL den = {{@3}};
    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} / den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'div',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 563,
                  'ARGS' => [
                              'n',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 389 "src/ops/math.ops"
    FLOATVAL den = {{@3}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} / den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[563]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 564,
                  'ARGS' => [
                              'n',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 389 "src/ops/math.ops"
    FLOATVAL den = {{@3}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} / den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[563]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 565,
                  'ARGS' => [
                              'n',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 389 "src/ops/math.ops"
    FLOATVAL den = {{@3}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} / den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[563]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 566,
                  'ARGS' => [
                              'n',
                              'nc',
                              'nc'
                            ],
                  'BODY' => '#line 389 "src/ops/math.ops"
    FLOATVAL den = {{@3}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = {{@2}} / den;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'div',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 567,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 400 "src/ops/math.ops"
    {{@1}} = VTABLE_divide(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'div',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 568,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 404 "src/ops/math.ops"
    {{@1}} = VTABLE_divide_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[568]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 569,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 404 "src/ops/math.ops"
    {{@1}} = VTABLE_divide_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'div',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 570,
                  'ARGS' => [
                              'p',
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 408 "src/ops/math.ops"
    {{@1}} = VTABLE_divide_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'div',
                  'FLAGS' => $ops->[570]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 571,
                  'ARGS' => [
                              'p',
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 408 "src/ops/math.ops"
    {{@1}} = VTABLE_divide_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'fdiv',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 572,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 441 "src/ops/math.ops"
    INTVAL   den = {{@2}};
    FLOATVAL f;

    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }

    f  = floor({{@1}} / den);
    {{@1}} = (INTVAL)f;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fdiv',
                  'FLAGS' => $ops->[572]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 573,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 441 "src/ops/math.ops"
    INTVAL   den = {{@2}};
    FLOATVAL f;

    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }

    f  = floor({{@1}} / den);
    {{@1}} = (INTVAL)f;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fdiv',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 574,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 456 "src/ops/math.ops"
    FLOATVAL den = {{@2}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = floor({{@1}} / den);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fdiv',
                  'FLAGS' => $ops->[574]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 575,
                  'ARGS' => [
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 456 "src/ops/math.ops"
    FLOATVAL den = {{@2}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = floor({{@1}} / den);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdiv',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 576,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 467 "src/ops/math.ops"
    VTABLE_i_floor_divide(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdiv',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 577,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 471 "src/ops/math.ops"
    VTABLE_i_floor_divide_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdiv',
                  'FLAGS' => $ops->[577]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 578,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 471 "src/ops/math.ops"
    VTABLE_i_floor_divide_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdiv',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 579,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 475 "src/ops/math.ops"
    VTABLE_i_floor_divide_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdiv',
                  'FLAGS' => $ops->[579]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 580,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 475 "src/ops/math.ops"
    VTABLE_i_floor_divide_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'fdiv',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 581,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 479 "src/ops/math.ops"
    INTVAL   den = {{@3}};
    FLOATVAL f;

    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }

    f  = floor({{@2}} / den);
    {{@1}} = (INTVAL)f;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'fdiv',
                  'FLAGS' => $ops->[581]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 582,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 479 "src/ops/math.ops"
    INTVAL   den = {{@3}};
    FLOATVAL f;

    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }

    f  = floor({{@2}} / den);
    {{@1}} = (INTVAL)f;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fdiv',
                  'FLAGS' => $ops->[581]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 583,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 479 "src/ops/math.ops"
    INTVAL   den = {{@3}};
    FLOATVAL f;

    if (den == 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }

    f  = floor({{@2}} / den);
    {{@1}} = (INTVAL)f;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fdiv',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 584,
                  'ARGS' => [
                              'n',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 494 "src/ops/math.ops"
    FLOATVAL den = {{@3}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = floor({{@2}} / den);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fdiv',
                  'FLAGS' => $ops->[584]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 585,
                  'ARGS' => [
                              'n',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 494 "src/ops/math.ops"
    FLOATVAL den = {{@3}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = floor({{@2}} / den);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fdiv',
                  'FLAGS' => $ops->[584]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 586,
                  'ARGS' => [
                              'n',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 494 "src/ops/math.ops"
    FLOATVAL den = {{@3}};
    if (FLOAT_IS_ZERO(den)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
        {{=handler}};
    }
    {{@1}} = floor({{@2}} / den);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdiv',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 587,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 505 "src/ops/math.ops"
    {{@1}} = VTABLE_floor_divide(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdiv',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 588,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 509 "src/ops/math.ops"
    {{@1}} = VTABLE_floor_divide_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdiv',
                  'FLAGS' => $ops->[588]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 589,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 509 "src/ops/math.ops"
    {{@1}} = VTABLE_floor_divide_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdiv',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 590,
                  'ARGS' => [
                              'p',
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 513 "src/ops/math.ops"
    {{@1}} = VTABLE_floor_divide_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fdiv',
                  'FLAGS' => $ops->[590]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 591,
                  'ARGS' => [
                              'p',
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 513 "src/ops/math.ops"
    {{@1}} = VTABLE_floor_divide_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'ceil',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 592,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 531 "src/ops/math.ops"
    {{@1}} = ceil({{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'ceil',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 593,
                  'ARGS' => [
                              'i',
                              'n'
                            ],
                  'BODY' => '#line 535 "src/ops/math.ops"
    FLOATVAL f = ceil({{@2}});
    {{@1}}         = (INTVAL)f;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'ceil',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 594,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 540 "src/ops/math.ops"
    {{@1}} = ceil({{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'floor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 595,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 558 "src/ops/math.ops"
    {{@1}} = floor({{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'floor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 596,
                  'ARGS' => [
                              'i',
                              'n'
                            ],
                  'BODY' => '#line 562 "src/ops/math.ops"
    FLOATVAL f = floor({{@2}});
    {{@1}}         = (INTVAL)f;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'floor',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 597,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 567 "src/ops/math.ops"
    {{@1}} = floor({{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'inc',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 598,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 583 "src/ops/math.ops"
    {{@1}}++;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'inc',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 599,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 587 "src/ops/math.ops"
    {{@1}}++;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'inc',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 600,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 591 "src/ops/math.ops"
    VTABLE_increment(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 601,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 643 "src/ops/math.ops"
    {{@1}} = intval_mod({{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => $ops->[601]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 602,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 643 "src/ops/math.ops"
    {{@1}} = intval_mod({{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 603,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 647 "src/ops/math.ops"
    {{@1}} = floatval_mod({{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => $ops->[603]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 604,
                  'ARGS' => [
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 647 "src/ops/math.ops"
    {{@1}} = floatval_mod({{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 605,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 651 "src/ops/math.ops"
    VTABLE_i_modulus(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 606,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 655 "src/ops/math.ops"
    VTABLE_i_modulus_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => $ops->[606]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 607,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 655 "src/ops/math.ops"
    VTABLE_i_modulus_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 608,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 659 "src/ops/math.ops"
    VTABLE_i_modulus_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => $ops->[608]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 609,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 659 "src/ops/math.ops"
    VTABLE_i_modulus_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 610,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 663 "src/ops/math.ops"
    {{@1}} = intval_mod({{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => $ops->[610]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 611,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 663 "src/ops/math.ops"
    {{@1}} = intval_mod({{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => $ops->[610]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 612,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 663 "src/ops/math.ops"
    {{@1}} = intval_mod({{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 613,
                  'ARGS' => [
                              'n',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 667 "src/ops/math.ops"
    {{@1}} = floatval_mod({{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => $ops->[613]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 614,
                  'ARGS' => [
                              'n',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 667 "src/ops/math.ops"
    {{@1}} = floatval_mod({{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => $ops->[613]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 615,
                  'ARGS' => [
                              'n',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 667 "src/ops/math.ops"
    {{@1}} = floatval_mod({{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 616,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 671 "src/ops/math.ops"
    {{@1}} = VTABLE_modulus(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 617,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 675 "src/ops/math.ops"
    {{@1}} = VTABLE_modulus_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => $ops->[617]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 618,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 675 "src/ops/math.ops"
    {{@1}} = VTABLE_modulus_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 619,
                  'ARGS' => [
                              'p',
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 679 "src/ops/math.ops"
    {{@1}} = VTABLE_modulus_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mod',
                  'FLAGS' => $ops->[619]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 620,
                  'ARGS' => [
                              'p',
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 679 "src/ops/math.ops"
    {{@1}} = VTABLE_modulus_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 621,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 711 "src/ops/math.ops"
    {{@1}} *= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => $ops->[621]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 622,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 711 "src/ops/math.ops"
    {{@1}} *= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 623,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 715 "src/ops/math.ops"
    {{@1}} *= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => $ops->[623]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 624,
                  'ARGS' => [
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 715 "src/ops/math.ops"
    {{@1}} *= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 625,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 719 "src/ops/math.ops"
    VTABLE_i_multiply(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 626,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 723 "src/ops/math.ops"
    VTABLE_i_multiply_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => $ops->[626]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 627,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 723 "src/ops/math.ops"
    VTABLE_i_multiply_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 628,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 727 "src/ops/math.ops"
    VTABLE_i_multiply_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => $ops->[628]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 629,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 727 "src/ops/math.ops"
    VTABLE_i_multiply_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 630,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 731 "src/ops/math.ops"
    {{@1}} = {{@2}} * {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => $ops->[630]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 631,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 731 "src/ops/math.ops"
    {{@1}} = {{@2}} * {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => $ops->[630]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 632,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 731 "src/ops/math.ops"
    {{@1}} = {{@2}} * {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 633,
                  'ARGS' => [
                              'n',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 735 "src/ops/math.ops"
    {{@1}} = {{@2}} * {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => $ops->[633]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 634,
                  'ARGS' => [
                              'n',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 735 "src/ops/math.ops"
    {{@1}} = {{@2}} * {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => $ops->[633]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 635,
                  'ARGS' => [
                              'n',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 735 "src/ops/math.ops"
    {{@1}} = {{@2}} * {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 636,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 739 "src/ops/math.ops"
    {{@1}} = VTABLE_multiply(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 637,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 743 "src/ops/math.ops"
    {{@1}} = VTABLE_multiply_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => $ops->[637]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 638,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 743 "src/ops/math.ops"
    {{@1}} = VTABLE_multiply_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 639,
                  'ARGS' => [
                              'p',
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 747 "src/ops/math.ops"
    {{@1}} = VTABLE_multiply_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'mul',
                  'FLAGS' => $ops->[639]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 640,
                  'ARGS' => [
                              'p',
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 747 "src/ops/math.ops"
    {{@1}} = VTABLE_multiply_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'neg',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 641,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 771 "src/ops/math.ops"
    {{@1}} = - {{@1}};

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'neg',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 642,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 775 "src/ops/math.ops"
    {{@1}} = - {{@1}};

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'neg',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 643,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 779 "src/ops/math.ops"
    VTABLE_i_neg(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'neg',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 644,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 783 "src/ops/math.ops"
    {{@1}} = - {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'neg',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 645,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 787 "src/ops/math.ops"
    {{@1}} = - {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'neg',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 646,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 791 "src/ops/math.ops"
    {{@1}} = VTABLE_neg(interp, {{@2}}, {{@1}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 647,
                  'ARGS' => [
                              'n',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 811 "src/ops/math.ops"
    {{@1}} = pow((FLOATVAL){{@2}}, (FLOATVAL){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => $ops->[647]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 648,
                  'ARGS' => [
                              'n',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 811 "src/ops/math.ops"
    {{@1}} = pow((FLOATVAL){{@2}}, (FLOATVAL){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => $ops->[647]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 649,
                  'ARGS' => [
                              'n',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 811 "src/ops/math.ops"
    {{@1}} = pow((FLOATVAL){{@2}}, (FLOATVAL){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 650,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 815 "src/ops/math.ops"
    const FLOATVAL a = VTABLE_get_number(interp, {{@2}});
    const FLOATVAL b = VTABLE_get_number(interp, {{@3}});
    const FLOATVAL c = pow(a, b);
    if (PMC_IS_NULL({{@1}}))
        {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Float));
    else
        {{@1}} = pmc_new(interp, {{@1}}->vtable->base_type);
    VTABLE_set_number_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 651,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 826 "src/ops/math.ops"
    const FLOATVAL a = VTABLE_get_number(interp, {{@2}});
    const FLOATVAL b = (FLOATVAL){{@3}};
    const FLOATVAL c = pow(a, b);
    if (PMC_IS_NULL({{@1}}))
        {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Float));
    else
        {{@1}} = pmc_new(interp, {{@1}}->vtable->base_type);
    VTABLE_set_number_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => $ops->[651]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 652,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 826 "src/ops/math.ops"
    const FLOATVAL a = VTABLE_get_number(interp, {{@2}});
    const FLOATVAL b = (FLOATVAL){{@3}};
    const FLOATVAL c = pow(a, b);
    if (PMC_IS_NULL({{@1}}))
        {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Float));
    else
        {{@1}} = pmc_new(interp, {{@1}}->vtable->base_type);
    VTABLE_set_number_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 653,
                  'ARGS' => [
                              'p',
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 837 "src/ops/math.ops"
    const FLOATVAL a = VTABLE_get_number(interp, {{@2}});
    const FLOATVAL c = pow(a, {{@3}});
    if (PMC_IS_NULL({{@1}}))
        {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Float));
    else
        {{@1}} = pmc_new(interp, {{@1}}->vtable->base_type);
    VTABLE_set_number_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => $ops->[653]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 654,
                  'ARGS' => [
                              'p',
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 837 "src/ops/math.ops"
    const FLOATVAL a = VTABLE_get_number(interp, {{@2}});
    const FLOATVAL c = pow(a, {{@3}});
    if (PMC_IS_NULL({{@1}}))
        {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Float));
    else
        {{@1}} = pmc_new(interp, {{@1}}->vtable->base_type);
    VTABLE_set_number_native(interp, {{@1}}, c);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 655,
                  'ARGS' => [
                              'n',
                              'n',
                              'i'
                            ],
                  'BODY' => '#line 847 "src/ops/math.ops"
    FLOATVAL n2 = {{@2}};
    FLOATVAL res = 1.0;
    INTVAL   e  = {{@3}};
    int s = 1;
    if (e != 0) {
        if (e < 0) {
            s = -1;
            e = -e;
        }
    }
    while (e) {
        if (e & 1) {
            res *= n2;
        }
        n2 *= n2;
        e >>= 1;
    }
    if (s < 0) {
        res = 1.0/res;
    }
    {{@1}} = res;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => $ops->[655]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 656,
                  'ARGS' => [
                              'n',
                              'nc',
                              'i'
                            ],
                  'BODY' => '#line 847 "src/ops/math.ops"
    FLOATVAL n2 = {{@2}};
    FLOATVAL res = 1.0;
    INTVAL   e  = {{@3}};
    int s = 1;
    if (e != 0) {
        if (e < 0) {
            s = -1;
            e = -e;
        }
    }
    while (e) {
        if (e & 1) {
            res *= n2;
        }
        n2 *= n2;
        e >>= 1;
    }
    if (s < 0) {
        res = 1.0/res;
    }
    {{@1}} = res;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => $ops->[655]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 657,
                  'ARGS' => [
                              'n',
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 847 "src/ops/math.ops"
    FLOATVAL n2 = {{@2}};
    FLOATVAL res = 1.0;
    INTVAL   e  = {{@3}};
    int s = 1;
    if (e != 0) {
        if (e < 0) {
            s = -1;
            e = -e;
        }
    }
    while (e) {
        if (e & 1) {
            res *= n2;
        }
        n2 *= n2;
        e >>= 1;
    }
    if (s < 0) {
        res = 1.0/res;
    }
    {{@1}} = res;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pow',
                  'FLAGS' => $ops->[655]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 658,
                  'ARGS' => [
                              'n',
                              'nc',
                              'ic'
                            ],
                  'BODY' => '#line 847 "src/ops/math.ops"
    FLOATVAL n2 = {{@2}};
    FLOATVAL res = 1.0;
    INTVAL   e  = {{@3}};
    int s = 1;
    if (e != 0) {
        if (e < 0) {
            s = -1;
            e = -e;
        }
    }
    while (e) {
        if (e & 1) {
            res *= n2;
        }
        n2 *= n2;
        e >>= 1;
    }
    if (s < 0) {
        res = 1.0/res;
    }
    {{@1}} = res;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 659,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 899 "src/ops/math.ops"
    {{@1}} -= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => $ops->[659]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 660,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 899 "src/ops/math.ops"
    {{@1}} -= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 661,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 903 "src/ops/math.ops"
    {{@1}} -= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => $ops->[661]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 662,
                  'ARGS' => [
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 903 "src/ops/math.ops"
    {{@1}} -= {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 663,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 907 "src/ops/math.ops"
    VTABLE_i_subtract(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 664,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 911 "src/ops/math.ops"
    VTABLE_i_subtract_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => $ops->[664]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 665,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 911 "src/ops/math.ops"
    VTABLE_i_subtract_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 666,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 915 "src/ops/math.ops"
    VTABLE_i_subtract_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => $ops->[666]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 667,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 915 "src/ops/math.ops"
    VTABLE_i_subtract_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 668,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 919 "src/ops/math.ops"
    {{@1}} = {{@2}} - {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => $ops->[668]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 669,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 919 "src/ops/math.ops"
    {{@1}} = {{@2}} - {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => $ops->[668]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 670,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 919 "src/ops/math.ops"
    {{@1}} = {{@2}} - {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 671,
                  'ARGS' => [
                              'n',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 923 "src/ops/math.ops"
    {{@1}} = {{@2}} - {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => $ops->[671]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 672,
                  'ARGS' => [
                              'n',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 923 "src/ops/math.ops"
    {{@1}} = {{@2}} - {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => $ops->[671]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 673,
                  'ARGS' => [
                              'n',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 923 "src/ops/math.ops"
    {{@1}} = {{@2}} - {{@3}};

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 674,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 927 "src/ops/math.ops"
    {{@1}} = VTABLE_subtract(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 675,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 931 "src/ops/math.ops"
    {{@1}} = VTABLE_subtract_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => $ops->[675]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 676,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 931 "src/ops/math.ops"
    {{@1}} = VTABLE_subtract_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 677,
                  'ARGS' => [
                              'p',
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 935 "src/ops/math.ops"
    {{@1}} = VTABLE_subtract_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sub',
                  'FLAGS' => $ops->[677]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 678,
                  'ARGS' => [
                              'p',
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 935 "src/ops/math.ops"
    {{@1}} = VTABLE_subtract_float(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sqrt',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 679,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 947 "src/ops/math.ops"
    {{@1}} = sqrt((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'acos',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 680,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 976 "src/ops/math.ops"
    {{@1}} = acos((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'asec',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 681,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 988 "src/ops/math.ops"
    {{@1}} = acos(((FLOATVAL)1) / ((FLOATVAL){{@2}}));

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'asin',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 682,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1001 "src/ops/math.ops"
    {{@1}} = asin((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'atan',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 683,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1019 "src/ops/math.ops"
    {{@1}} = atan((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'atan',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 684,
                  'ARGS' => [
                              'n',
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1023 "src/ops/math.ops"
    {{@1}} = atan2((FLOATVAL){{@2}}, (FLOATVAL){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'atan',
                  'FLAGS' => $ops->[684]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 685,
                  'ARGS' => [
                              'n',
                              'nc',
                              'n'
                            ],
                  'BODY' => '#line 1023 "src/ops/math.ops"
    {{@1}} = atan2((FLOATVAL){{@2}}, (FLOATVAL){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'atan',
                  'FLAGS' => $ops->[684]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 686,
                  'ARGS' => [
                              'n',
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 1023 "src/ops/math.ops"
    {{@1}} = atan2((FLOATVAL){{@2}}, (FLOATVAL){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cos',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 687,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1035 "src/ops/math.ops"
    {{@1}} = cos((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cosh',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 688,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1047 "src/ops/math.ops"
    {{@1}} = cosh((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'exp',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 689,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1060 "src/ops/math.ops"
    {{@1}} = exp((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'ln',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 690,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1072 "src/ops/math.ops"
    {{@1}} = log((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'log10',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 691,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1084 "src/ops/math.ops"
    {{@1}} = log10((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'log2',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 692,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1096 "src/ops/math.ops"
    FLOATVAL temp = log((FLOATVAL)2.0);
    {{@1}} = log((FLOATVAL){{@2}}) / temp;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sec',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 693,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1109 "src/ops/math.ops"
    {{@1}} = ((FLOATVAL)1) / cos((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sech',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 694,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1121 "src/ops/math.ops"
    {{@1}} = ((FLOATVAL)1) / cosh((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sin',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 695,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1133 "src/ops/math.ops"
    {{@1}} = sin((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sinh',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 696,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1145 "src/ops/math.ops"
    {{@1}} = sinh((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'tan',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 697,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1157 "src/ops/math.ops"
    {{@1}} = tan((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'tanh',
                  'FLAGS' => {
                               '' => undef,
                               'base_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 698,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 1169 "src/ops/math.ops"
    {{@1}} = tanh((FLOATVAL){{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'gcd',
                  'FLAGS' => {
                               '' => undef,
                               'advanced_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 699,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 1195 "src/ops/math.ops"
    INTVAL p = 0;
    INTVAL a = {{@2}} < 0 ? -{{@2}} : {{@2}};
    INTVAL b = {{@3}} < 0 ? -{{@3}} : {{@3}};

    if (a==0) { {{@1}}=b; {{+=4}}; }
    if (b==0) { {{@1}}=a; {{+=4}}; }

    while (!((a | b) & 1)) {
        a>>=1;
        b>>=1;
        p++;
    }

    while (a>0) {
        if (!(a & 1)) a>>=1;
        else if (!(b & 1)) b>>=1;
        else if (a<b)      b = (b-a)>>1;
        else               a = (a-b)>>1;
    }

    {{@1}} = b<<p;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'gcd',
                  'FLAGS' => $ops->[699]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 700,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 1195 "src/ops/math.ops"
    INTVAL p = 0;
    INTVAL a = {{@2}} < 0 ? -{{@2}} : {{@2}};
    INTVAL b = {{@3}} < 0 ? -{{@3}} : {{@3}};

    if (a==0) { {{@1}}=b; {{+=4}}; }
    if (b==0) { {{@1}}=a; {{+=4}}; }

    while (!((a | b) & 1)) {
        a>>=1;
        b>>=1;
        p++;
    }

    while (a>0) {
        if (!(a & 1)) a>>=1;
        else if (!(b & 1)) b>>=1;
        else if (a<b)      b = (b-a)>>1;
        else               a = (a-b)>>1;
    }

    {{@1}} = b<<p;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'gcd',
                  'FLAGS' => $ops->[699]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 701,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 1195 "src/ops/math.ops"
    INTVAL p = 0;
    INTVAL a = {{@2}} < 0 ? -{{@2}} : {{@2}};
    INTVAL b = {{@3}} < 0 ? -{{@3}} : {{@3}};

    if (a==0) { {{@1}}=b; {{+=4}}; }
    if (b==0) { {{@1}}=a; {{+=4}}; }

    while (!((a | b) & 1)) {
        a>>=1;
        b>>=1;
        p++;
    }

    while (a>0) {
        if (!(a & 1)) a>>=1;
        else if (!(b & 1)) b>>=1;
        else if (a<b)      b = (b-a)>>1;
        else               a = (a-b)>>1;
    }

    {{@1}} = b<<p;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lcm',
                  'FLAGS' => {
                               '' => undef,
                               'advanced_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 702,
                  'ARGS' => [
                              'i',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 1228 "src/ops/math.ops"
    INTVAL gcd = 0;
    INTVAL p = 0;
    INTVAL a = {{@2}} < 0 ? -{{@2}} : {{@2}};
    INTVAL b = {{@3}} < 0 ? -{{@3}} : {{@3}};
    INTVAL saved_var1 = a, saved_var2 = b;

    if (a==0 || b==0) { {{@1}}=0; {{+=4}}; }

    while (!((a | b) & 1)) {
        a>>=1;
        b>>=1;
        p++;
    }

    while (a>0) {
        if (!(a & 1)) a>>=1;
        else if (!(b & 1)) b>>=1;
        else if (a<b)      b = (b-a)>>1;
        else               a = (a-b)>>1;
    }

    gcd = b<<p;
    saved_var1 /= gcd;
    {{@1}} = saved_var1*saved_var2;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lcm',
                  'FLAGS' => $ops->[702]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 703,
                  'ARGS' => [
                              'i',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 1228 "src/ops/math.ops"
    INTVAL gcd = 0;
    INTVAL p = 0;
    INTVAL a = {{@2}} < 0 ? -{{@2}} : {{@2}};
    INTVAL b = {{@3}} < 0 ? -{{@3}} : {{@3}};
    INTVAL saved_var1 = a, saved_var2 = b;

    if (a==0 || b==0) { {{@1}}=0; {{+=4}}; }

    while (!((a | b) & 1)) {
        a>>=1;
        b>>=1;
        p++;
    }

    while (a>0) {
        if (!(a & 1)) a>>=1;
        else if (!(b & 1)) b>>=1;
        else if (a<b)      b = (b-a)>>1;
        else               a = (a-b)>>1;
    }

    gcd = b<<p;
    saved_var1 /= gcd;
    {{@1}} = saved_var1*saved_var2;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'lcm',
                  'FLAGS' => $ops->[702]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 704,
                  'ARGS' => [
                              'i',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 1228 "src/ops/math.ops"
    INTVAL gcd = 0;
    INTVAL p = 0;
    INTVAL a = {{@2}} < 0 ? -{{@2}} : {{@2}};
    INTVAL b = {{@3}} < 0 ? -{{@3}} : {{@3}};
    INTVAL saved_var1 = a, saved_var2 = b;

    if (a==0 || b==0) { {{@1}}=0; {{+=4}}; }

    while (!((a | b) & 1)) {
        a>>=1;
        b>>=1;
        p++;
    }

    while (a>0) {
        if (!(a & 1)) a>>=1;
        else if (!(b & 1)) b>>=1;
        else if (a<b)      b = (b-a)>>1;
        else               a = (a-b)>>1;
    }

    gcd = b<<p;
    saved_var1 /= gcd;
    {{@1}} = saved_var1*saved_var2;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fact',
                  'FLAGS' => {
                               '' => undef,
                               'advanced_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 705,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 1265 "src/ops/math.ops"
    /* Coercing a negative to a UINT can get pretty ugly
     * in this situation. */
    INTVAL i = {{@2}};
    UINTVAL q = 1;
    while (i>0) {
        q = q*i;
        i--;
    }
    {{@1}} = q;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'fact',
                  'FLAGS' => {
                               '' => undef,
                               'advanced_math' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 706,
                  'ARGS' => [
                              'n',
                              'i'
                            ],
                  'BODY' => '#line 1277 "src/ops/math.ops"
    /* Coercing a negative to a UINT can get pretty ugly
     * in this situation. */
    INTVAL i = {{@2}};
    FLOATVAL q = 1;
    while (i>0) {
        q = q*i;
        i--;
    }
    {{@1}} = q;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'callmethodcc',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 707,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 50 "src/ops/object.ops"
    PMC      * const object     = {{@1}};
    STRING   * const meth       = {{@2}};
    opcode_t * const next       = {{^+3}};

    PMC      * const method_pmc = VTABLE_find_method(interp, object, meth);
    opcode_t *dest              = NULL;

    if (PMC_IS_NULL(method_pmc)) {
        PMC * const _class = VTABLE_get_class(interp, object);
        if (PMC_IS_NULL(_class)) {
            dest = Parrot_ex_throw_from_op_args(interp, next,
                EXCEPTION_METHOD_NOT_FOUND,
                "Method \'%Ss\' not found for non-object", meth);
        }
        else {
            dest = Parrot_ex_throw_from_op_args(interp, next,
                EXCEPTION_METHOD_NOT_FOUND,
                "Method \'%Ss\' not found for invocant of class \'%Ss\'", meth,
                VTABLE_get_string(interp, _class));
        }
    }
    else {
        interp->current_object = object;
        interp->current_cont   = NEED_CONTINUATION;
        dest                   = VTABLE_invoke(interp, method_pmc, next);
    }
    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'callmethodcc',
                  'FLAGS' => $ops->[707]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 708,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 50 "src/ops/object.ops"
    PMC      * const object     = {{@1}};
    STRING   * const meth       = {{@2}};
    opcode_t * const next       = {{^+3}};

    PMC      * const method_pmc = VTABLE_find_method(interp, object, meth);
    opcode_t *dest              = NULL;

    if (PMC_IS_NULL(method_pmc)) {
        PMC * const _class = VTABLE_get_class(interp, object);
        if (PMC_IS_NULL(_class)) {
            dest = Parrot_ex_throw_from_op_args(interp, next,
                EXCEPTION_METHOD_NOT_FOUND,
                "Method \'%Ss\' not found for non-object", meth);
        }
        else {
            dest = Parrot_ex_throw_from_op_args(interp, next,
                EXCEPTION_METHOD_NOT_FOUND,
                "Method \'%Ss\' not found for invocant of class \'%Ss\'", meth,
                VTABLE_get_string(interp, _class));
        }
    }
    else {
        interp->current_object = object;
        interp->current_cont   = NEED_CONTINUATION;
        dest                   = VTABLE_invoke(interp, method_pmc, next);
    }
    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'callmethodcc',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 709,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 80 "src/ops/object.ops"
    opcode_t        *dest;
    opcode_t * const next  = {{^+3}};

    interp->current_object = {{@1}};
    interp->current_cont   = NEED_CONTINUATION;
    dest                   = VTABLE_invoke(interp, {{@2}}, next);

    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'callmethod',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 710,
                  'ARGS' => [
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 91 "src/ops/object.ops"
    PMC      * const object     = {{@1}};
    STRING   * const meth       = {{@2}};
    opcode_t * const next       = {{^+4}};

    PMC      * const method_pmc = VTABLE_find_method(interp, object, meth);
    opcode_t *dest              = NULL;


    if (PMC_IS_NULL(method_pmc)) {
        dest = Parrot_ex_throw_from_op_args(interp, next, EXCEPTION_METHOD_NOT_FOUND,
            "Method \'%Ss\' not found for invocant of class \'%Ss\'", meth,
            VTABLE_get_string(interp, VTABLE_get_class(interp, object)));
    }
    else {
        interp->current_object = object;
        interp->current_cont = {{@3}};
        dest = (opcode_t *)VTABLE_invoke(interp, method_pmc, next);
    }
    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'callmethod',
                  'FLAGS' => $ops->[710]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 711,
                  'ARGS' => [
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 91 "src/ops/object.ops"
    PMC      * const object     = {{@1}};
    STRING   * const meth       = {{@2}};
    opcode_t * const next       = {{^+4}};

    PMC      * const method_pmc = VTABLE_find_method(interp, object, meth);
    opcode_t *dest              = NULL;


    if (PMC_IS_NULL(method_pmc)) {
        dest = Parrot_ex_throw_from_op_args(interp, next, EXCEPTION_METHOD_NOT_FOUND,
            "Method \'%Ss\' not found for invocant of class \'%Ss\'", meth,
            VTABLE_get_string(interp, VTABLE_get_class(interp, object)));
    }
    else {
        interp->current_object = object;
        interp->current_cont = {{@3}};
        dest = (opcode_t *)VTABLE_invoke(interp, method_pmc, next);
    }
    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'callmethod',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 712,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 113 "src/ops/object.ops"
    PMC      * const object     = {{@1}};
    PMC      * const method_pmc = {{@2}};
    opcode_t * const next       = {{^+4}};

    opcode_t *dest;

    interp->current_object = object;
    interp->current_cont = {{@3}};
    dest = (opcode_t *)VTABLE_invoke(interp, method_pmc, next);
    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'tailcallmethod',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 713,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 126 "src/ops/object.ops"
    opcode_t * const next       = {{^+3}};
    PMC      * const object     = {{@1}};
    STRING   * const meth       = {{@2}};
    PMC      * const method_pmc = VTABLE_find_method(interp, object, meth);

    opcode_t *dest;

    if (PMC_IS_NULL(method_pmc)) {
        dest = Parrot_ex_throw_from_op_args(interp, next, EXCEPTION_METHOD_NOT_FOUND,
            "Method \'%Ss\' not found for invocant of class \'%Ss\'", meth,
            VTABLE_get_string(interp, VTABLE_get_class(interp, object)));
    }
    else {
        interp->current_cont = Parrot_pcc_get_continuation(interp, CURRENT_CONTEXT(interp));
        PObj_get_FLAGS(interp->current_cont) |= SUB_FLAG_TAILCALL;
        interp->current_object = object;
        dest = (opcode_t *)VTABLE_invoke(interp, method_pmc, next);
    }
    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'tailcallmethod',
                  'FLAGS' => $ops->[713]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 714,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 126 "src/ops/object.ops"
    opcode_t * const next       = {{^+3}};
    PMC      * const object     = {{@1}};
    STRING   * const meth       = {{@2}};
    PMC      * const method_pmc = VTABLE_find_method(interp, object, meth);

    opcode_t *dest;

    if (PMC_IS_NULL(method_pmc)) {
        dest = Parrot_ex_throw_from_op_args(interp, next, EXCEPTION_METHOD_NOT_FOUND,
            "Method \'%Ss\' not found for invocant of class \'%Ss\'", meth,
            VTABLE_get_string(interp, VTABLE_get_class(interp, object)));
    }
    else {
        interp->current_cont = Parrot_pcc_get_continuation(interp, CURRENT_CONTEXT(interp));
        PObj_get_FLAGS(interp->current_cont) |= SUB_FLAG_TAILCALL;
        interp->current_object = object;
        dest = (opcode_t *)VTABLE_invoke(interp, method_pmc, next);
    }
    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'tailcallmethod',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 715,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 148 "src/ops/object.ops"
    opcode_t * const next       = {{^+3}};
    PMC      * const object     = {{@1}};
    PMC      * const method_pmc = {{@2}};

    opcode_t *dest;

    interp->current_cont = Parrot_pcc_get_continuation(interp, CURRENT_CONTEXT(interp));
    PObj_get_FLAGS(interp->current_cont) |= SUB_FLAG_TAILCALL;

    interp->current_object = object;
    dest = (opcode_t *)VTABLE_invoke(interp, method_pmc, next);
    {{=dest}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'addmethod',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 716,
                  'ARGS' => [
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 169 "src/ops/object.ops"
    VTABLE_add_method(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'addmethod',
                  'FLAGS' => $ops->[716]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 717,
                  'ARGS' => [
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 169 "src/ops/object.ops"
    VTABLE_add_method(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'can',
                  'FLAGS' => {
                               '' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 718,
                  'ARGS' => [
                              'i',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 181 "src/ops/object.ops"
    {{@1}} = VTABLE_can(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'can',
                  'FLAGS' => $ops->[718]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 719,
                  'ARGS' => [
                              'i',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 181 "src/ops/object.ops"
    {{@1}} = VTABLE_can(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'does',
                  'FLAGS' => {
                               '' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 720,
                  'ARGS' => [
                              'i',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 193 "src/ops/object.ops"
    {{@1}} = {{@3}} ? VTABLE_does(interp, {{@2}}, {{@3}}) : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'does',
                  'FLAGS' => $ops->[720]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 721,
                  'ARGS' => [
                              'i',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 193 "src/ops/object.ops"
    {{@1}} = {{@3}} ? VTABLE_does(interp, {{@2}}, {{@3}}) : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'does',
                  'FLAGS' => {
                               '' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 722,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 204 "src/ops/object.ops"
    {{@1}} = {{@3}} ? VTABLE_does_pmc(interp, {{@2}}, {{@3}}) : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'does',
                  'FLAGS' => $ops->[722]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 723,
                  'ARGS' => [
                              'i',
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 204 "src/ops/object.ops"
    {{@1}} = {{@3}} ? VTABLE_does_pmc(interp, {{@2}}, {{@3}}) : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isa',
                  'FLAGS' => {
                               '' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 724,
                  'ARGS' => [
                              'i',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 217 "src/ops/object.ops"
    {{@1}} = {{@3}} ? VTABLE_isa(interp, {{@2}}, {{@3}}) : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isa',
                  'FLAGS' => $ops->[724]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 725,
                  'ARGS' => [
                              'i',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 217 "src/ops/object.ops"
    {{@1}} = {{@3}} ? VTABLE_isa(interp, {{@2}}, {{@3}}) : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isa',
                  'FLAGS' => {
                               '' => undef,
                               'object_base' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 726,
                  'ARGS' => [
                              'i',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 221 "src/ops/object.ops"
    {{@1}} = {{@3}} ? VTABLE_isa_pmc(interp, {{@2}}, {{@3}}) : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'isa',
                  'FLAGS' => $ops->[726]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 727,
                  'ARGS' => [
                              'i',
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 221 "src/ops/object.ops"
    {{@1}} = {{@3}} ? VTABLE_isa_pmc(interp, {{@2}}, {{@3}}) : 0;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'newclass',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 728,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 239 "src/ops/object.ops"
    PMC * const name = pmc_new(interp, enum_class_String);
    VTABLE_set_string_native(interp, name, {{@2}});
    {{@1}} = pmc_new_init(interp, enum_class_Class, name);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'newclass',
                  'FLAGS' => $ops->[728]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 729,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 239 "src/ops/object.ops"
    PMC * const name = pmc_new(interp, enum_class_String);
    VTABLE_set_string_native(interp, name, {{@2}});
    {{@1}} = pmc_new_init(interp, enum_class_Class, name);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'newclass',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 730,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 245 "src/ops/object.ops"
    {{@1}} = pmc_new_init(interp, enum_class_Class, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'newclass',
                  'FLAGS' => $ops->[730]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 731,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 245 "src/ops/object.ops"
    {{@1}} = pmc_new_init(interp, enum_class_Class, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 732,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 261 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class(interp, {{@2}});
    opcode_t * const next         = {{^+3}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", VTABLE_get_string(interp, {{@2}}));
        {{=handler}};
    }
    {{@1}} = pmc_new(interp, enum_class_Class);
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[732]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 733,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 261 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class(interp, {{@2}});
    opcode_t * const next         = {{^+3}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", VTABLE_get_string(interp, {{@2}}));
        {{=handler}};
    }
    {{@1}} = pmc_new(interp, enum_class_Class);
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 734,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 276 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t * handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", VTABLE_get_string(interp, {{@2}}));
        {{=handler}};
    }
    {{@1}} = Parrot_oo_newclass_from_str(interp, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[734]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 735,
                  'ARGS' => [
                              'p',
                              'pc',
                              's'
                            ],
                  'BODY' => '#line 276 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t * handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", VTABLE_get_string(interp, {{@2}}));
        {{=handler}};
    }
    {{@1}} = Parrot_oo_newclass_from_str(interp, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[734]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 736,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 276 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t * handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", VTABLE_get_string(interp, {{@2}}));
        {{=handler}};
    }
    {{@1}} = Parrot_oo_newclass_from_str(interp, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[734]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 737,
                  'ARGS' => [
                              'p',
                              'pc',
                              'sc'
                            ],
                  'BODY' => '#line 276 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t * handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", VTABLE_get_string(interp, {{@2}}));
        {{=handler}};
    }
    {{@1}} = Parrot_oo_newclass_from_str(interp, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 738,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 291 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", VTABLE_get_string(interp, {{@2}}));
        {{=handler}};
    }
    {{@1}} = pmc_new_init(interp, enum_class_Class, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[738]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 739,
                  'ARGS' => [
                              'p',
                              'pc',
                              'p'
                            ],
                  'BODY' => '#line 291 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", VTABLE_get_string(interp, {{@2}}));
        {{=handler}};
    }
    {{@1}} = pmc_new_init(interp, enum_class_Class, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[738]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 740,
                  'ARGS' => [
                              'p',
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 291 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", VTABLE_get_string(interp, {{@2}}));
        {{=handler}};
    }
    {{@1}} = pmc_new_init(interp, enum_class_Class, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[738]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 741,
                  'ARGS' => [
                              'p',
                              'pc',
                              'pc'
                            ],
                  'BODY' => '#line 291 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", VTABLE_get_string(interp, {{@2}}));
        {{=handler}};
    }
    {{@1}} = pmc_new_init(interp, enum_class_Class, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 742,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 319 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class_str(interp, {{@2}});
    opcode_t * const next         = {{^+3}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", {{@2}});
        {{=handler}};
    }

    {{@1}} = pmc_new(interp, enum_class_Class);
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[742]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 743,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 319 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class_str(interp, {{@2}});
    opcode_t * const next         = {{^+3}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", {{@2}});
        {{=handler}};
    }

    {{@1}} = pmc_new(interp, enum_class_Class);
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 744,
                  'ARGS' => [
                              'p',
                              's',
                              's'
                            ],
                  'BODY' => '#line 335 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class_str(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", {{@2}});
        {{=handler}};
    }

    {{@1}}  = Parrot_oo_newclass_from_str(interp, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[744]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 745,
                  'ARGS' => [
                              'p',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 335 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class_str(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", {{@2}});
        {{=handler}};
    }

    {{@1}}  = Parrot_oo_newclass_from_str(interp, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[744]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 746,
                  'ARGS' => [
                              'p',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 335 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class_str(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", {{@2}});
        {{=handler}};
    }

    {{@1}}  = Parrot_oo_newclass_from_str(interp, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[744]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 747,
                  'ARGS' => [
                              'p',
                              'sc',
                              'sc'
                            ],
                  'BODY' => '#line 335 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class_str(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", {{@2}});
        {{=handler}};
    }

    {{@1}}  = Parrot_oo_newclass_from_str(interp, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 748,
                  'ARGS' => [
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 351 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class_str(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", {{@2}});
        {{=handler}};
    }

    {{@1}} = pmc_new_init(interp, enum_class_Class, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[748]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 749,
                  'ARGS' => [
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 351 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class_str(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", {{@2}});
        {{=handler}};
    }

    {{@1}} = pmc_new_init(interp, enum_class_Class, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[748]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 750,
                  'ARGS' => [
                              'p',
                              's',
                              'pc'
                            ],
                  'BODY' => '#line 351 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class_str(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", {{@2}});
        {{=handler}};
    }

    {{@1}} = pmc_new_init(interp, enum_class_Class, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'subclass',
                  'FLAGS' => $ops->[748]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 751,
                  'ARGS' => [
                              'p',
                              'sc',
                              'pc'
                            ],
                  'BODY' => '#line 351 "src/ops/object.ops"
    PMC      * const parent_class = Parrot_oo_get_class_str(interp, {{@2}});
    opcode_t * const next         = {{^+4}};

    if (PMC_IS_NULL(parent_class)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' doesn\'t exist", {{@2}});
        {{=handler}};
    }

    {{@1}} = pmc_new_init(interp, enum_class_Class, {{@3}});
    VTABLE_add_parent(interp, {{@1}}, parent_class);
    {{=next}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_class',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 752,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 377 "src/ops/object.ops"
    {{@1}} = Parrot_oo_get_class_str(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_class',
                  'FLAGS' => $ops->[752]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 753,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 377 "src/ops/object.ops"
    {{@1}} = Parrot_oo_get_class_str(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_class',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 754,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 381 "src/ops/object.ops"
    {{@1}} = Parrot_oo_get_class(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_class',
                  'FLAGS' => $ops->[754]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 755,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 381 "src/ops/object.ops"
    {{@1}} = Parrot_oo_get_class(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'class',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 756,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 393 "src/ops/object.ops"
    {{@1}} = VTABLE_get_class(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'addparent',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 757,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 406 "src/ops/object.ops"
    VTABLE_add_parent(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'removeparent',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 758,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 416 "src/ops/object.ops"
    VTABLE_remove_parent(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'addrole',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 759,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 426 "src/ops/object.ops"
    VTABLE_add_role(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'addattribute',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 760,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 436 "src/ops/object.ops"
    STRING * const class_name  = string_from_literal(interp, "Class");
    STRING * const role_name   = string_from_literal(interp, "Role");

    if (VTABLE_isa(interp, {{@1}}, class_name) || VTABLE_isa(interp, {{@1}}, role_name))
        VTABLE_add_attribute(interp, {{@1}}, {{@2}}, PMCNULL);
    else {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Cannot add attribute to non-class");
        {{=handler}};
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'addattribute',
                  'FLAGS' => $ops->[760]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 761,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 436 "src/ops/object.ops"
    STRING * const class_name  = string_from_literal(interp, "Class");
    STRING * const role_name   = string_from_literal(interp, "Role");

    if (VTABLE_isa(interp, {{@1}}, class_name) || VTABLE_isa(interp, {{@1}}, role_name))
        VTABLE_add_attribute(interp, {{@1}}, {{@2}}, PMCNULL);
    else {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Cannot add attribute to non-class");
        {{=handler}};
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'removeattribute',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 762,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 456 "src/ops/object.ops"
    VTABLE_remove_attribute(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'removeattribute',
                  'FLAGS' => $ops->[762]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 763,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 456 "src/ops/object.ops"
    VTABLE_remove_attribute(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getattribute',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 764,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 473 "src/ops/object.ops"
    {{@1}} = VTABLE_get_attr_str(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getattribute',
                  'FLAGS' => $ops->[764]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 765,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 473 "src/ops/object.ops"
    {{@1}} = VTABLE_get_attr_str(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getattribute',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 766,
                  'ARGS' => [
                              'p',
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 477 "src/ops/object.ops"
    {{@1}} = VTABLE_get_attr_keyed(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getattribute',
                  'FLAGS' => $ops->[766]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 767,
                  'ARGS' => [
                              'p',
                              'p',
                              'pc',
                              's'
                            ],
                  'BODY' => '#line 477 "src/ops/object.ops"
    {{@1}} = VTABLE_get_attr_keyed(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getattribute',
                  'FLAGS' => $ops->[766]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 768,
                  'ARGS' => [
                              'p',
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 477 "src/ops/object.ops"
    {{@1}} = VTABLE_get_attr_keyed(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getattribute',
                  'FLAGS' => $ops->[766]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 769,
                  'ARGS' => [
                              'p',
                              'p',
                              'pc',
                              'sc'
                            ],
                  'BODY' => '#line 477 "src/ops/object.ops"
    {{@1}} = VTABLE_get_attr_keyed(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setattribute',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 770,
                  'ARGS' => [
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 493 "src/ops/object.ops"
    VTABLE_set_attr_str(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setattribute',
                  'FLAGS' => $ops->[770]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 771,
                  'ARGS' => [
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 493 "src/ops/object.ops"
    VTABLE_set_attr_str(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setattribute',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 772,
                  'ARGS' => [
                              'p',
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 497 "src/ops/object.ops"
    VTABLE_set_attr_keyed(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setattribute',
                  'FLAGS' => $ops->[772]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 773,
                  'ARGS' => [
                              'p',
                              'pc',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 497 "src/ops/object.ops"
    VTABLE_set_attr_keyed(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setattribute',
                  'FLAGS' => $ops->[772]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 774,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 497 "src/ops/object.ops"
    VTABLE_set_attr_keyed(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setattribute',
                  'FLAGS' => $ops->[772]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 775,
                  'ARGS' => [
                              'p',
                              'pc',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 497 "src/ops/object.ops"
    VTABLE_set_attr_keyed(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'inspect',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 776,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 515 "src/ops/object.ops"
    {{@1}} = VTABLE_inspect(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'inspect',
                  'FLAGS' => $ops->[776]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 777,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 515 "src/ops/object.ops"
    {{@1}} = VTABLE_inspect(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'inspect',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 778,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 519 "src/ops/object.ops"
    {{@1}} = VTABLE_inspect_str(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'inspect',
                  'FLAGS' => $ops->[778]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 779,
                  'ARGS' => [
                              'p',
                              'pc',
                              's'
                            ],
                  'BODY' => '#line 519 "src/ops/object.ops"
    {{@1}} = VTABLE_inspect_str(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'inspect',
                  'FLAGS' => $ops->[778]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 780,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 519 "src/ops/object.ops"
    {{@1}} = VTABLE_inspect_str(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'inspect',
                  'FLAGS' => $ops->[778]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 781,
                  'ARGS' => [
                              'p',
                              'pc',
                              'sc'
                            ],
                  'BODY' => '#line 519 "src/ops/object.ops"
    {{@1}} = VTABLE_inspect_str(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 782,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 53 "src/ops/pmc.ops"
    STRING * const name   = {{@2}};
    PMC    * const _class = Parrot_pcc_get_HLL(interp, CURRENT_CONTEXT(interp))
                          ? Parrot_oo_get_class_str(interp, name)
                          : PMCNULL;

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, PMCNULL);
    else {
        const INTVAL type = pmc_type(interp, name);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+3}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", name);
            {{=dest}};
        }
        {{@1}} = pmc_new(interp, type);
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => $ops->[782]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 783,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 53 "src/ops/pmc.ops"
    STRING * const name   = {{@2}};
    PMC    * const _class = Parrot_pcc_get_HLL(interp, CURRENT_CONTEXT(interp))
                          ? Parrot_oo_get_class_str(interp, name)
                          : PMCNULL;

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, PMCNULL);
    else {
        const INTVAL type = pmc_type(interp, name);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+3}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", name);
            {{=dest}};
        }
        {{@1}} = pmc_new(interp, type);
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 784,
                  'ARGS' => [
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 73 "src/ops/pmc.ops"
    STRING * const name   = {{@2}};
    PMC    * const _class = Parrot_pcc_get_HLL(interp, CURRENT_CONTEXT(interp))
                          ? Parrot_oo_get_class_str(interp, name)
                          : PMCNULL;

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, {{@3}});
    else {
        const INTVAL type = pmc_type(interp, name);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", name);
            {{=dest}};
        }
        {{@1}} = pmc_new_init(interp, type, {{@3}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => $ops->[784]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 785,
                  'ARGS' => [
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 73 "src/ops/pmc.ops"
    STRING * const name   = {{@2}};
    PMC    * const _class = Parrot_pcc_get_HLL(interp, CURRENT_CONTEXT(interp))
                          ? Parrot_oo_get_class_str(interp, name)
                          : PMCNULL;

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, {{@3}});
    else {
        const INTVAL type = pmc_type(interp, name);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", name);
            {{=dest}};
        }
        {{@1}} = pmc_new_init(interp, type, {{@3}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => $ops->[784]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 786,
                  'ARGS' => [
                              'p',
                              's',
                              'pc'
                            ],
                  'BODY' => '#line 73 "src/ops/pmc.ops"
    STRING * const name   = {{@2}};
    PMC    * const _class = Parrot_pcc_get_HLL(interp, CURRENT_CONTEXT(interp))
                          ? Parrot_oo_get_class_str(interp, name)
                          : PMCNULL;

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, {{@3}});
    else {
        const INTVAL type = pmc_type(interp, name);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", name);
            {{=dest}};
        }
        {{@1}} = pmc_new_init(interp, type, {{@3}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => $ops->[784]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 787,
                  'ARGS' => [
                              'p',
                              'sc',
                              'pc'
                            ],
                  'BODY' => '#line 73 "src/ops/pmc.ops"
    STRING * const name   = {{@2}};
    PMC    * const _class = Parrot_pcc_get_HLL(interp, CURRENT_CONTEXT(interp))
                          ? Parrot_oo_get_class_str(interp, name)
                          : PMCNULL;

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, {{@3}});
    else {
        const INTVAL type = pmc_type(interp, name);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", name);
            {{=dest}};
        }
        {{@1}} = pmc_new_init(interp, type, {{@3}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => {
                               '' => undef,
                               'object_classes' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 788,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 93 "src/ops/pmc.ops"
    PMC * const name_key = {{@2}};
    PMC * const _class   = Parrot_oo_get_class(interp, name_key);

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, PMCNULL);
    else {
        const INTVAL type = pmc_type_p(interp, name_key);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+3}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", VTABLE_get_repr(interp, name_key));
            {{=dest}};
        }
        {{@1}} = pmc_new(interp, type);
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => $ops->[788]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 789,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 93 "src/ops/pmc.ops"
    PMC * const name_key = {{@2}};
    PMC * const _class   = Parrot_oo_get_class(interp, name_key);

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, PMCNULL);
    else {
        const INTVAL type = pmc_type_p(interp, name_key);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+3}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", VTABLE_get_repr(interp, name_key));
            {{=dest}};
        }
        {{@1}} = pmc_new(interp, type);
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 790,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 111 "src/ops/pmc.ops"
    PMC * const name_key = {{@2}};
    PMC * const _class   = Parrot_oo_get_class(interp, name_key);

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, {{@3}});
    else {
        const INTVAL type = pmc_type_p(interp, name_key);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", VTABLE_get_repr(interp, name_key));
            {{=dest}};
        }
        {{@1}} = pmc_new_init(interp, type, {{@3}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => $ops->[790]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 791,
                  'ARGS' => [
                              'p',
                              'pc',
                              'p'
                            ],
                  'BODY' => '#line 111 "src/ops/pmc.ops"
    PMC * const name_key = {{@2}};
    PMC * const _class   = Parrot_oo_get_class(interp, name_key);

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, {{@3}});
    else {
        const INTVAL type = pmc_type_p(interp, name_key);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", VTABLE_get_repr(interp, name_key));
            {{=dest}};
        }
        {{@1}} = pmc_new_init(interp, type, {{@3}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => $ops->[790]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 792,
                  'ARGS' => [
                              'p',
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 111 "src/ops/pmc.ops"
    PMC * const name_key = {{@2}};
    PMC * const _class   = Parrot_oo_get_class(interp, name_key);

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, {{@3}});
    else {
        const INTVAL type = pmc_type_p(interp, name_key);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", VTABLE_get_repr(interp, name_key));
            {{=dest}};
        }
        {{@1}} = pmc_new_init(interp, type, {{@3}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'new',
                  'FLAGS' => $ops->[790]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 793,
                  'ARGS' => [
                              'p',
                              'pc',
                              'pc'
                            ],
                  'BODY' => '#line 111 "src/ops/pmc.ops"
    PMC * const name_key = {{@2}};
    PMC * const _class   = Parrot_oo_get_class(interp, name_key);

    if (!PMC_IS_NULL(_class))
        {{@1}} = VTABLE_instantiate(interp, _class, {{@3}});
    else {
        const INTVAL type = pmc_type_p(interp, name_key);
        if (type <= 0) {
            opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
                EXCEPTION_NO_CLASS,
                "Class \'%Ss\' not found", VTABLE_get_repr(interp, name_key));
            {{=dest}};
        }
        {{@1}} = pmc_new_init(interp, type, {{@3}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'root_new',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 794,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 144 "src/ops/pmc.ops"
    PMC * const key      = {{@2}};
    PMC * const root_ns  = interp->root_namespace;
    PMC * const ns       = Parrot_get_namespace_keyed(interp, root_ns, key);
    PMC * classobj       = PMCNULL;

    if (!PMC_IS_NULL(ns))
        classobj = Parrot_oo_get_class(interp, ns);
    if (!PMC_IS_NULL(classobj))
        {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
    else {
        opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' not found", VTABLE_get_repr(interp, key));
        {{=dest}};
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'root_new',
                  'FLAGS' => $ops->[794]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 795,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 144 "src/ops/pmc.ops"
    PMC * const key      = {{@2}};
    PMC * const root_ns  = interp->root_namespace;
    PMC * const ns       = Parrot_get_namespace_keyed(interp, root_ns, key);
    PMC * classobj       = PMCNULL;

    if (!PMC_IS_NULL(ns))
        classobj = Parrot_oo_get_class(interp, ns);
    if (!PMC_IS_NULL(classobj))
        {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
    else {
        opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+3}},
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' not found", VTABLE_get_repr(interp, key));
        {{=dest}};
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'root_new',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 796,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 162 "src/ops/pmc.ops"
    PMC * const key      = {{@2}};
    PMC * const root_ns  = interp->root_namespace;
    PMC * const ns       = Parrot_get_namespace_keyed(interp, root_ns, key);
    PMC * classobj       = PMCNULL;

    if (!PMC_IS_NULL(ns))
        classobj = Parrot_oo_get_class(interp, ns);
    if (!PMC_IS_NULL(classobj))
        {{@1}} = VTABLE_instantiate(interp, classobj, {{@3}});
    else {
        opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' not found", VTABLE_get_repr(interp, key));
        {{=dest}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'root_new',
                  'FLAGS' => $ops->[796]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 797,
                  'ARGS' => [
                              'p',
                              'pc',
                              'p'
                            ],
                  'BODY' => '#line 162 "src/ops/pmc.ops"
    PMC * const key      = {{@2}};
    PMC * const root_ns  = interp->root_namespace;
    PMC * const ns       = Parrot_get_namespace_keyed(interp, root_ns, key);
    PMC * classobj       = PMCNULL;

    if (!PMC_IS_NULL(ns))
        classobj = Parrot_oo_get_class(interp, ns);
    if (!PMC_IS_NULL(classobj))
        {{@1}} = VTABLE_instantiate(interp, classobj, {{@3}});
    else {
        opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' not found", VTABLE_get_repr(interp, key));
        {{=dest}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'root_new',
                  'FLAGS' => $ops->[796]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 798,
                  'ARGS' => [
                              'p',
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 162 "src/ops/pmc.ops"
    PMC * const key      = {{@2}};
    PMC * const root_ns  = interp->root_namespace;
    PMC * const ns       = Parrot_get_namespace_keyed(interp, root_ns, key);
    PMC * classobj       = PMCNULL;

    if (!PMC_IS_NULL(ns))
        classobj = Parrot_oo_get_class(interp, ns);
    if (!PMC_IS_NULL(classobj))
        {{@1}} = VTABLE_instantiate(interp, classobj, {{@3}});
    else {
        opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' not found", VTABLE_get_repr(interp, key));
        {{=dest}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'root_new',
                  'FLAGS' => $ops->[796]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 799,
                  'ARGS' => [
                              'p',
                              'pc',
                              'pc'
                            ],
                  'BODY' => '#line 162 "src/ops/pmc.ops"
    PMC * const key      = {{@2}};
    PMC * const root_ns  = interp->root_namespace;
    PMC * const ns       = Parrot_get_namespace_keyed(interp, root_ns, key);
    PMC * classobj       = PMCNULL;

    if (!PMC_IS_NULL(ns))
        classobj = Parrot_oo_get_class(interp, ns);
    if (!PMC_IS_NULL(classobj))
        {{@1}} = VTABLE_instantiate(interp, classobj, {{@3}});
    else {
        opcode_t *dest = Parrot_ex_throw_from_op_args(interp, {{^+4}},
            EXCEPTION_NO_CLASS,
            "Class \'%Ss\' not found", VTABLE_get_repr(interp, key));
        {{=dest}};
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'typeof',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 800,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 191 "src/ops/pmc.ops"
    {{@1}} = VTABLE_name(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'typeof',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 801,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 195 "src/ops/pmc.ops"
    {{@1}} = VTABLE_get_class(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_repr',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 802,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 207 "src/ops/pmc.ops"
    {{@1}} = VTABLE_get_repr(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_RESTART',
                  'NAME' => 'find_method',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 803,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 234 "src/ops/pmc.ops"
    opcode_t * const resume = {{^+4}};
    {{@1}} = VTABLE_find_method(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}}) || !VTABLE_defined(interp, {{@1}})) {
        opcode_t *dest = Parrot_ex_throw_from_op_args(interp, resume,
            EXCEPTION_METHOD_NOT_FOUND,
            "Method \'%Ss\' not found for invocant of class \'%Ss\'", {{@3}},
            VTABLE_get_string(interp, VTABLE_get_class(interp, {{@2}})));
        {{=dest}};
    }
    {{=resume}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_RESTART',
                  'NAME' => 'find_method',
                  'FLAGS' => $ops->[803]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 804,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 234 "src/ops/pmc.ops"
    opcode_t * const resume = {{^+4}};
    {{@1}} = VTABLE_find_method(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}}) || !VTABLE_defined(interp, {{@1}})) {
        opcode_t *dest = Parrot_ex_throw_from_op_args(interp, resume,
            EXCEPTION_METHOD_NOT_FOUND,
            "Method \'%Ss\' not found for invocant of class \'%Ss\'", {{@3}},
            VTABLE_get_string(interp, VTABLE_get_class(interp, {{@2}})));
        {{=dest}};
    }
    {{=resume}};
',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'defined',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 805,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 266 "src/ops/pmc.ops"
    {{@1}} = PMC_IS_NULL({{@2}}) ? 0 : VTABLE_defined(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'defined',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 806,
                  'ARGS' => [
                              'i',
                              'p',
                              'ki'
                            ],
                  'BODY' => '#line 270 "src/ops/pmc.ops"
    {{@1}} = PMC_IS_NULL({{@2}}) ? 0 : VTABLE_defined_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'defined',
                  'FLAGS' => $ops->[806]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 807,
                  'ARGS' => [
                              'i',
                              'p',
                              'kic'
                            ],
                  'BODY' => '#line 270 "src/ops/pmc.ops"
    {{@1}} = PMC_IS_NULL({{@2}}) ? 0 : VTABLE_defined_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'defined',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 808,
                  'ARGS' => [
                              'i',
                              'p',
                              'k'
                            ],
                  'BODY' => '#line 274 "src/ops/pmc.ops"
    {{@1}} = PMC_IS_NULL({{@2}}) ? 0 : VTABLE_defined_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'defined',
                  'FLAGS' => $ops->[808]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 809,
                  'ARGS' => [
                              'i',
                              'p',
                              'kc'
                            ],
                  'BODY' => '#line 274 "src/ops/pmc.ops"
    {{@1}} = PMC_IS_NULL({{@2}}) ? 0 : VTABLE_defined_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'exists',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 810,
                  'ARGS' => [
                              'i',
                              'p',
                              'ki'
                            ],
                  'BODY' => '#line 278 "src/ops/pmc.ops"
    {{@1}} = PMC_IS_NULL({{@2}}) ? 0 : VTABLE_exists_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'exists',
                  'FLAGS' => $ops->[810]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 811,
                  'ARGS' => [
                              'i',
                              'p',
                              'kic'
                            ],
                  'BODY' => '#line 278 "src/ops/pmc.ops"
    {{@1}} = PMC_IS_NULL({{@2}}) ? 0 : VTABLE_exists_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'exists',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 812,
                  'ARGS' => [
                              'i',
                              'p',
                              'k'
                            ],
                  'BODY' => '#line 282 "src/ops/pmc.ops"
    {{@1}} = PMC_IS_NULL({{@2}}) ? 0: VTABLE_exists_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'exists',
                  'FLAGS' => $ops->[812]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 813,
                  'ARGS' => [
                              'i',
                              'p',
                              'kc'
                            ],
                  'BODY' => '#line 282 "src/ops/pmc.ops"
    {{@1}} = PMC_IS_NULL({{@2}}) ? 0: VTABLE_exists_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'delete',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 814,
                  'ARGS' => [
                              'p',
                              'k'
                            ],
                  'BODY' => '#line 296 "src/ops/pmc.ops"
    VTABLE_delete_keyed(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'delete',
                  'FLAGS' => $ops->[814]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 815,
                  'ARGS' => [
                              'p',
                              'kc'
                            ],
                  'BODY' => '#line 296 "src/ops/pmc.ops"
    VTABLE_delete_keyed(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'delete',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 816,
                  'ARGS' => [
                              'p',
                              'ki'
                            ],
                  'BODY' => '#line 300 "src/ops/pmc.ops"
    VTABLE_delete_keyed_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'delete',
                  'FLAGS' => $ops->[816]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 817,
                  'ARGS' => [
                              'p',
                              'kic'
                            ],
                  'BODY' => '#line 300 "src/ops/pmc.ops"
    VTABLE_delete_keyed_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'elements',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 818,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 312 "src/ops/pmc.ops"
    {{@1}} = VTABLE_elements(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'push',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 819,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 344 "src/ops/pmc.ops"
    VTABLE_push_integer(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'push',
                  'FLAGS' => $ops->[819]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 820,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 344 "src/ops/pmc.ops"
    VTABLE_push_integer(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'push',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 821,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 348 "src/ops/pmc.ops"
    VTABLE_push_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'push',
                  'FLAGS' => $ops->[821]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 822,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 348 "src/ops/pmc.ops"
    VTABLE_push_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'push',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 823,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 352 "src/ops/pmc.ops"
    VTABLE_push_string(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'push',
                  'FLAGS' => $ops->[823]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 824,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 352 "src/ops/pmc.ops"
    VTABLE_push_string(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'push',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 825,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 356 "src/ops/pmc.ops"
    VTABLE_push_pmc(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pop',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 826,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 374 "src/ops/pmc.ops"
    {{@1}} = VTABLE_pop_integer(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pop',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 827,
                  'ARGS' => [
                              'n',
                              'p'
                            ],
                  'BODY' => '#line 378 "src/ops/pmc.ops"
    {{@1}} = VTABLE_pop_float(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pop',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 828,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 382 "src/ops/pmc.ops"
    {{@1}} = VTABLE_pop_string(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pop',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 829,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 386 "src/ops/pmc.ops"
    {{@1}} = VTABLE_pop_pmc(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'unshift',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 830,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 404 "src/ops/pmc.ops"
    VTABLE_unshift_integer(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'unshift',
                  'FLAGS' => $ops->[830]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 831,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 404 "src/ops/pmc.ops"
    VTABLE_unshift_integer(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'unshift',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 832,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 408 "src/ops/pmc.ops"
    VTABLE_unshift_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'unshift',
                  'FLAGS' => $ops->[832]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 833,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 408 "src/ops/pmc.ops"
    VTABLE_unshift_float(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'unshift',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 834,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 412 "src/ops/pmc.ops"
    VTABLE_unshift_string(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'unshift',
                  'FLAGS' => $ops->[834]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 835,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 412 "src/ops/pmc.ops"
    VTABLE_unshift_string(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'unshift',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 836,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 416 "src/ops/pmc.ops"
    VTABLE_unshift_pmc(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shift',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 837,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 434 "src/ops/pmc.ops"
    {{@1}} = VTABLE_shift_integer(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shift',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 838,
                  'ARGS' => [
                              'n',
                              'p'
                            ],
                  'BODY' => '#line 438 "src/ops/pmc.ops"
    {{@1}} = VTABLE_shift_float(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shift',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 839,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 442 "src/ops/pmc.ops"
    {{@1}} = VTABLE_shift_string(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'shift',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 840,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 446 "src/ops/pmc.ops"
    {{@1}} = VTABLE_shift_pmc(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'splice',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 841,
                  'ARGS' => [
                              'p',
                              'p',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 458 "src/ops/pmc.ops"
    VTABLE_splice(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'splice',
                  'FLAGS' => $ops->[841]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 842,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 458 "src/ops/pmc.ops"
    VTABLE_splice(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'splice',
                  'FLAGS' => $ops->[841]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 843,
                  'ARGS' => [
                              'p',
                              'p',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 458 "src/ops/pmc.ops"
    VTABLE_splice(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'splice',
                  'FLAGS' => $ops->[841]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 844,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 458 "src/ops/pmc.ops"
    VTABLE_splice(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setprop',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 845,
                  'ARGS' => [
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 485 "src/ops/pmc.ops"
    VTABLE_setprop(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setprop',
                  'FLAGS' => $ops->[845]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 846,
                  'ARGS' => [
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 485 "src/ops/pmc.ops"
    VTABLE_setprop(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getprop',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 847,
                  'ARGS' => [
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 497 "src/ops/pmc.ops"
    {{@1}} = VTABLE_getprop(interp, {{@3}}, {{@2}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'getprop',
                  'FLAGS' => $ops->[847]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 848,
                  'ARGS' => [
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 497 "src/ops/pmc.ops"
    {{@1}} = VTABLE_getprop(interp, {{@3}}, {{@2}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'delprop',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 849,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 509 "src/ops/pmc.ops"
    VTABLE_delprop(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'delprop',
                  'FLAGS' => $ops->[849]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 850,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 509 "src/ops/pmc.ops"
    VTABLE_delprop(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'prophash',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 851,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 522 "src/ops/pmc.ops"
    {{@1}} = VTABLE_getprops(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'freeze',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 852,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 552 "src/ops/pmc.ops"
    {{@1}} = Parrot_freeze(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'thaw',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 853,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 556 "src/ops/pmc.ops"
    {{@1}} = Parrot_thaw(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'thaw',
                  'FLAGS' => $ops->[853]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 854,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 556 "src/ops/pmc.ops"
    {{@1}} = Parrot_thaw(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add_multi',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 855,
                  'ARGS' => [
                              's',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 587 "src/ops/pmc.ops"
    Parrot_mmd_add_multi_from_long_sig(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add_multi',
                  'FLAGS' => $ops->[855]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 856,
                  'ARGS' => [
                              'sc',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 587 "src/ops/pmc.ops"
    Parrot_mmd_add_multi_from_long_sig(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add_multi',
                  'FLAGS' => $ops->[855]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 857,
                  'ARGS' => [
                              's',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 587 "src/ops/pmc.ops"
    Parrot_mmd_add_multi_from_long_sig(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'add_multi',
                  'FLAGS' => $ops->[855]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 858,
                  'ARGS' => [
                              'sc',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 587 "src/ops/pmc.ops"
    Parrot_mmd_add_multi_from_long_sig(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_multi',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 859,
                  'ARGS' => [
                              'p',
                              's',
                              's'
                            ],
                  'BODY' => '#line 597 "src/ops/pmc.ops"
    {{@1}} = Parrot_mmd_find_multi_from_long_sig(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_multi',
                  'FLAGS' => $ops->[859]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 860,
                  'ARGS' => [
                              'p',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 597 "src/ops/pmc.ops"
    {{@1}} = Parrot_mmd_find_multi_from_long_sig(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_multi',
                  'FLAGS' => $ops->[859]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 861,
                  'ARGS' => [
                              'p',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 597 "src/ops/pmc.ops"
    {{@1}} = Parrot_mmd_find_multi_from_long_sig(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_multi',
                  'FLAGS' => $ops->[859]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 862,
                  'ARGS' => [
                              'p',
                              'sc',
                              'sc'
                            ],
                  'BODY' => '#line 597 "src/ops/pmc.ops"
    {{@1}} = Parrot_mmd_find_multi_from_long_sig(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'register',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 863,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 630 "src/ops/pmc.ops"
    gc_register_pmc(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'unregister',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 864,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 634 "src/ops/pmc.ops"
    gc_unregister_pmc(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'box',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 865,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 651 "src/ops/pmc.ops"
    {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Integer));
    VTABLE_set_integer_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'box',
                  'FLAGS' => $ops->[865]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 866,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 651 "src/ops/pmc.ops"
    {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Integer));
    VTABLE_set_integer_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'box',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 867,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 656 "src/ops/pmc.ops"
    {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Float));
    VTABLE_set_number_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'box',
                  'FLAGS' => $ops->[867]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 868,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 656 "src/ops/pmc.ops"
    {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Float));
    VTABLE_set_number_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'box',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 869,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 661 "src/ops/pmc.ops"
    {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_String));
    VTABLE_set_string_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'box',
                  'FLAGS' => $ops->[869]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 870,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 661 "src/ops/pmc.ops"
    {{@1}} = pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_String));
    VTABLE_set_string_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'iter',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 871,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 674 "src/ops/pmc.ops"
    {{@1}} = VTABLE_get_iter(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'morph',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 872,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 686 "src/ops/pmc.ops"
    VTABLE_morph(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'morph',
                  'FLAGS' => $ops->[872]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 873,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 686 "src/ops/pmc.ops"
    VTABLE_morph(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'clone',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 874,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 28 "src/ops/set.ops"
    /* cloning a NULL STRING produces an empty STRING; TT #964 */
    {{@1}} = {{@2}}
       ? Parrot_str_copy(interp, {{@2}})
       : Parrot_str_new(interp, NULL, 0);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'clone',
                  'FLAGS' => $ops->[874]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 875,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 28 "src/ops/set.ops"
    /* cloning a NULL STRING produces an empty STRING; TT #964 */
    {{@1}} = {{@2}}
       ? Parrot_str_copy(interp, {{@2}})
       : Parrot_str_new(interp, NULL, 0);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'exchange',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'io'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 876,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 51 "src/ops/set.ops"
    const INTVAL temp = {{@1}};
    {{@1}} = {{@2}};
    {{@2}} = temp;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'exchange',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'io'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 877,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 57 "src/ops/set.ops"
    PMC * const temp = {{@1}};
    {{@1}} = {{@2}};
    {{@2}} = temp;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'exchange',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'io'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 878,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 63 "src/ops/set.ops"
    FLOATVAL temp = {{@1}};
    {{@1}} = {{@2}};
    {{@2}} = temp;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'exchange',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'io'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 879,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 69 "src/ops/set.ops"
    STRING * const temp = {{@1}};
    {{@1}} = {{@2}};
    {{@2}} = temp;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 880,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 121 "src/ops/set.ops"
    {{@1}} = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[880]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 881,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 121 "src/ops/set.ops"
    {{@1}} = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 882,
                  'ARGS' => [
                              'i',
                              'n'
                            ],
                  'BODY' => '#line 125 "src/ops/set.ops"
    {{@1}} = (INTVAL)({{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[882]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 883,
                  'ARGS' => [
                              'i',
                              'nc'
                            ],
                  'BODY' => '#line 125 "src/ops/set.ops"
    {{@1}} = (INTVAL)({{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 884,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 129 "src/ops/set.ops"
    {{@1}} = Parrot_str_to_int(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[884]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 885,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 129 "src/ops/set.ops"
    {{@1}} = Parrot_str_to_int(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 886,
                  'ARGS' => [
                              'n',
                              'n'
                            ],
                  'BODY' => '#line 133 "src/ops/set.ops"
    {{@1}} = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[886]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 887,
                  'ARGS' => [
                              'n',
                              'nc'
                            ],
                  'BODY' => '#line 133 "src/ops/set.ops"
    {{@1}} = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 888,
                  'ARGS' => [
                              'n',
                              'i'
                            ],
                  'BODY' => '#line 137 "src/ops/set.ops"
    {{@1}} = (FLOATVAL){{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[888]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 889,
                  'ARGS' => [
                              'n',
                              'ic'
                            ],
                  'BODY' => '#line 137 "src/ops/set.ops"
    {{@1}} = (FLOATVAL){{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 890,
                  'ARGS' => [
                              'n',
                              's'
                            ],
                  'BODY' => '#line 141 "src/ops/set.ops"
    {{@1}} = Parrot_str_to_num(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[890]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 891,
                  'ARGS' => [
                              'n',
                              'sc'
                            ],
                  'BODY' => '#line 141 "src/ops/set.ops"
    {{@1}} = Parrot_str_to_num(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 892,
                  'ARGS' => [
                              'n',
                              'p'
                            ],
                  'BODY' => '#line 145 "src/ops/set.ops"
    {{@1}} = VTABLE_get_number(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 893,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 149 "src/ops/set.ops"
    {{@1}} = VTABLE_get_string(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 894,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 153 "src/ops/set.ops"
    {{@1}} = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 895,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 157 "src/ops/set.ops"
    {{@1}} = Parrot_str_copy(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 896,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 161 "src/ops/set.ops"
    {{@1}} = Parrot_str_from_int(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[896]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 897,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 161 "src/ops/set.ops"
    {{@1}} = Parrot_str_from_int(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 898,
                  'ARGS' => [
                              's',
                              'n'
                            ],
                  'BODY' => '#line 165 "src/ops/set.ops"
    {{@1}} = Parrot_str_from_num(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[898]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 899,
                  'ARGS' => [
                              's',
                              'nc'
                            ],
                  'BODY' => '#line 165 "src/ops/set.ops"
    {{@1}} = Parrot_str_from_num(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 900,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 169 "src/ops/set.ops"
    {{@1}} = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 901,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 173 "src/ops/set.ops"
    {{@1}} = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 902,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 177 "src/ops/set.ops"
    VTABLE_set_integer_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[902]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 903,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 177 "src/ops/set.ops"
    VTABLE_set_integer_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 904,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 181 "src/ops/set.ops"
    VTABLE_set_number_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[904]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 905,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 181 "src/ops/set.ops"
    VTABLE_set_number_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 906,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 185 "src/ops/set.ops"
    VTABLE_set_string_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 907,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 189 "src/ops/set.ops"
    VTABLE_set_string_native(interp, {{@1}},
        Parrot_str_copy(interp, {{@2}}));

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 908,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 193 "src/ops/set.ops"
    {{@1}} = VTABLE_get_integer(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'assign',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 909,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 234 "src/ops/set.ops"
    VTABLE_assign_pmc(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'assign',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 910,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 238 "src/ops/set.ops"
    VTABLE_set_integer_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'assign',
                  'FLAGS' => $ops->[910]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 911,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 238 "src/ops/set.ops"
    VTABLE_set_integer_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'assign',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 912,
                  'ARGS' => [
                              'p',
                              'n'
                            ],
                  'BODY' => '#line 242 "src/ops/set.ops"
    VTABLE_set_number_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'assign',
                  'FLAGS' => $ops->[912]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 913,
                  'ARGS' => [
                              'p',
                              'nc'
                            ],
                  'BODY' => '#line 242 "src/ops/set.ops"
    VTABLE_set_number_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'assign',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 914,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 246 "src/ops/set.ops"
    VTABLE_assign_string_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'assign',
                  'FLAGS' => $ops->[914]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 915,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 246 "src/ops/set.ops"
    VTABLE_assign_string_native(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'assign',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 916,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 250 "src/ops/set.ops"
    {{@1}} = Parrot_str_set(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'assign',
                  'FLAGS' => $ops->[916]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 917,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 250 "src/ops/set.ops"
    {{@1}} = Parrot_str_set(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setref',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 918,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 254 "src/ops/set.ops"
    VTABLE_set_pmc(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'deref',
                  'FLAGS' => {
                               '' => undef,
                               'base_ref' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 919,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 258 "src/ops/set.ops"
    {{@1}} = VTABLE_get_pmc(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setp_ind',
                  'FLAGS' => {
                               '' => undef,
                               'base_ref' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 920,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 276 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_PMC(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setp_ind',
                  'FLAGS' => $ops->[920]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 921,
                  'ARGS' => [
                              'ic',
                              'p'
                            ],
                  'BODY' => '#line 276 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_PMC(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setn_ind',
                  'FLAGS' => {
                               '' => undef,
                               'base_ref' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 922,
                  'ARGS' => [
                              'i',
                              'n'
                            ],
                  'BODY' => '#line 290 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_NUM(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setn_ind',
                  'FLAGS' => $ops->[922]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 923,
                  'ARGS' => [
                              'ic',
                              'n'
                            ],
                  'BODY' => '#line 290 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_NUM(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setn_ind',
                  'FLAGS' => $ops->[922]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 924,
                  'ARGS' => [
                              'i',
                              'nc'
                            ],
                  'BODY' => '#line 290 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_NUM(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'setn_ind',
                  'FLAGS' => $ops->[922]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 925,
                  'ARGS' => [
                              'ic',
                              'nc'
                            ],
                  'BODY' => '#line 290 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_NUM(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sets_ind',
                  'FLAGS' => {
                               '' => undef,
                               'base_ref' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 926,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 304 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_STR(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sets_ind',
                  'FLAGS' => $ops->[926]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 927,
                  'ARGS' => [
                              'ic',
                              's'
                            ],
                  'BODY' => '#line 304 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_STR(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sets_ind',
                  'FLAGS' => $ops->[926]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 928,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 304 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_STR(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sets_ind',
                  'FLAGS' => $ops->[926]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 929,
                  'ARGS' => [
                              'ic',
                              'sc'
                            ],
                  'BODY' => '#line 304 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_STR(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'seti_ind',
                  'FLAGS' => {
                               '' => undef,
                               'base_ref' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 930,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 318 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_INT(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'seti_ind',
                  'FLAGS' => $ops->[930]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 931,
                  'ARGS' => [
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 318 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_INT(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'seti_ind',
                  'FLAGS' => $ops->[930]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 932,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 318 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_INT(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'seti_ind',
                  'FLAGS' => $ops->[930]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 933,
                  'ARGS' => [
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 318 "src/ops/set.ops"
    if ({{@1}} < 0 || {{@1}} >= NUM_REGISTERS)
        PANIC(interp, "Out of bound register access");
    REG_INT(interp, {{@1}}) = {{@2}};

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 934,
                  'ARGS' => [
                              'p',
                              'ki',
                              'i'
                            ],
                  'BODY' => '#line 344 "src/ops/set.ops"
    VTABLE_set_integer_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[934]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 935,
                  'ARGS' => [
                              'p',
                              'kic',
                              'i'
                            ],
                  'BODY' => '#line 344 "src/ops/set.ops"
    VTABLE_set_integer_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[934]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 936,
                  'ARGS' => [
                              'p',
                              'ki',
                              'ic'
                            ],
                  'BODY' => '#line 344 "src/ops/set.ops"
    VTABLE_set_integer_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[934]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 937,
                  'ARGS' => [
                              'p',
                              'kic',
                              'ic'
                            ],
                  'BODY' => '#line 344 "src/ops/set.ops"
    VTABLE_set_integer_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 938,
                  'ARGS' => [
                              'p',
                              'ki',
                              'n'
                            ],
                  'BODY' => '#line 348 "src/ops/set.ops"
    VTABLE_set_number_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[938]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 939,
                  'ARGS' => [
                              'p',
                              'kic',
                              'n'
                            ],
                  'BODY' => '#line 348 "src/ops/set.ops"
    VTABLE_set_number_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[938]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 940,
                  'ARGS' => [
                              'p',
                              'ki',
                              'nc'
                            ],
                  'BODY' => '#line 348 "src/ops/set.ops"
    VTABLE_set_number_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[938]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 941,
                  'ARGS' => [
                              'p',
                              'kic',
                              'nc'
                            ],
                  'BODY' => '#line 348 "src/ops/set.ops"
    VTABLE_set_number_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 942,
                  'ARGS' => [
                              'p',
                              'ki',
                              's'
                            ],
                  'BODY' => '#line 352 "src/ops/set.ops"
    VTABLE_set_string_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[942]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 943,
                  'ARGS' => [
                              'p',
                              'kic',
                              's'
                            ],
                  'BODY' => '#line 352 "src/ops/set.ops"
    VTABLE_set_string_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[942]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 944,
                  'ARGS' => [
                              'p',
                              'ki',
                              'sc'
                            ],
                  'BODY' => '#line 352 "src/ops/set.ops"
    VTABLE_set_string_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[942]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 945,
                  'ARGS' => [
                              'p',
                              'kic',
                              'sc'
                            ],
                  'BODY' => '#line 352 "src/ops/set.ops"
    VTABLE_set_string_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 946,
                  'ARGS' => [
                              'p',
                              'ki',
                              'p'
                            ],
                  'BODY' => '#line 356 "src/ops/set.ops"
    VTABLE_set_pmc_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[946]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 947,
                  'ARGS' => [
                              'p',
                              'kic',
                              'p'
                            ],
                  'BODY' => '#line 356 "src/ops/set.ops"
    VTABLE_set_pmc_keyed_int(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 948,
                  'ARGS' => [
                              'i',
                              'p',
                              'ki'
                            ],
                  'BODY' => '#line 380 "src/ops/set.ops"
    {{@1}} = VTABLE_get_integer_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[948]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 949,
                  'ARGS' => [
                              'i',
                              'p',
                              'kic'
                            ],
                  'BODY' => '#line 380 "src/ops/set.ops"
    {{@1}} = VTABLE_get_integer_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 950,
                  'ARGS' => [
                              'n',
                              'p',
                              'ki'
                            ],
                  'BODY' => '#line 384 "src/ops/set.ops"
    {{@1}} = VTABLE_get_number_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[950]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 951,
                  'ARGS' => [
                              'n',
                              'p',
                              'kic'
                            ],
                  'BODY' => '#line 384 "src/ops/set.ops"
    {{@1}} = VTABLE_get_number_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 952,
                  'ARGS' => [
                              's',
                              'p',
                              'ki'
                            ],
                  'BODY' => '#line 388 "src/ops/set.ops"
    {{@1}} = VTABLE_get_string_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[952]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 953,
                  'ARGS' => [
                              's',
                              'p',
                              'kic'
                            ],
                  'BODY' => '#line 388 "src/ops/set.ops"
    {{@1}} = VTABLE_get_string_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 954,
                  'ARGS' => [
                              'p',
                              'p',
                              'ki'
                            ],
                  'BODY' => '#line 392 "src/ops/set.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[954]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 955,
                  'ARGS' => [
                              'p',
                              'p',
                              'kic'
                            ],
                  'BODY' => '#line 392 "src/ops/set.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 956,
                  'ARGS' => [
                              'p',
                              'k',
                              'i'
                            ],
                  'BODY' => '#line 416 "src/ops/set.ops"
    VTABLE_set_integer_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[956]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 957,
                  'ARGS' => [
                              'p',
                              'kc',
                              'i'
                            ],
                  'BODY' => '#line 416 "src/ops/set.ops"
    VTABLE_set_integer_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[956]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 958,
                  'ARGS' => [
                              'p',
                              'k',
                              'ic'
                            ],
                  'BODY' => '#line 416 "src/ops/set.ops"
    VTABLE_set_integer_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[956]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 959,
                  'ARGS' => [
                              'p',
                              'kc',
                              'ic'
                            ],
                  'BODY' => '#line 416 "src/ops/set.ops"
    VTABLE_set_integer_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 960,
                  'ARGS' => [
                              'p',
                              'k',
                              'n'
                            ],
                  'BODY' => '#line 420 "src/ops/set.ops"
    VTABLE_set_number_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[960]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 961,
                  'ARGS' => [
                              'p',
                              'kc',
                              'n'
                            ],
                  'BODY' => '#line 420 "src/ops/set.ops"
    VTABLE_set_number_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[960]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 962,
                  'ARGS' => [
                              'p',
                              'k',
                              'nc'
                            ],
                  'BODY' => '#line 420 "src/ops/set.ops"
    VTABLE_set_number_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[960]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 963,
                  'ARGS' => [
                              'p',
                              'kc',
                              'nc'
                            ],
                  'BODY' => '#line 420 "src/ops/set.ops"
    VTABLE_set_number_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 964,
                  'ARGS' => [
                              'p',
                              'k',
                              's'
                            ],
                  'BODY' => '#line 424 "src/ops/set.ops"
    VTABLE_set_string_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[964]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 965,
                  'ARGS' => [
                              'p',
                              'kc',
                              's'
                            ],
                  'BODY' => '#line 424 "src/ops/set.ops"
    VTABLE_set_string_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[964]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 966,
                  'ARGS' => [
                              'p',
                              'k',
                              'sc'
                            ],
                  'BODY' => '#line 424 "src/ops/set.ops"
    VTABLE_set_string_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[964]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 967,
                  'ARGS' => [
                              'p',
                              'kc',
                              'sc'
                            ],
                  'BODY' => '#line 424 "src/ops/set.ops"
    VTABLE_set_string_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 968,
                  'ARGS' => [
                              'p',
                              'k',
                              'p'
                            ],
                  'BODY' => '#line 428 "src/ops/set.ops"
    VTABLE_set_pmc_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[968]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 969,
                  'ARGS' => [
                              'p',
                              'kc',
                              'p'
                            ],
                  'BODY' => '#line 428 "src/ops/set.ops"
    VTABLE_set_pmc_keyed(interp, {{@1}}, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 970,
                  'ARGS' => [
                              'i',
                              'p',
                              'k'
                            ],
                  'BODY' => '#line 452 "src/ops/set.ops"
    {{@1}} = VTABLE_get_integer_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[970]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 971,
                  'ARGS' => [
                              'i',
                              'p',
                              'kc'
                            ],
                  'BODY' => '#line 452 "src/ops/set.ops"
    {{@1}} = VTABLE_get_integer_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 972,
                  'ARGS' => [
                              'n',
                              'p',
                              'k'
                            ],
                  'BODY' => '#line 456 "src/ops/set.ops"
    {{@1}} = VTABLE_get_number_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[972]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 973,
                  'ARGS' => [
                              'n',
                              'p',
                              'kc'
                            ],
                  'BODY' => '#line 456 "src/ops/set.ops"
    {{@1}} = VTABLE_get_number_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 974,
                  'ARGS' => [
                              's',
                              'p',
                              'k'
                            ],
                  'BODY' => '#line 460 "src/ops/set.ops"
    {{@1}} = VTABLE_get_string_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[974]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 975,
                  'ARGS' => [
                              's',
                              'p',
                              'kc'
                            ],
                  'BODY' => '#line 460 "src/ops/set.ops"
    {{@1}} = VTABLE_get_string_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 976,
                  'ARGS' => [
                              'p',
                              'p',
                              'k'
                            ],
                  'BODY' => '#line 464 "src/ops/set.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set',
                  'FLAGS' => $ops->[976]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 977,
                  'ARGS' => [
                              'p',
                              'p',
                              'kc'
                            ],
                  'BODY' => '#line 464 "src/ops/set.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'clone',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 978,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 474 "src/ops/set.ops"
    {{@1}} = VTABLE_clone(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'clone',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 979,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 484 "src/ops/set.ops"
    {{@1}} = VTABLE_clone_pmc(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'clone',
                  'FLAGS' => $ops->[979]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 980,
                  'ARGS' => [
                              'p',
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 484 "src/ops/set.ops"
    {{@1}} = VTABLE_clone_pmc(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'copy',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 981,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 494 "src/ops/set.ops"
    if (PMC_IS_NULL({{@1}})) {
        opcode_t *dest = {{^+3}};
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, dest,
                EXCEPTION_NULL_REG_ACCESS, "Null PMC in copy");
        {{=handler}};
    }
    else {
        PMC   * const clone = VTABLE_clone(interp, {{@2}});
        /* Preserve the metadata on the destination. */
        PMC   * const meta  = VTABLE_getprops(interp, {{@1}});

        /* avoid leaks and unreachable memory by destroying the destination PMC */
        Parrot_pmc_destroy(interp, {{@1}});

        /* the source PMC knows how to clone itself, but we must reuse the
         * destination header */
        memmove({{@1}}, clone, sizeof (PMC));

        /* don\'t let the clone\'s destruction destroy the destination\'s data */
        PObj_active_destroy_CLEAR(clone);
        PMC_data(clone)        = NULL;
        PMC_sync(clone)        = NULL;
        PMC_metadata(clone)    = NULL;

        /* Restore metadata. */
        if (!PMC_IS_NULL(meta)) {
            PMC * const iter = VTABLE_get_iter(interp, meta);
            while (VTABLE_get_bool(interp, iter)) {
                STRING * const key = VTABLE_shift_string(interp, iter);
                PMC * const value  = VTABLE_get_pmc_keyed_str(interp, meta, key);
                VTABLE_setprop(interp, {{@1}}, key, value);
            }
        }
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'null',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 982,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 563 "src/ops/set.ops"
    {{@1}} = NULL;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'null',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 983,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 567 "src/ops/set.ops"
    {{@1}} = 0;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'null',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 984,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 571 "src/ops/set.ops"
    {{@1}} = PMCNULL;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'null',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 985,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 575 "src/ops/set.ops"
    {{@1}} = 0;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'cleari',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 986,
                  'ARGS' => [],
                  'BODY' => '#line 597 "src/ops/set.ops"
    Parrot_clear_i(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'clearn',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 987,
                  'ARGS' => [],
                  'BODY' => '#line 601 "src/ops/set.ops"
    Parrot_clear_n(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'clears',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 988,
                  'ARGS' => [],
                  'BODY' => '#line 605 "src/ops/set.ops"
    Parrot_clear_s(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'clearp',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'inline',
                  'CODE' => 989,
                  'ARGS' => [],
                  'BODY' => '#line 609 "src/ops/set.ops"
    Parrot_clear_p(interp);

{{+=1}};',
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'ord',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 990,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 40 "src/ops/string.ops"
    {{@1}} = string_ord(interp, {{@2}}, 0);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'ord',
                  'FLAGS' => $ops->[990]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 991,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 40 "src/ops/string.ops"
    {{@1}} = string_ord(interp, {{@2}}, 0);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'ord',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 992,
                  'ARGS' => [
                              'i',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 44 "src/ops/string.ops"
    {{@1}} = string_ord(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'ord',
                  'FLAGS' => $ops->[992]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 993,
                  'ARGS' => [
                              'i',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 44 "src/ops/string.ops"
    {{@1}} = string_ord(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'ord',
                  'FLAGS' => $ops->[992]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 994,
                  'ARGS' => [
                              'i',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 44 "src/ops/string.ops"
    {{@1}} = string_ord(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'ord',
                  'FLAGS' => $ops->[992]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 995,
                  'ARGS' => [
                              'i',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 44 "src/ops/string.ops"
    {{@1}} = string_ord(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'chr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 996,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 55 "src/ops/string.ops"
    STRING * const s = string_chr(interp, (UINTVAL){{@2}});
    {{@1}} = s;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'chr',
                  'FLAGS' => $ops->[996]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 997,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 55 "src/ops/string.ops"
    STRING * const s = string_chr(interp, (UINTVAL){{@2}});
    {{@1}} = s;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'chopn',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 998,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 74 "src/ops/string.ops"
    Parrot_str_chopn_inplace(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'chopn',
                  'FLAGS' => $ops->[998]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 999,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 74 "src/ops/string.ops"
    Parrot_str_chopn_inplace(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'chopn',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1000,
                  'ARGS' => [
                              's',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 78 "src/ops/string.ops"
    {{@1}} = Parrot_str_chopn(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'chopn',
                  'FLAGS' => $ops->[1000]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1001,
                  'ARGS' => [
                              's',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 78 "src/ops/string.ops"
    {{@1}} = Parrot_str_chopn(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'chopn',
                  'FLAGS' => $ops->[1000]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1002,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 78 "src/ops/string.ops"
    {{@1}} = Parrot_str_chopn(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'chopn',
                  'FLAGS' => $ops->[1000]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1003,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 78 "src/ops/string.ops"
    {{@1}} = Parrot_str_chopn(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1004,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 101 "src/ops/string.ops"
    {{@1}} = Parrot_str_append(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => $ops->[1004]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1005,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 101 "src/ops/string.ops"
    {{@1}} = Parrot_str_append(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1006,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 105 "src/ops/string.ops"
    VTABLE_i_concatenate(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1007,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 109 "src/ops/string.ops"
    VTABLE_i_concatenate_str(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => $ops->[1007]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1008,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 109 "src/ops/string.ops"
    VTABLE_i_concatenate_str(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1009,
                  'ARGS' => [
                              's',
                              's',
                              's'
                            ],
                  'BODY' => '#line 113 "src/ops/string.ops"
    {{@1}} = Parrot_str_concat(interp, {{@2}}, {{@3}}, 1);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => $ops->[1009]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1010,
                  'ARGS' => [
                              's',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 113 "src/ops/string.ops"
    {{@1}} = Parrot_str_concat(interp, {{@2}}, {{@3}}, 1);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => $ops->[1009]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1011,
                  'ARGS' => [
                              's',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 113 "src/ops/string.ops"
    {{@1}} = Parrot_str_concat(interp, {{@2}}, {{@3}}, 1);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1012,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 117 "src/ops/string.ops"
    {{@1}} = VTABLE_concatenate_str(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => $ops->[1012]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1013,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 117 "src/ops/string.ops"
    {{@1}} = VTABLE_concatenate_str(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'concat',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1014,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 121 "src/ops/string.ops"
    {{@1}} = VTABLE_concatenate(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_GNEXT',
                  'NAME' => 'repeat',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1015,
                  'ARGS' => [
                              's',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 136 "src/ops/string.ops"
    if ({{@3}} < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_NEG_REPEAT,
                "Cannot repeat with negative arg");
        {{=handler}};
    }
    {{@1}} = Parrot_str_repeat(interp, {{@2}}, (UINTVAL){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_GNEXT',
                  'NAME' => 'repeat',
                  'FLAGS' => $ops->[1015]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1016,
                  'ARGS' => [
                              's',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 136 "src/ops/string.ops"
    if ({{@3}} < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_NEG_REPEAT,
                "Cannot repeat with negative arg");
        {{=handler}};
    }
    {{@1}} = Parrot_str_repeat(interp, {{@2}}, (UINTVAL){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'repeat',
                  'FLAGS' => $ops->[1015]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1017,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 136 "src/ops/string.ops"
    if ({{@3}} < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_NEG_REPEAT,
                "Cannot repeat with negative arg");
        {{=handler}};
    }
    {{@1}} = Parrot_str_repeat(interp, {{@2}}, (UINTVAL){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'repeat',
                  'FLAGS' => $ops->[1015]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1018,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 136 "src/ops/string.ops"
    if ({{@3}} < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_NEG_REPEAT,
                "Cannot repeat with negative arg");
        {{=handler}};
    }
    {{@1}} = Parrot_str_repeat(interp, {{@2}}, (UINTVAL){{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_GNEXT',
                  'NAME' => 'repeat',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1019,
                  'ARGS' => [
                              'p',
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 146 "src/ops/string.ops"
    if ({{@3}} < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_NEG_REPEAT,
                "Cannot repeat with negative arg");
        {{=handler}};
    }
    {{@1}} = VTABLE_repeat_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'repeat',
                  'FLAGS' => $ops->[1019]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1020,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 146 "src/ops/string.ops"
    if ({{@3}} < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_NEG_REPEAT,
                "Cannot repeat with negative arg");
        {{=handler}};
    }
    {{@1}} = VTABLE_repeat_int(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'repeat',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1021,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 156 "src/ops/string.ops"
    if (VTABLE_get_integer(interp, {{@3}}) < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_NEG_REPEAT,
                "Cannot repeat with negative arg");
        {{=handler}};
    }
    {{@1}} = VTABLE_repeat(interp, {{@2}}, {{@3}}, {{@1}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'repeat',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1022,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 175 "src/ops/string.ops"
    VTABLE_i_repeat_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'repeat',
                  'FLAGS' => $ops->[1022]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1023,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 175 "src/ops/string.ops"
    VTABLE_i_repeat_int(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'repeat',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1024,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 179 "src/ops/string.ops"
    VTABLE_i_repeat(interp, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'length',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1025,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 196 "src/ops/string.ops"
    {{@1}} = {{@2}} ? Parrot_str_byte_length(interp, {{@2}}) : 0;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'length',
                  'FLAGS' => $ops->[1025]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1026,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 196 "src/ops/string.ops"
    {{@1}} = {{@2}} ? Parrot_str_byte_length(interp, {{@2}}) : 0;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bytelength',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1027,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 200 "src/ops/string.ops"
    UINTVAL n;
    STRING * const s = {{@2}};
    if (!s)
        n = 0;
    else {
        n = s->bufused;
        PARROT_ASSERT(n == ENCODING_BYTES(interp, {{@2}}));
    }
    {{@1}} = n;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'bytelength',
                  'FLAGS' => $ops->[1027]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1028,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 200 "src/ops/string.ops"
    UINTVAL n;
    STRING * const s = {{@2}};
    if (!s)
        n = 0;
    else {
        n = s->bufused;
        PARROT_ASSERT(n == ENCODING_BYTES(interp, {{@2}}));
    }
    {{@1}} = n;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'pin',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1029,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 223 "src/ops/string.ops"
    Parrot_str_pin(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'unpin',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1030,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 235 "src/ops/string.ops"
    Parrot_str_unpin(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1031,
                  'ARGS' => [
                              's',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 271 "src/ops/string.ops"
    const INTVAL len = Parrot_str_byte_length(interp, {{@2}});
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, len, &{{@1}}, 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1031]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1032,
                  'ARGS' => [
                              's',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 271 "src/ops/string.ops"
    const INTVAL len = Parrot_str_byte_length(interp, {{@2}});
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, len, &{{@1}}, 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1031]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1033,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 271 "src/ops/string.ops"
    const INTVAL len = Parrot_str_byte_length(interp, {{@2}});
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, len, &{{@1}}, 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1031]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1034,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 271 "src/ops/string.ops"
    const INTVAL len = Parrot_str_byte_length(interp, {{@2}});
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, len, &{{@1}}, 0);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1035,
                  'ARGS' => [
                              's',
                              's',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 276 "src/ops/string.ops"
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, {{@4}}, &{{@1}}, 0);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1035]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1036,
                  'ARGS' => [
                              's',
                              'sc',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 276 "src/ops/string.ops"
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, {{@4}}, &{{@1}}, 0);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1035]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1037,
                  'ARGS' => [
                              's',
                              's',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 276 "src/ops/string.ops"
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, {{@4}}, &{{@1}}, 0);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1035]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1038,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 276 "src/ops/string.ops"
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, {{@4}}, &{{@1}}, 0);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1035]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1039,
                  'ARGS' => [
                              's',
                              's',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 276 "src/ops/string.ops"
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, {{@4}}, &{{@1}}, 0);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1035]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1040,
                  'ARGS' => [
                              's',
                              'sc',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 276 "src/ops/string.ops"
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, {{@4}}, &{{@1}}, 0);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1035]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1041,
                  'ARGS' => [
                              's',
                              's',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 276 "src/ops/string.ops"
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, {{@4}}, &{{@1}}, 0);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1035]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1042,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 276 "src/ops/string.ops"
    {{@1}} = Parrot_str_substr(interp, {{@2}}, {{@3}}, {{@4}}, &{{@1}}, 0);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1043,
                  'ARGS' => [
                              's',
                              's',
                              'i',
                              'i',
                              's'
                            ],
                  'BODY' => '#line 280 "src/ops/string.ops"
    {{@1}} = Parrot_str_replace(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}}, &{{@1}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1043]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1044,
                  'ARGS' => [
                              's',
                              's',
                              'ic',
                              'i',
                              's'
                            ],
                  'BODY' => '#line 280 "src/ops/string.ops"
    {{@1}} = Parrot_str_replace(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}}, &{{@1}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1043]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1045,
                  'ARGS' => [
                              's',
                              's',
                              'i',
                              'ic',
                              's'
                            ],
                  'BODY' => '#line 280 "src/ops/string.ops"
    {{@1}} = Parrot_str_replace(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}}, &{{@1}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1043]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1046,
                  'ARGS' => [
                              's',
                              's',
                              'ic',
                              'ic',
                              's'
                            ],
                  'BODY' => '#line 280 "src/ops/string.ops"
    {{@1}} = Parrot_str_replace(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}}, &{{@1}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1043]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1047,
                  'ARGS' => [
                              's',
                              's',
                              'i',
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 280 "src/ops/string.ops"
    {{@1}} = Parrot_str_replace(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}}, &{{@1}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1043]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1048,
                  'ARGS' => [
                              's',
                              's',
                              'ic',
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 280 "src/ops/string.ops"
    {{@1}} = Parrot_str_replace(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}}, &{{@1}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1043]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1049,
                  'ARGS' => [
                              's',
                              's',
                              'i',
                              'ic',
                              'sc'
                            ],
                  'BODY' => '#line 280 "src/ops/string.ops"
    {{@1}} = Parrot_str_replace(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}}, &{{@1}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1043]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1050,
                  'ARGS' => [
                              's',
                              's',
                              'ic',
                              'ic',
                              'sc'
                            ],
                  'BODY' => '#line 280 "src/ops/string.ops"
    {{@1}} = Parrot_str_replace(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}}, &{{@1}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1051,
                  'ARGS' => [
                              's',
                              'i',
                              'i',
                              's'
                            ],
                  'BODY' => '#line 284 "src/ops/string.ops"
    (void)Parrot_str_replace(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}}, NULL);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1051]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1052,
                  'ARGS' => [
                              's',
                              'ic',
                              'i',
                              's'
                            ],
                  'BODY' => '#line 284 "src/ops/string.ops"
    (void)Parrot_str_replace(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}}, NULL);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1051]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1053,
                  'ARGS' => [
                              's',
                              'i',
                              'ic',
                              's'
                            ],
                  'BODY' => '#line 284 "src/ops/string.ops"
    (void)Parrot_str_replace(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}}, NULL);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1051]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1054,
                  'ARGS' => [
                              's',
                              'ic',
                              'ic',
                              's'
                            ],
                  'BODY' => '#line 284 "src/ops/string.ops"
    (void)Parrot_str_replace(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}}, NULL);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1051]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1055,
                  'ARGS' => [
                              's',
                              'i',
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 284 "src/ops/string.ops"
    (void)Parrot_str_replace(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}}, NULL);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1051]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1056,
                  'ARGS' => [
                              's',
                              'ic',
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 284 "src/ops/string.ops"
    (void)Parrot_str_replace(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}}, NULL);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1051]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1057,
                  'ARGS' => [
                              's',
                              'i',
                              'ic',
                              'sc'
                            ],
                  'BODY' => '#line 284 "src/ops/string.ops"
    (void)Parrot_str_replace(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}}, NULL);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1051]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1058,
                  'ARGS' => [
                              's',
                              'ic',
                              'ic',
                              'sc'
                            ],
                  'BODY' => '#line 284 "src/ops/string.ops"
    (void)Parrot_str_replace(interp, {{@1}}, {{@2}}, {{@3}}, {{@4}}, NULL);

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1059,
                  'ARGS' => [
                              's',
                              'p',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 288 "src/ops/string.ops"
    {{@1}} = VTABLE_substr_str(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1059]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1060,
                  'ARGS' => [
                              's',
                              'p',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 288 "src/ops/string.ops"
    {{@1}} = VTABLE_substr_str(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1059]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1061,
                  'ARGS' => [
                              's',
                              'p',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 288 "src/ops/string.ops"
    {{@1}} = VTABLE_substr_str(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'substr',
                  'FLAGS' => $ops->[1059]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1062,
                  'ARGS' => [
                              's',
                              'p',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 288 "src/ops/string.ops"
    {{@1}} = VTABLE_substr_str(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1063,
                  'ARGS' => [
                              'i',
                              's',
                              's'
                            ],
                  'BODY' => '#line 308 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, 0) : -1;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => $ops->[1063]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1064,
                  'ARGS' => [
                              'i',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 308 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, 0) : -1;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => $ops->[1063]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1065,
                  'ARGS' => [
                              'i',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 308 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, 0) : -1;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => $ops->[1063]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1066,
                  'ARGS' => [
                              'i',
                              'sc',
                              'sc'
                            ],
                  'BODY' => '#line 308 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, 0) : -1;

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1067,
                  'ARGS' => [
                              'i',
                              's',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 312 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, {{@4}}) : -1;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => $ops->[1067]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1068,
                  'ARGS' => [
                              'i',
                              'sc',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 312 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, {{@4}}) : -1;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => $ops->[1067]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1069,
                  'ARGS' => [
                              'i',
                              's',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 312 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, {{@4}}) : -1;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => $ops->[1067]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1070,
                  'ARGS' => [
                              'i',
                              'sc',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 312 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, {{@4}}) : -1;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => $ops->[1067]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1071,
                  'ARGS' => [
                              'i',
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 312 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, {{@4}}) : -1;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => $ops->[1067]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1072,
                  'ARGS' => [
                              'i',
                              'sc',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 312 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, {{@4}}) : -1;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => $ops->[1067]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1073,
                  'ARGS' => [
                              'i',
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 312 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, {{@4}}) : -1;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'index',
                  'FLAGS' => $ops->[1067]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1074,
                  'ARGS' => [
                              'i',
                              'sc',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 312 "src/ops/string.ops"
    {{@1}} = ({{@2}} && {{@3}}) ? Parrot_str_find_index(interp, {{@2}}, {{@3}}, {{@4}}) : -1;

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sprintf',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1075,
                  'ARGS' => [
                              's',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 332 "src/ops/string.ops"
    {{@1}}=Parrot_psprintf(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sprintf',
                  'FLAGS' => $ops->[1075]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1076,
                  'ARGS' => [
                              's',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 332 "src/ops/string.ops"
    {{@1}}=Parrot_psprintf(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sprintf',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1077,
                  'ARGS' => [
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 336 "src/ops/string.ops"
    VTABLE_set_string_native(interp, {{@1}},
        Parrot_psprintf(interp, VTABLE_get_string(interp, {{@2}}), {{@3}}));

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'new',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1078,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 350 "src/ops/string.ops"
    {{@1}} = Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'new',
                  'FLAGS' => {
                               '' => undef,
                               'base_mem' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1079,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 354 "src/ops/string.ops"
    {{@1}} = Parrot_str_new_noinit(interp, enum_stringrep_one, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'new',
                  'FLAGS' => $ops->[1079]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1080,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 354 "src/ops/string.ops"
    {{@1}} = Parrot_str_new_noinit(interp, enum_stringrep_one, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_GNEXT',
                  'NAME' => 'stringinfo',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1081,
                  'ARGS' => [
                              'i',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 384 "src/ops/string.ops"
    if ({{@2}} == NULL)
        {{@1}} = 0;
    else {
        switch ({{@3}}) {
          case STRINGINFO_HEADER:
            {{@1}} = PTR2UINTVAL({{@2}});
            break;
          case STRINGINFO_STRSTART:
            {{@1}} = PTR2UINTVAL({{@2}}->strstart);
            break;
          case STRINGINFO_BUFLEN:
            {{@1}} = Buffer_buflen({{@2}});
            break;
          case STRINGINFO_FLAGS:
            {{@1}} = PObj_get_FLAGS({{@2}});
            break;
          case STRINGINFO_BUFUSED:
            {{@1}} = {{@2}}->bufused;
            break;
          case STRINGINFO_STRLEN:
            {{@1}} = {{@2}}->strlen;
            break;
          default:
            {
                opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION,
                    "stringinfo: unknown info type: %d", {{@3}});
                {{=handler}};
            }
        }
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_GNEXT',
                  'NAME' => 'stringinfo',
                  'FLAGS' => $ops->[1081]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1082,
                  'ARGS' => [
                              'i',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 384 "src/ops/string.ops"
    if ({{@2}} == NULL)
        {{@1}} = 0;
    else {
        switch ({{@3}}) {
          case STRINGINFO_HEADER:
            {{@1}} = PTR2UINTVAL({{@2}});
            break;
          case STRINGINFO_STRSTART:
            {{@1}} = PTR2UINTVAL({{@2}}->strstart);
            break;
          case STRINGINFO_BUFLEN:
            {{@1}} = Buffer_buflen({{@2}});
            break;
          case STRINGINFO_FLAGS:
            {{@1}} = PObj_get_FLAGS({{@2}});
            break;
          case STRINGINFO_BUFUSED:
            {{@1}} = {{@2}}->bufused;
            break;
          case STRINGINFO_STRLEN:
            {{@1}} = {{@2}}->strlen;
            break;
          default:
            {
                opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION,
                    "stringinfo: unknown info type: %d", {{@3}});
                {{=handler}};
            }
        }
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'stringinfo',
                  'FLAGS' => $ops->[1081]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1083,
                  'ARGS' => [
                              'i',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 384 "src/ops/string.ops"
    if ({{@2}} == NULL)
        {{@1}} = 0;
    else {
        switch ({{@3}}) {
          case STRINGINFO_HEADER:
            {{@1}} = PTR2UINTVAL({{@2}});
            break;
          case STRINGINFO_STRSTART:
            {{@1}} = PTR2UINTVAL({{@2}}->strstart);
            break;
          case STRINGINFO_BUFLEN:
            {{@1}} = Buffer_buflen({{@2}});
            break;
          case STRINGINFO_FLAGS:
            {{@1}} = PObj_get_FLAGS({{@2}});
            break;
          case STRINGINFO_BUFUSED:
            {{@1}} = {{@2}}->bufused;
            break;
          case STRINGINFO_STRLEN:
            {{@1}} = {{@2}}->strlen;
            break;
          default:
            {
                opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION,
                    "stringinfo: unknown info type: %d", {{@3}});
                {{=handler}};
            }
        }
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'stringinfo',
                  'FLAGS' => $ops->[1081]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1084,
                  'ARGS' => [
                              'i',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 384 "src/ops/string.ops"
    if ({{@2}} == NULL)
        {{@1}} = 0;
    else {
        switch ({{@3}}) {
          case STRINGINFO_HEADER:
            {{@1}} = PTR2UINTVAL({{@2}});
            break;
          case STRINGINFO_STRSTART:
            {{@1}} = PTR2UINTVAL({{@2}}->strstart);
            break;
          case STRINGINFO_BUFLEN:
            {{@1}} = Buffer_buflen({{@2}});
            break;
          case STRINGINFO_FLAGS:
            {{@1}} = PObj_get_FLAGS({{@2}});
            break;
          case STRINGINFO_BUFUSED:
            {{@1}} = {{@2}}->bufused;
            break;
          case STRINGINFO_STRLEN:
            {{@1}} = {{@2}}->strlen;
            break;
          default:
            {
                opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION,
                    "stringinfo: unknown info type: %d", {{@3}});
                {{=handler}};
            }
        }
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'upcase',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1085,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 429 "src/ops/string.ops"
    {{@1}} = Parrot_str_upcase(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'upcase',
                  'FLAGS' => $ops->[1085]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1086,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 429 "src/ops/string.ops"
    {{@1}} = Parrot_str_upcase(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'upcase',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1087,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 433 "src/ops/string.ops"
    Parrot_str_upcase_inplace(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'downcase',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1088,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 448 "src/ops/string.ops"
    {{@1}} = Parrot_str_downcase(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'downcase',
                  'FLAGS' => $ops->[1088]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1089,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 448 "src/ops/string.ops"
    {{@1}} = Parrot_str_downcase(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'downcase',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1090,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 452 "src/ops/string.ops"
    Parrot_str_downcase_inplace(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'titlecase',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1091,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 467 "src/ops/string.ops"
    {{@1}} = Parrot_str_titlecase(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'titlecase',
                  'FLAGS' => $ops->[1091]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1092,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 467 "src/ops/string.ops"
    {{@1}} = Parrot_str_titlecase(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'titlecase',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'io'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1093,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 471 "src/ops/string.ops"
    Parrot_str_titlecase_inplace(interp, {{@1}});

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'join',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1094,
                  'ARGS' => [
                              's',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 493 "src/ops/string.ops"
    {{@1}} = Parrot_str_join(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'join',
                  'FLAGS' => $ops->[1094]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1095,
                  'ARGS' => [
                              's',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 493 "src/ops/string.ops"
    {{@1}} = Parrot_str_join(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'split',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1096,
                  'ARGS' => [
                              'p',
                              's',
                              's'
                            ],
                  'BODY' => '#line 497 "src/ops/string.ops"
    {{@1}} = Parrot_str_split(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'split',
                  'FLAGS' => $ops->[1096]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1097,
                  'ARGS' => [
                              'p',
                              'sc',
                              's'
                            ],
                  'BODY' => '#line 497 "src/ops/string.ops"
    {{@1}} = Parrot_str_split(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'split',
                  'FLAGS' => $ops->[1096]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1098,
                  'ARGS' => [
                              'p',
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 497 "src/ops/string.ops"
    {{@1}} = Parrot_str_split(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'split',
                  'FLAGS' => $ops->[1096]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1099,
                  'ARGS' => [
                              'p',
                              'sc',
                              'sc'
                            ],
                  'BODY' => '#line 497 "src/ops/string.ops"
    {{@1}} = Parrot_str_split(interp, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'charset',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1100,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 528 "src/ops/string.ops"
    {{@1}} = Parrot_charset_number_of_str(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'charset',
                  'FLAGS' => $ops->[1100]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1101,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 528 "src/ops/string.ops"
    {{@1}} = Parrot_charset_number_of_str(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'charsetname',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1102,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 532 "src/ops/string.ops"
    STRING * const name = Parrot_charset_name(interp, {{@2}});
    {{@1}} = name ? Parrot_str_copy(interp, name) : NULL;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'charsetname',
                  'FLAGS' => $ops->[1102]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1103,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 532 "src/ops/string.ops"
    STRING * const name = Parrot_charset_name(interp, {{@2}});
    {{@1}} = name ? Parrot_str_copy(interp, name) : NULL;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'find_charset',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1104,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 537 "src/ops/string.ops"
    const INTVAL n = Parrot_charset_number(interp, {{@2}});
    if (n < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_INVALID_CHARTYPE,
                "charset \'%Ss\' not found", {{@2}});
        {{=handler}};
    }
    {{@1}} = n;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'find_charset',
                  'FLAGS' => $ops->[1104]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1105,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 537 "src/ops/string.ops"
    const INTVAL n = Parrot_charset_number(interp, {{@2}});
    if (n < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_INVALID_CHARTYPE,
                "charset \'%Ss\' not found", {{@2}});
        {{=handler}};
    }
    {{@1}} = n;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_charset',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1106,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 548 "src/ops/string.ops"
    {{@1}} = Parrot_str_change_charset(interp, {{@1}}, {{@2}}, NULL);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_charset',
                  'FLAGS' => $ops->[1106]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1107,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 548 "src/ops/string.ops"
    {{@1}} = Parrot_str_change_charset(interp, {{@1}}, {{@2}}, NULL);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_charset',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1108,
                  'ARGS' => [
                              's',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 552 "src/ops/string.ops"
    STRING *dest = Parrot_gc_new_string_header(interp, 0);
    {{@1}} = Parrot_str_change_charset(interp, {{@2}}, {{@3}}, dest);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_charset',
                  'FLAGS' => $ops->[1108]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1109,
                  'ARGS' => [
                              's',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 552 "src/ops/string.ops"
    STRING *dest = Parrot_gc_new_string_header(interp, 0);
    {{@1}} = Parrot_str_change_charset(interp, {{@2}}, {{@3}}, dest);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_charset',
                  'FLAGS' => $ops->[1108]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1110,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 552 "src/ops/string.ops"
    STRING *dest = Parrot_gc_new_string_header(interp, 0);
    {{@1}} = Parrot_str_change_charset(interp, {{@2}}, {{@3}}, dest);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_charset',
                  'FLAGS' => $ops->[1108]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1111,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 552 "src/ops/string.ops"
    STRING *dest = Parrot_gc_new_string_header(interp, 0);
    {{@1}} = Parrot_str_change_charset(interp, {{@2}}, {{@3}}, dest);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'encoding',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1112,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 584 "src/ops/string.ops"
    {{@1}} = Parrot_encoding_number_of_str(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'encoding',
                  'FLAGS' => $ops->[1112]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1113,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 584 "src/ops/string.ops"
    {{@1}} = Parrot_encoding_number_of_str(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'encodingname',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1114,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 588 "src/ops/string.ops"
    STRING * const name = Parrot_encoding_name(interp, {{@2}});
    {{@1}} = name ? Parrot_str_copy(interp, name) : NULL;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'encodingname',
                  'FLAGS' => $ops->[1114]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1115,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 588 "src/ops/string.ops"
    STRING * const name = Parrot_encoding_name(interp, {{@2}});
    {{@1}} = name ? Parrot_str_copy(interp, name) : NULL;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'find_encoding',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1116,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 593 "src/ops/string.ops"
    const INTVAL n = Parrot_encoding_number(interp, {{@2}});
    if (n < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_INVALID_ENCODING,
                "encoding \'%Ss\' not found", {{@2}});
        {{=handler}};
    }
    {{@1}} = n;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'find_encoding',
                  'FLAGS' => $ops->[1116]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1117,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 593 "src/ops/string.ops"
    const INTVAL n = Parrot_encoding_number(interp, {{@2}});
    if (n < 0) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_INVALID_ENCODING,
                "encoding \'%Ss\' not found", {{@2}});
        {{=handler}};
    }
    {{@1}} = n;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_encoding',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1118,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 604 "src/ops/string.ops"
    {{@1}} = Parrot_str_change_encoding(interp, {{@1}}, {{@2}}, NULL);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_encoding',
                  'FLAGS' => $ops->[1118]{'FLAGS'},
                  'ARGDIRS' => [
                                 'io',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1119,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 604 "src/ops/string.ops"
    {{@1}} = Parrot_str_change_encoding(interp, {{@1}}, {{@2}}, NULL);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_encoding',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1120,
                  'ARGS' => [
                              's',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 608 "src/ops/string.ops"
    STRING * const dest = Parrot_gc_new_string_header(interp, 0);
    {{@1}} = Parrot_str_change_encoding(interp, {{@2}}, {{@3}}, dest);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_encoding',
                  'FLAGS' => $ops->[1120]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1121,
                  'ARGS' => [
                              's',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 608 "src/ops/string.ops"
    STRING * const dest = Parrot_gc_new_string_header(interp, 0);
    {{@1}} = Parrot_str_change_encoding(interp, {{@2}}, {{@3}}, dest);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_encoding',
                  'FLAGS' => $ops->[1120]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1122,
                  'ARGS' => [
                              's',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 608 "src/ops/string.ops"
    STRING * const dest = Parrot_gc_new_string_header(interp, 0);
    {{@1}} = Parrot_str_change_encoding(interp, {{@2}}, {{@3}}, dest);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trans_encoding',
                  'FLAGS' => $ops->[1120]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1123,
                  'ARGS' => [
                              's',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 608 "src/ops/string.ops"
    STRING * const dest = Parrot_gc_new_string_header(interp, 0);
    {{@1}} = Parrot_str_change_encoding(interp, {{@2}}, {{@3}}, dest);

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'is_cclass',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1124,
                  'ARGS' => [
                              'i',
                              'i',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 621 "src/ops/string.ops"
    {{@1}} = Parrot_str_is_cclass(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'is_cclass',
                  'FLAGS' => $ops->[1124]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1125,
                  'ARGS' => [
                              'i',
                              'ic',
                              's',
                              'i'
                            ],
                  'BODY' => '#line 621 "src/ops/string.ops"
    {{@1}} = Parrot_str_is_cclass(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'is_cclass',
                  'FLAGS' => $ops->[1124]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1126,
                  'ARGS' => [
                              'i',
                              'i',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 621 "src/ops/string.ops"
    {{@1}} = Parrot_str_is_cclass(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'is_cclass',
                  'FLAGS' => $ops->[1124]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1127,
                  'ARGS' => [
                              'i',
                              'ic',
                              'sc',
                              'i'
                            ],
                  'BODY' => '#line 621 "src/ops/string.ops"
    {{@1}} = Parrot_str_is_cclass(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'is_cclass',
                  'FLAGS' => $ops->[1124]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1128,
                  'ARGS' => [
                              'i',
                              'i',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 621 "src/ops/string.ops"
    {{@1}} = Parrot_str_is_cclass(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'is_cclass',
                  'FLAGS' => $ops->[1124]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1129,
                  'ARGS' => [
                              'i',
                              'ic',
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 621 "src/ops/string.ops"
    {{@1}} = Parrot_str_is_cclass(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'is_cclass',
                  'FLAGS' => $ops->[1124]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1130,
                  'ARGS' => [
                              'i',
                              'i',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 621 "src/ops/string.ops"
    {{@1}} = Parrot_str_is_cclass(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'is_cclass',
                  'FLAGS' => $ops->[1124]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1131,
                  'ARGS' => [
                              'i',
                              'ic',
                              'sc',
                              'ic'
                            ],
                  'BODY' => '#line 621 "src/ops/string.ops"
    {{@1}} = Parrot_str_is_cclass(interp, {{@2}}, {{@3}}, {{@4}});

{{+=5}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1132,
                  'ARGS' => [
                              'i',
                              'i',
                              's',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1133,
                  'ARGS' => [
                              'i',
                              'ic',
                              's',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1134,
                  'ARGS' => [
                              'i',
                              'i',
                              'sc',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1135,
                  'ARGS' => [
                              'i',
                              'ic',
                              'sc',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1136,
                  'ARGS' => [
                              'i',
                              'i',
                              's',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1137,
                  'ARGS' => [
                              'i',
                              'ic',
                              's',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1138,
                  'ARGS' => [
                              'i',
                              'i',
                              'sc',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1139,
                  'ARGS' => [
                              'i',
                              'ic',
                              'sc',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1140,
                  'ARGS' => [
                              'i',
                              'i',
                              's',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1141,
                  'ARGS' => [
                              'i',
                              'ic',
                              's',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1142,
                  'ARGS' => [
                              'i',
                              'i',
                              'sc',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1143,
                  'ARGS' => [
                              'i',
                              'ic',
                              'sc',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1144,
                  'ARGS' => [
                              'i',
                              'i',
                              's',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1145,
                  'ARGS' => [
                              'i',
                              'ic',
                              's',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1146,
                  'ARGS' => [
                              'i',
                              'i',
                              'sc',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_cclass',
                  'FLAGS' => $ops->[1132]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1147,
                  'ARGS' => [
                              'i',
                              'ic',
                              'sc',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 635 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1148,
                  'ARGS' => [
                              'i',
                              'i',
                              's',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1149,
                  'ARGS' => [
                              'i',
                              'ic',
                              's',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1150,
                  'ARGS' => [
                              'i',
                              'i',
                              'sc',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1151,
                  'ARGS' => [
                              'i',
                              'ic',
                              'sc',
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1152,
                  'ARGS' => [
                              'i',
                              'i',
                              's',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1153,
                  'ARGS' => [
                              'i',
                              'ic',
                              's',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1154,
                  'ARGS' => [
                              'i',
                              'i',
                              'sc',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1155,
                  'ARGS' => [
                              'i',
                              'ic',
                              'sc',
                              'ic',
                              'i'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1156,
                  'ARGS' => [
                              'i',
                              'i',
                              's',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1157,
                  'ARGS' => [
                              'i',
                              'ic',
                              's',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1158,
                  'ARGS' => [
                              'i',
                              'i',
                              'sc',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1159,
                  'ARGS' => [
                              'i',
                              'ic',
                              'sc',
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1160,
                  'ARGS' => [
                              'i',
                              'i',
                              's',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1161,
                  'ARGS' => [
                              'i',
                              'ic',
                              's',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1162,
                  'ARGS' => [
                              'i',
                              'i',
                              'sc',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_not_cclass',
                  'FLAGS' => $ops->[1148]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1163,
                  'ARGS' => [
                              'i',
                              'ic',
                              'sc',
                              'ic',
                              'ic'
                            ],
                  'BODY' => '#line 649 "src/ops/string.ops"
    {{@1}} = Parrot_str_find_not_cclass(interp, {{@2}}, {{@3}}, {{@4}}, {{@5}});

{{+=6}};',
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'escape',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1164,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 665 "src/ops/string.ops"
    {{@1}} = Parrot_str_escape(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'compose',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1165,
                  'ARGS' => [
                              's',
                              's'
                            ],
                  'BODY' => '#line 669 "src/ops/string.ops"
    {{@1}} = Parrot_str_compose(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'compose',
                  'FLAGS' => $ops->[1165]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1166,
                  'ARGS' => [
                              's',
                              'sc'
                            ],
                  'BODY' => '#line 669 "src/ops/string.ops"
    {{@1}} = Parrot_str_compose(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'spawnw',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1167,
                  'ARGS' => [
                              'i',
                              's'
                            ],
                  'BODY' => '#line 42 "src/ops/sys.ops"
    {{@1}} = Parrot_Run_OS_Command(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'spawnw',
                  'FLAGS' => $ops->[1167]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1168,
                  'ARGS' => [
                              'i',
                              'sc'
                            ],
                  'BODY' => '#line 42 "src/ops/sys.ops"
    {{@1}} = Parrot_Run_OS_Command(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'spawnw',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1169,
                  'ARGS' => [
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 46 "src/ops/sys.ops"
    {{@1}} = Parrot_Run_OS_Command_Argv(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'err',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1170,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 67 "src/ops/sys.ops"
    {{@1}} = errno;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'err',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1171,
                  'ARGS' => [
                              's'
                            ],
                  'BODY' => '#line 71 "src/ops/sys.ops"
    const char * const tmp = strerror(errno);
    {{@1}} = string_make(interp, tmp, strlen(tmp), "ascii", 0);

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'err',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1172,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 76 "src/ops/sys.ops"
    const char * const tmp = strerror({{@2}});
    {{@1}} = string_make(interp, tmp, strlen(tmp), "ascii", 0);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'err',
                  'FLAGS' => $ops->[1172]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1173,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 76 "src/ops/sys.ops"
    const char * const tmp = strerror({{@2}});
    {{@1}} = string_make(interp, tmp, strlen(tmp), "ascii", 0);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'time',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1174,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 91 "src/ops/sys.ops"
    {{@1}} = Parrot_intval_time();

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'time',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1175,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 105 "src/ops/sys.ops"
    {{@1}} = Parrot_floatval_time();

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'gmtime',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1176,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 178 "src/ops/sys.ops"
    struct tm tm;
    const time_t t = (time_t) {{@2}};
    char resultbuffer[26];
    Parrot_gmtime_r(&t, &tm);
    Parrot_asctime_r(&tm, resultbuffer);
    {{@1}} = Parrot_str_new(interp, resultbuffer, 25);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'gmtime',
                  'FLAGS' => $ops->[1176]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1177,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 178 "src/ops/sys.ops"
    struct tm tm;
    const time_t t = (time_t) {{@2}};
    char resultbuffer[26];
    Parrot_gmtime_r(&t, &tm);
    Parrot_asctime_r(&tm, resultbuffer);
    {{@1}} = Parrot_str_new(interp, resultbuffer, 25);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'localtime',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1178,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 187 "src/ops/sys.ops"
    struct tm tm;
    const time_t t = (time_t) {{@2}};
    char resultbuffer[26];
    Parrot_localtime_r(&t, &tm);
    Parrot_asctime_r(&tm, resultbuffer);
    {{@1}} = Parrot_str_new(interp, resultbuffer, 25);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'localtime',
                  'FLAGS' => $ops->[1178]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1179,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 187 "src/ops/sys.ops"
    struct tm tm;
    const time_t t = (time_t) {{@2}};
    char resultbuffer[26];
    Parrot_localtime_r(&t, &tm);
    Parrot_asctime_r(&tm, resultbuffer);
    {{@1}} = Parrot_str_new(interp, resultbuffer, 25);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'decodetime',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1180,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 196 "src/ops/sys.ops"
    struct tm tm;
    const time_t t = (time_t) {{@2}};
    Parrot_gmtime_r(&t, &tm);
    {{@1}} = tm_to_array(interp, &tm);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'decodetime',
                  'FLAGS' => $ops->[1180]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1181,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 196 "src/ops/sys.ops"
    struct tm tm;
    const time_t t = (time_t) {{@2}};
    Parrot_gmtime_r(&t, &tm);
    {{@1}} = tm_to_array(interp, &tm);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'decodelocaltime',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1182,
                  'ARGS' => [
                              'p',
                              'i'
                            ],
                  'BODY' => '#line 203 "src/ops/sys.ops"
    struct tm tm;
    const time_t t = (time_t) {{@2}};
    Parrot_localtime_r(&t, &tm);
    {{@1}} = tm_to_array(interp, &tm);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'decodelocaltime',
                  'FLAGS' => $ops->[1182]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1183,
                  'ARGS' => [
                              'p',
                              'ic'
                            ],
                  'BODY' => '#line 203 "src/ops/sys.ops"
    struct tm tm;
    const time_t t = (time_t) {{@2}};
    Parrot_localtime_r(&t, &tm);
    {{@1}} = tm_to_array(interp, &tm);

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sysinfo',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1184,
                  'ARGS' => [
                              's',
                              'i'
                            ],
                  'BODY' => '#line 267 "src/ops/sys.ops"
    {{@1}} = sysinfo_s(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sysinfo',
                  'FLAGS' => $ops->[1184]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1185,
                  'ARGS' => [
                              's',
                              'ic'
                            ],
                  'BODY' => '#line 267 "src/ops/sys.ops"
    {{@1}} = sysinfo_s(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sysinfo',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1186,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 271 "src/ops/sys.ops"
    {{@1}} = sysinfo_i(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sysinfo',
                  'FLAGS' => $ops->[1186]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1187,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 271 "src/ops/sys.ops"
    {{@1}} = sysinfo_i(interp, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT|PARROT_JUMP_GNEXT',
                  'NAME' => 'sleep',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1188,
                  'ARGS' => [
                              'i'
                            ],
                  'BODY' => '#line 285 "src/ops/sys.ops"
    opcode_t *next = {{^+2}};
    if ({{@1}} < 0) {
        opcode_t * const handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NEG_SLEEP,
            "Cannot go back in time");
        {{=handler}};
    }
    next = (opcode_t *)Parrot_cx_schedule_sleep(interp, (FLOATVAL) {{@1}}, next);
    {{=next}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'sleep',
                  'FLAGS' => $ops->[1188]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1189,
                  'ARGS' => [
                              'ic'
                            ],
                  'BODY' => '#line 285 "src/ops/sys.ops"
    opcode_t *next = {{^+2}};
    if ({{@1}} < 0) {
        opcode_t * const handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NEG_SLEEP,
            "Cannot go back in time");
        {{=handler}};
    }
    next = (opcode_t *)Parrot_cx_schedule_sleep(interp, (FLOATVAL) {{@1}}, next);
    {{=next}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'sleep',
                  'FLAGS' => {
                               '' => undef,
                               'flow' => undef
                             },
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1190,
                  'ARGS' => [
                              'n'
                            ],
                  'BODY' => '#line 297 "src/ops/sys.ops"
    opcode_t *next = {{^+2}};
    if ({{@1}} < 0.0) {
        opcode_t * const handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NEG_SLEEP,
            "Cannot go back in time");
        {{=handler}};
    }
    next = (opcode_t *)Parrot_cx_schedule_sleep(interp, {{@1}}, next);
    {{=next}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'sleep',
                  'FLAGS' => $ops->[1190]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1191,
                  'ARGS' => [
                              'nc'
                            ],
                  'BODY' => '#line 297 "src/ops/sys.ops"
    opcode_t *next = {{^+2}};
    if ({{@1}} < 0.0) {
        opcode_t * const handler = Parrot_ex_throw_from_op_args(interp, next,
            EXCEPTION_NEG_SLEEP,
            "Cannot go back in time");
        {{=handler}};
    }
    next = (opcode_t *)Parrot_cx_schedule_sleep(interp, {{@1}}, next);
    {{=next}};
',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sizeof',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1192,
                  'ARGS' => [
                              'i',
                              'i'
                            ],
                  'BODY' => '#line 317 "src/ops/sys.ops"
    if ({{@2}} < enum_first_type || {{@2}} >= enum_last_type)
        {{@1}} = -1;
    else
        {{@1}} = data_types[{{@2}} - enum_first_type].size;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'sizeof',
                  'FLAGS' => $ops->[1192]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1193,
                  'ARGS' => [
                              'i',
                              'ic'
                            ],
                  'BODY' => '#line 317 "src/ops/sys.ops"
    if ({{@2}} < enum_first_type || {{@2}} >= enum_last_type)
        {{@1}} = -1;
    else
        {{@1}} = data_types[{{@2}} - enum_first_type].size;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'store_lex',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1194,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 40 "src/ops/var.ops"
    PMC     * const ctx      = CURRENT_CONTEXT(interp);
    STRING  * const lex_name = {{@1}};
    PMC     * const lex_pad  = Parrot_find_pad(interp, lex_name, ctx);

    if (PMC_IS_NULL(lex_pad)) {
        opcode_t * const handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_LEX_NOT_FOUND,
                "Lexical \'%Ss\' not found", lex_name);
        {{=handler}};
    }
    VTABLE_set_pmc_keyed_str(interp, lex_pad, lex_name, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'store_lex',
                  'FLAGS' => $ops->[1194]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1195,
                  'ARGS' => [
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 40 "src/ops/var.ops"
    PMC     * const ctx      = CURRENT_CONTEXT(interp);
    STRING  * const lex_name = {{@1}};
    PMC     * const lex_pad  = Parrot_find_pad(interp, lex_name, ctx);

    if (PMC_IS_NULL(lex_pad)) {
        opcode_t * const handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_LEX_NOT_FOUND,
                "Lexical \'%Ss\' not found", lex_name);
        {{=handler}};
    }
    VTABLE_set_pmc_keyed_str(interp, lex_pad, lex_name, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'store_dynamic_lex',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1196,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 65 "src/ops/var.ops"
    STRING  * const lex_name = {{@1}};
    PMC     * const ctx      =
        Parrot_pcc_get_caller_ctx(interp, CURRENT_CONTEXT(interp));
    PMC     * const lex_pad  =
        PMC_IS_NULL(ctx)
            ? PMCNULL
            : Parrot_find_dynamic_pad(interp, lex_name, ctx);

    if (PMC_IS_NULL(lex_pad)) {
        opcode_t * const handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_LEX_NOT_FOUND,
                "Lexical \'%Ss\' not found in dynamic scope", lex_name);
        {{=handler}};
    }
    VTABLE_set_pmc_keyed_str(interp, lex_pad, lex_name, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'store_dynamic_lex',
                  'FLAGS' => $ops->[1196]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1197,
                  'ARGS' => [
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 65 "src/ops/var.ops"
    STRING  * const lex_name = {{@1}};
    PMC     * const ctx      =
        Parrot_pcc_get_caller_ctx(interp, CURRENT_CONTEXT(interp));
    PMC     * const lex_pad  =
        PMC_IS_NULL(ctx)
            ? PMCNULL
            : Parrot_find_dynamic_pad(interp, lex_name, ctx);

    if (PMC_IS_NULL(lex_pad)) {
        opcode_t * const handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_LEX_NOT_FOUND,
                "Lexical \'%Ss\' not found in dynamic scope", lex_name);
        {{=handler}};
    }
    VTABLE_set_pmc_keyed_str(interp, lex_pad, lex_name, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'find_lex',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1198,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 94 "src/ops/var.ops"
    PMC     * const ctx      = CURRENT_CONTEXT(interp);
    STRING  * const lex_name = {{@2}};
    PMC     * const lex_pad  = Parrot_find_pad(interp, lex_name, ctx);

    PMC * const result =
        PMC_IS_NULL(lex_pad)
            ? NULL
            : VTABLE_get_pmc_keyed_str(interp, lex_pad, lex_name);
    if (!result) {
        opcode_t * const handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_LEX_NOT_FOUND,
                "Lexical \'%Ss\' not found", lex_name);
        {{=handler}};
    }
    {{@1}} = result;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS',
                  'NAME' => 'find_lex',
                  'FLAGS' => $ops->[1198]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1199,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 94 "src/ops/var.ops"
    PMC     * const ctx      = CURRENT_CONTEXT(interp);
    STRING  * const lex_name = {{@2}};
    PMC     * const lex_pad  = Parrot_find_pad(interp, lex_name, ctx);

    PMC * const result =
        PMC_IS_NULL(lex_pad)
            ? NULL
            : VTABLE_get_pmc_keyed_str(interp, lex_pad, lex_name);
    if (!result) {
        opcode_t * const handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_LEX_NOT_FOUND,
                "Lexical \'%Ss\' not found", lex_name);
        {{=handler}};
    }
    {{@1}} = result;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_dynamic_lex',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1200,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 123 "src/ops/var.ops"
    STRING  * const lex_name = {{@2}};
    PMC     * const ctx      =
        Parrot_pcc_get_caller_ctx(interp, CURRENT_CONTEXT(interp));
    PMC     * const lex_pad  =
        PMC_IS_NULL(ctx)
            ? PMCNULL
            : Parrot_find_dynamic_pad(interp, lex_name, ctx);
    PMC     * const result =
        PMC_IS_NULL(lex_pad)
            ? PMCNULL
            : VTABLE_get_pmc_keyed_str(interp, lex_pad, lex_name);
    {{@1}} = result;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_dynamic_lex',
                  'FLAGS' => $ops->[1200]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1201,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 123 "src/ops/var.ops"
    STRING  * const lex_name = {{@2}};
    PMC     * const ctx      =
        Parrot_pcc_get_caller_ctx(interp, CURRENT_CONTEXT(interp));
    PMC     * const lex_pad  =
        PMC_IS_NULL(ctx)
            ? PMCNULL
            : Parrot_find_dynamic_pad(interp, lex_name, ctx);
    PMC     * const result =
        PMC_IS_NULL(lex_pad)
            ? PMCNULL
            : VTABLE_get_pmc_keyed_str(interp, lex_pad, lex_name);
    {{@1}} = result;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_caller_lex',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1202,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 147 "src/ops/var.ops"
    STRING  * const lex_name = {{@2}};
    PMC     * ctx            = CURRENT_CONTEXT(interp);
    PMC     * result         = PMCNULL;

    for (ctx = Parrot_pcc_get_caller_ctx(interp, ctx);
            !PMC_IS_NULL(ctx) && PMC_IS_NULL(result);
            ctx = Parrot_pcc_get_caller_ctx(interp, ctx))
    {
        PMC * const lex_pad = Parrot_find_pad(interp, lex_name, ctx);
        if (!PMC_IS_NULL(lex_pad)) {
            result = VTABLE_get_pmc_keyed_str(interp, lex_pad, lex_name);
        }
        if (!result) result = PMCNULL;
    }
    {{@1}} = result;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'find_caller_lex',
                  'FLAGS' => $ops->[1202]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1203,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 147 "src/ops/var.ops"
    STRING  * const lex_name = {{@2}};
    PMC     * ctx            = CURRENT_CONTEXT(interp);
    PMC     * result         = PMCNULL;

    for (ctx = Parrot_pcc_get_caller_ctx(interp, ctx);
            !PMC_IS_NULL(ctx) && PMC_IS_NULL(result);
            ctx = Parrot_pcc_get_caller_ctx(interp, ctx))
    {
        PMC * const lex_pad = Parrot_find_pad(interp, lex_name, ctx);
        if (!PMC_IS_NULL(lex_pad)) {
            result = VTABLE_get_pmc_keyed_str(interp, lex_pad, lex_name);
        }
        if (!result) result = PMCNULL;
    }
    {{@1}} = result;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_namespace',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1204,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 186 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    {{@1}} = cur_ns;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_namespace',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1205,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 191 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    PMC * const ns     = Parrot_get_namespace_keyed(interp, cur_ns, {{@2}});

    {{@1}} = PMC_IS_NULL(ns) ? PMCNULL : ns;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_namespace',
                  'FLAGS' => $ops->[1205]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1206,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 191 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    PMC * const ns     = Parrot_get_namespace_keyed(interp, cur_ns, {{@2}});

    {{@1}} = PMC_IS_NULL(ns) ? PMCNULL : ns;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_hll_namespace',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1207,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 210 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    {{@1}} = hll_ns;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_hll_namespace',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1208,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 215 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    if (PMC_IS_NULL(hll_ns))
        {{@1}} = PMCNULL;
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, hll_ns, {{@2}});
        {{@1}} = ns;
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_hll_namespace',
                  'FLAGS' => $ops->[1208]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1209,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 215 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    if (PMC_IS_NULL(hll_ns))
        {{@1}} = PMCNULL;
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, hll_ns, {{@2}});
        {{@1}} = ns;
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_root_namespace',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1210,
                  'ARGS' => [
                              'p'
                            ],
                  'BODY' => '#line 236 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    {{@1}} = root_ns;

{{+=2}};',
                  'LABELS' => [
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_root_namespace',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1211,
                  'ARGS' => [
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 241 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    if (PMC_IS_NULL(root_ns))
        {{@1}} = PMCNULL;
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, root_ns, {{@2}});
        {{@1}} = ns;
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'get_root_namespace',
                  'FLAGS' => $ops->[1211]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1212,
                  'ARGS' => [
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 241 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    if (PMC_IS_NULL(root_ns))
        {{@1}} = PMCNULL;
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, root_ns, {{@2}});
        {{@1}} = ns;
    }

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1213,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 274 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    {{@1}} = Parrot_find_global_op(interp, cur_ns, {{@2}}, {{^+3}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_global',
                  'FLAGS' => $ops->[1213]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1214,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 274 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    {{@1}} = Parrot_find_global_op(interp, cur_ns, {{@2}}, {{^+3}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1215,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 279 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    if (PMC_IS_NULL(cur_ns)) {
        {{@1}} = PMCNULL;
    }
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, cur_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_global',
                  'FLAGS' => $ops->[1215]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1216,
                  'ARGS' => [
                              'p',
                              'pc',
                              's'
                            ],
                  'BODY' => '#line 279 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    if (PMC_IS_NULL(cur_ns)) {
        {{@1}} = PMCNULL;
    }
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, cur_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_global',
                  'FLAGS' => $ops->[1215]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1217,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 279 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    if (PMC_IS_NULL(cur_ns)) {
        {{@1}} = PMCNULL;
    }
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, cur_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_global',
                  'FLAGS' => $ops->[1215]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1218,
                  'ARGS' => [
                              'p',
                              'pc',
                              'sc'
                            ],
                  'BODY' => '#line 279 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    if (PMC_IS_NULL(cur_ns)) {
        {{@1}} = PMCNULL;
    }
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, cur_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_hll_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1219,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 306 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    {{@1}} = Parrot_find_global_op(interp, hll_ns, {{@2}}, {{^+3}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_hll_global',
                  'FLAGS' => $ops->[1219]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1220,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 306 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    {{@1}} = Parrot_find_global_op(interp, hll_ns, {{@2}}, {{^+3}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_hll_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1221,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 311 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    if (PMC_IS_NULL(hll_ns)) {
        {{@1}} = hll_ns;
    }
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, hll_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_hll_global',
                  'FLAGS' => $ops->[1221]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1222,
                  'ARGS' => [
                              'p',
                              'pc',
                              's'
                            ],
                  'BODY' => '#line 311 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    if (PMC_IS_NULL(hll_ns)) {
        {{@1}} = hll_ns;
    }
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, hll_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_hll_global',
                  'FLAGS' => $ops->[1221]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1223,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 311 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    if (PMC_IS_NULL(hll_ns)) {
        {{@1}} = hll_ns;
    }
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, hll_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_hll_global',
                  'FLAGS' => $ops->[1221]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1224,
                  'ARGS' => [
                              'p',
                              'pc',
                              'sc'
                            ],
                  'BODY' => '#line 311 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    if (PMC_IS_NULL(hll_ns)) {
        {{@1}} = hll_ns;
    }
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, hll_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_root_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1225,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 338 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    {{@1}} = Parrot_find_global_op(interp, root_ns, {{@2}}, {{^+3}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_root_global',
                  'FLAGS' => $ops->[1225]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1226,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 338 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    {{@1}} = Parrot_find_global_op(interp, root_ns, {{@2}}, {{^+3}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_root_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1227,
                  'ARGS' => [
                              'p',
                              'p',
                              's'
                            ],
                  'BODY' => '#line 343 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    if (PMC_IS_NULL(root_ns))
        {{@1}} = PMCNULL;
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, root_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_root_global',
                  'FLAGS' => $ops->[1227]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1228,
                  'ARGS' => [
                              'p',
                              'pc',
                              's'
                            ],
                  'BODY' => '#line 343 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    if (PMC_IS_NULL(root_ns))
        {{@1}} = PMCNULL;
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, root_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_root_global',
                  'FLAGS' => $ops->[1227]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1229,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 343 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    if (PMC_IS_NULL(root_ns))
        {{@1}} = PMCNULL;
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, root_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ENEXT',
                  'NAME' => 'get_root_global',
                  'FLAGS' => $ops->[1227]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1230,
                  'ARGS' => [
                              'p',
                              'pc',
                              'sc'
                            ],
                  'BODY' => '#line 343 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    if (PMC_IS_NULL(root_ns))
        {{@1}} = PMCNULL;
    else {
        PMC * const ns = Parrot_get_namespace_keyed(interp, root_ns, {{@2}});
        if (PMC_IS_NULL(ns))
            {{@1}} = PMCNULL;
        else
            {{@1}} = Parrot_find_global_op(interp, ns, {{@3}}, {{^+4}});
    }

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1231,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 378 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    Parrot_set_global(interp, cur_ns, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_global',
                  'FLAGS' => $ops->[1231]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1232,
                  'ARGS' => [
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 378 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    Parrot_set_global(interp, cur_ns, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1233,
                  'ARGS' => [
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 383 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    PMC * const ns     = Parrot_make_namespace_keyed(interp, cur_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_global',
                  'FLAGS' => $ops->[1233]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1234,
                  'ARGS' => [
                              'pc',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 383 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    PMC * const ns     = Parrot_make_namespace_keyed(interp, cur_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_global',
                  'FLAGS' => $ops->[1233]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1235,
                  'ARGS' => [
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 383 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    PMC * const ns     = Parrot_make_namespace_keyed(interp, cur_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_global',
                  'FLAGS' => $ops->[1233]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1236,
                  'ARGS' => [
                              'pc',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 383 "src/ops/var.ops"
    PMC * const cur_ns = Parrot_pcc_get_namespace(interp, CURRENT_CONTEXT(interp));
    PMC * const ns     = Parrot_make_namespace_keyed(interp, cur_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_hll_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1237,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 402 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    Parrot_set_global(interp, hll_ns, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_hll_global',
                  'FLAGS' => $ops->[1237]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1238,
                  'ARGS' => [
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 402 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    Parrot_set_global(interp, hll_ns, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_hll_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1239,
                  'ARGS' => [
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 407 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    PMC * const ns     = Parrot_make_namespace_keyed(interp, hll_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_hll_global',
                  'FLAGS' => $ops->[1239]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1240,
                  'ARGS' => [
                              'pc',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 407 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    PMC * const ns     = Parrot_make_namespace_keyed(interp, hll_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_hll_global',
                  'FLAGS' => $ops->[1239]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1241,
                  'ARGS' => [
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 407 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    PMC * const ns     = Parrot_make_namespace_keyed(interp, hll_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_hll_global',
                  'FLAGS' => $ops->[1239]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1242,
                  'ARGS' => [
                              'pc',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 407 "src/ops/var.ops"
    PMC * const hll_ns = Parrot_get_ctx_HLL_namespace(interp);
    PMC * const ns     = Parrot_make_namespace_keyed(interp, hll_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_root_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1243,
                  'ARGS' => [
                              's',
                              'p'
                            ],
                  'BODY' => '#line 426 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    Parrot_set_global(interp, root_ns, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_root_global',
                  'FLAGS' => $ops->[1243]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1244,
                  'ARGS' => [
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 426 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    Parrot_set_global(interp, root_ns, {{@1}}, {{@2}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_root_global',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1245,
                  'ARGS' => [
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 431 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    PMC * const ns      = Parrot_make_namespace_keyed(interp, root_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_root_global',
                  'FLAGS' => $ops->[1245]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1246,
                  'ARGS' => [
                              'pc',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 431 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    PMC * const ns      = Parrot_make_namespace_keyed(interp, root_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_root_global',
                  'FLAGS' => $ops->[1245]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1247,
                  'ARGS' => [
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 431 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    PMC * const ns      = Parrot_make_namespace_keyed(interp, root_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'set_root_global',
                  'FLAGS' => $ops->[1245]{'FLAGS'},
                  'ARGDIRS' => [
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1248,
                  'ARGS' => [
                              'pc',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 431 "src/ops/var.ops"
    PMC * const root_ns = interp->root_namespace;
    PMC * const ns      = Parrot_make_namespace_keyed(interp, root_ns, {{@1}});

    Parrot_set_global(interp, ns, {{@2}}, {{@3}});

{{+=4}};',
                  'LABELS' => [
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'find_name',
                  'FLAGS' => {},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1249,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 463 "src/ops/var.ops"
    if (!{{@2}}) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Tried to find null name");
        {{=handler}};
    }

    {{@1}} = Parrot_find_name_op(interp, {{@2}}, {{^+3}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'find_name',
                  'FLAGS' => $ops->[1249]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'function',
                  'CODE' => 1250,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 463 "src/ops/var.ops"
    if (!{{@2}}) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Tried to find null name");
        {{=handler}};
    }

    {{@1}} = Parrot_find_name_op(interp, {{@2}}, {{^+3}});

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'find_sub_not_null',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1251,
                  'ARGS' => [
                              'p',
                              's'
                            ],
                  'BODY' => '#line 476 "src/ops/var.ops"
    opcode_t *dest = {{^+3}};
    PMC *sub = Parrot_find_name_op(interp, {{@2}}, dest);

    if (PMC_IS_NULL(sub)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, dest,
                       EXCEPTION_GLOBAL_NOT_FOUND,
                       "Could not find non-existent sub %Ss", {{@2}});
        {{=handler}};
    }

    {{@1}} = sub;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'find_sub_not_null',
                  'FLAGS' => $ops->[1251]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1252,
                  'ARGS' => [
                              'p',
                              'sc'
                            ],
                  'BODY' => '#line 476 "src/ops/var.ops"
    opcode_t *dest = {{^+3}};
    PMC *sub = Parrot_find_name_op(interp, {{@2}}, dest);

    if (PMC_IS_NULL(sub)) {
        opcode_t *handler = Parrot_ex_throw_from_op_args(interp, dest,
                       EXCEPTION_GLOBAL_NOT_FOUND,
                       "Could not find non-existent sub %Ss", {{@2}});
        {{=handler}};
    }

    {{@1}} = sub;

{{+=3}};',
                  'LABELS' => [
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => '0',
                  'NAME' => 'trap',
                  'FLAGS' => {
                               '' => undef,
                               'deprecated' => undef
                             },
                  'ARGDIRS' => [],
                  'TYPE' => 'function',
                  'CODE' => 1253,
                  'ARGS' => [],
                  'BODY' => '#line 46 "src/ops/experimental.ops"
INTVAL unused = PARROT_WARNINGS_test(interp,PARROT_WARNINGS_DEPRECATED_FLAG) &&
  fprintf(stderr,"Warning: instruction \'trap\' is deprecated\\n");
#if defined(__GNUC__) && defined(i386)
    __asm__("int3");       /* opcode 0xcc */
#endif
#if defined(__GNUC__) && defined(PPC)
    __asm__("trap");       /* opcode tr 31, 0, 0 */
#endif

{{+=1}};',
                  'experimental' => 1,
                  'LABELS' => []
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1254,
                  'ARGS' => [
                              'p',
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 95 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1254]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1255,
                  'ARGS' => [
                              'p',
                              'pc',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 95 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1254]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1256,
                  'ARGS' => [
                              'p',
                              'p',
                              'pc',
                              'p'
                            ],
                  'BODY' => '#line 95 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1254]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1257,
                  'ARGS' => [
                              'p',
                              'pc',
                              'pc',
                              'p'
                            ],
                  'BODY' => '#line 95 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1254]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1258,
                  'ARGS' => [
                              'p',
                              'p',
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 95 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1254]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1259,
                  'ARGS' => [
                              'p',
                              'pc',
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 95 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1254]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1260,
                  'ARGS' => [
                              'p',
                              'p',
                              'pc',
                              'pc'
                            ],
                  'BODY' => '#line 95 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1254]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1261,
                  'ARGS' => [
                              'p',
                              'pc',
                              'pc',
                              'pc'
                            ],
                  'BODY' => '#line 95 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1262,
                  'ARGS' => [
                              'p',
                              'p',
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 115 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1262]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1263,
                  'ARGS' => [
                              'p',
                              'pc',
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 115 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1262]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1264,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic',
                              'p'
                            ],
                  'BODY' => '#line 115 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1262]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1265,
                  'ARGS' => [
                              'p',
                              'pc',
                              'ic',
                              'p'
                            ],
                  'BODY' => '#line 115 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1262]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1266,
                  'ARGS' => [
                              'p',
                              'p',
                              'i',
                              'pc'
                            ],
                  'BODY' => '#line 115 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1262]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1267,
                  'ARGS' => [
                              'p',
                              'pc',
                              'i',
                              'pc'
                            ],
                  'BODY' => '#line 115 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1262]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1268,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic',
                              'pc'
                            ],
                  'BODY' => '#line 115 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1262]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1269,
                  'ARGS' => [
                              'p',
                              'pc',
                              'ic',
                              'pc'
                            ],
                  'BODY' => '#line 115 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1270,
                  'ARGS' => [
                              'p',
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 135 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1270]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1271,
                  'ARGS' => [
                              'p',
                              'pc',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 135 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1270]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1272,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 135 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1270]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1273,
                  'ARGS' => [
                              'p',
                              'pc',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 135 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1270]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1274,
                  'ARGS' => [
                              'p',
                              'p',
                              's',
                              'pc'
                            ],
                  'BODY' => '#line 135 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1270]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1275,
                  'ARGS' => [
                              'p',
                              'pc',
                              's',
                              'pc'
                            ],
                  'BODY' => '#line 135 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1270]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1276,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc',
                              'pc'
                            ],
                  'BODY' => '#line 135 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'fetch',
                  'FLAGS' => $ops->[1270]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1277,
                  'ARGS' => [
                              'p',
                              'pc',
                              'sc',
                              'pc'
                            ],
                  'BODY' => '#line 135 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});
    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1278,
                  'ARGS' => [
                              'p',
                              'p',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 170 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});

        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
        VTABLE_set_pmc_keyed(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1278]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1279,
                  'ARGS' => [
                              'p',
                              'pc',
                              'p',
                              'p'
                            ],
                  'BODY' => '#line 170 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});

        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
        VTABLE_set_pmc_keyed(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1278]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1280,
                  'ARGS' => [
                              'p',
                              'p',
                              'pc',
                              'p'
                            ],
                  'BODY' => '#line 170 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});

        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
        VTABLE_set_pmc_keyed(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1278]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1281,
                  'ARGS' => [
                              'p',
                              'pc',
                              'pc',
                              'p'
                            ],
                  'BODY' => '#line 170 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});

        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
        VTABLE_set_pmc_keyed(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1278]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1282,
                  'ARGS' => [
                              'p',
                              'p',
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 170 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});

        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
        VTABLE_set_pmc_keyed(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1278]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1283,
                  'ARGS' => [
                              'p',
                              'pc',
                              'p',
                              'pc'
                            ],
                  'BODY' => '#line 170 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});

        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
        VTABLE_set_pmc_keyed(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1278]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1284,
                  'ARGS' => [
                              'p',
                              'p',
                              'pc',
                              'pc'
                            ],
                  'BODY' => '#line 170 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});

        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
        VTABLE_set_pmc_keyed(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1278]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1285,
                  'ARGS' => [
                              'p',
                              'pc',
                              'pc',
                              'pc'
                            ],
                  'BODY' => '#line 170 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});

        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }
        VTABLE_set_pmc_keyed(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1286,
                  'ARGS' => [
                              'p',
                              'p',
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 193 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_int(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1286]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1287,
                  'ARGS' => [
                              'p',
                              'pc',
                              'i',
                              'p'
                            ],
                  'BODY' => '#line 193 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_int(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1286]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1288,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic',
                              'p'
                            ],
                  'BODY' => '#line 193 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_int(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1286]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1289,
                  'ARGS' => [
                              'p',
                              'pc',
                              'ic',
                              'p'
                            ],
                  'BODY' => '#line 193 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_int(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1286]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1290,
                  'ARGS' => [
                              'p',
                              'p',
                              'i',
                              'pc'
                            ],
                  'BODY' => '#line 193 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_int(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1286]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1291,
                  'ARGS' => [
                              'p',
                              'pc',
                              'i',
                              'pc'
                            ],
                  'BODY' => '#line 193 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_int(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1286]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1292,
                  'ARGS' => [
                              'p',
                              'p',
                              'ic',
                              'pc'
                            ],
                  'BODY' => '#line 193 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_int(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1286]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1293,
                  'ARGS' => [
                              'p',
                              'pc',
                              'ic',
                              'pc'
                            ],
                  'BODY' => '#line 193 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_int(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_int(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => {
                               '' => undef,
                               'base_core' => undef
                             },
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1294,
                  'ARGS' => [
                              'p',
                              'p',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 216 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_str(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1294]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1295,
                  'ARGS' => [
                              'p',
                              'pc',
                              's',
                              'p'
                            ],
                  'BODY' => '#line 216 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_str(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1294]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1296,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 216 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_str(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1294]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1297,
                  'ARGS' => [
                              'p',
                              'pc',
                              'sc',
                              'p'
                            ],
                  'BODY' => '#line 216 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_str(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1294]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1298,
                  'ARGS' => [
                              'p',
                              'p',
                              's',
                              'pc'
                            ],
                  'BODY' => '#line 216 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_str(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1294]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1299,
                  'ARGS' => [
                              'p',
                              'pc',
                              's',
                              'pc'
                            ],
                  'BODY' => '#line 216 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_str(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1294]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1300,
                  'ARGS' => [
                              'p',
                              'p',
                              'sc',
                              'pc'
                            ],
                  'BODY' => '#line 216 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_str(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' ),
         bless( {
                  'JUMP' => 'PARROT_JUMP_ADDRESS|PARROT_JUMP_ENEXT',
                  'NAME' => 'vivify',
                  'FLAGS' => $ops->[1294]{'FLAGS'},
                  'ARGDIRS' => [
                                 'o',
                                 'i',
                                 'i',
                                 'i'
                               ],
                  'TYPE' => 'inline',
                  'CODE' => 1301,
                  'ARGS' => [
                              'p',
                              'pc',
                              'sc',
                              'pc'
                            ],
                  'BODY' => '#line 216 "src/ops/experimental.ops"
    {{@1}} = VTABLE_get_pmc_keyed_str(interp, {{@2}}, {{@3}});

    if (PMC_IS_NULL({{@1}})) {
        PMC * const classobj = Parrot_oo_get_class(interp, {{@4}});
        if (!PMC_IS_NULL(classobj))
            {{@1}} = VTABLE_instantiate(interp, classobj, PMCNULL);
        else {
            const INTVAL type = pmc_type_p(interp, {{@4}});
            if (type <= 0) {
                opcode_t *dest = Parrot_ex_throw_from_op_args(
                    interp, {{^+5}}, EXCEPTION_NO_CLASS,
                    "Class \'%Ss\' not found", VTABLE_get_repr(interp, {{@4}}));
                {{=dest}};
            }

            {{@1}} = pmc_new(interp, type);
        }

        VTABLE_set_pmc_keyed_str(interp, {{@2}}, {{@3}}, {{@1}});
    }

{{+=5}};',
                  'experimental' => 1,
                  'LABELS' => [
                                0,
                                0,
                                0,
                                0
                              ]
                }, 'Parrot::Op' )
       ];

1;
